Package: disgenet2r
Type: Package
Title: an R package to query, visualize, and expand DisGeNET data
Version: 0.99.3
Subversion: 20160727
Date: 2023-02-23
Author: IBI group
Maintainer: <support@disgenet.org>
Description: R package to query and expand DisGeNET data (www.disgenet.org), and to visualize the results within R framework. The disgenet2r package is designed to retrieve data from DisGeNET v6.0 (Jan, 2019).
License: MIT
Depends: R (>= 3.5.0)
LazyData: true
VignetteBuilder: knitr
Suggests: testthat, parallel, knitr
Imports: httr, VennDiagram, stringr, igraph, tidyr, tidyverse, purrr,
        ggplot2, reshape2, reshape, gtable, data.table,
        jsonlite
RoxygenNote: 7.2.1
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2023-02-23 16:54:05 UTC; janet

# disgenet2r

`disgenet2r` is an R package to query and expand DisGeNET data (www.disgenet.org), and to visualize the results within R framework.
The disgenet2r is designed to query data for DisGeNET v7.0 (May, 2020).      


# IMPORTANT: The disgenet2r package is no longer updated and will soon be replaced by [disgenetplus2r](https://gitlab.com/medbio/disgenetplus2r). 

A detailed documentation of the **disgenetplus2r** is available [here](https://medbio.gitlab.io/disgenetplus2r/).



## Package' Status

 * __Version__: 0.99.3
 * __Subversion__: `20230223`
 * __Authors__:  IBI group
 * __Maintainer__: <support@disgenet.org>


## COPYRIGHT

Copyright (C) 2023 IBI group.

disgenet2r is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

disgenet2r is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.

## How to cite disgenet2r:

Piñero, J., Ramírez-Anguita, J. M., Saüch-Pitarch, J., Ronzano, F., Centeno, E., Sanz, F., & Furlong, L. I. (2020). The DisGeNET knowledge platform for disease genomics: 2019 update. Nucleic acids research, 48(D1), D845-D855.

#' Retrieves the DisGeNET API key for a user
#'
#' Given the email and password, retrieves the users API Key
#' @param email the email of the user
#' @param password the password of the user to connect to DisGeNET
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to don't see
#' the warnings.
#' @return A string
#' @examples
#' disgenet_api_key <- get_disgenet_api_key( email = "user@gmail.com", password = "myspwd" )
#' @export get_disgenet_api_key



get_disgenet_api_key <- function( email, password,  verbose = FALSE, warnings = TRUE ) {
  url <- paste0(get_url_disgenet(), "auth/")
  r  <- httr::POST(url = url, httr::add_headers(.headers=c(
    `accept` =  '*/*' )), body = list(    `email` = email,    `password` = password  )  )

  if (r$status_code == 200) {
    api_key <- jsonlite::fromJSON(httr::content( r, as = "text", encoding = "UTF-8"), flatten = F)$token
    #Sys.setenv('DISGENET_API_KEY' = api_key)
  }else{
    print(httr::http_status(r))
    print(httr::content(r, "text"))
    api_key <-  NULL
  }
   return(api_key)
}

#' Retrieves mappings from different vocabularies associated to a disease, or list of diseases and generates an \code{DataGeNET.DGN}
#'
#' Given the disease identifier for one or multiple diseases retrieves the mappings to other vocabularies
#' from DisGeNET and creates an object of type \code{DataGeNET.DGN}.
#'
#' @param disease  A disease or a list of disease identifiers (CUIs, MeSH, OMIMs...)
#' @param vocabulary   The vocabulary of the disease identifier(s)
#' Select one of the available:  \code{UMLS} (UMLS), \code{OMIM} (OMIM),
#' \code{MESH} (MeSH), \code{DO} (Disease Ontology),
#' \code{NCI} (NCI thesaurus), \code{ORDO} (Orphanet),
#' \code{ICD9CM} (ICD9-CM) or \code{EFO} (EFO). Default \code{'UMLS'}.
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to don't see
#' the warnings.
#' @return An object of class \code{DataGeNET.DGN}
#' @examples
#' dis_res <- get_umls_from_vocabulary( "	D000130", vocabulary = "MESH"  )
#' @export get_umls_from_vocabulary



get_umls_from_vocabulary <- function(disease, vocabulary,  api_key=NULL,
                                     allowed_vocabularies = c("UMLS",
                                                              "OMIM",
                                                              "NCI",
                                                              "MESH",
                                                              "ICD9CM",
                                                              "ICD10",
                                                              "EFO",
                                                              "DO",
                                                              "HPO",
                                                              "ORDO", "NAME")) {

  if(is.null(api_key)){
    api_key = Sys.getenv('DISGENET_API_KEY')
    if(api_key == ""){
      stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
    }
  }
  if (!vocabulary %in% allowed_vocabularies) {
      stop(
        paste0(  vocabulary, " is an invalid vocabulary! Allowed vocabularies are: \n",
          paste(allowed_vocabularies, collapse = "\n")  )
      )
  }
  else{

    list_of_diseases <- paste(unique(disease),collapse=",")

    if (vocabulary!= "NAME"){
      url <-   paste0(get_url_disgenet(), "disease/mappings/", tolower(vocabulary),"/", list_of_diseases    )
    }
    else{
      disease <- gsub(" ","%20", disease)
      url <-   paste0(get_url_disgenet(), "disease/mappings/name/", disease    )
      #print(url)
    }

    r <- get_api_connection(url = url, api_key=api_key)
    if (r$status_code == 200) {
      result <-  jsonlite::fromJSON(httr::content(r, as = "text", encoding = "UTF-8"), flatten = F)
      return(result)
    } else{
      print(httr::http_status(r))
      print(httr::content(r, "text"))
    }
  }

}

# Query for given compound(s) and generates an \code{DataGeNET.RDF}
#
# Given a compound identifier in ChEMBL, it retrieves the related genes and diseases
# in DisGeNET. It creates an object of type \code{DataGeNET.RDF}.
#
# @param CHEMBL ID or vector of CHEMBL IDs
# @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
# on-time log from the function.
# @param warnings By default \code{TRUE}. Change it to \code{FALSE} to don't see
# the warnings.
# @return An object of class \code{DataGeNET.RDF}
# @examples
# com2dis <- compound2disease( compound = "CHEMBL281124" )
### @export compound2disease


compound2disease <- function( compound , verbose = FALSE, warnings = TRUE ) {

  # this function, gives you the disease profile from DisGeNET for an specific compound in ChEMBL
  message("Please, be aware of ChEMBL restrictions for their SPARQL endpoint \"https://www.ebi.ac.uk/rdf/what-are-limitations-sparql-endpoints\"");
  if( verbose ) {
    message( "Starting querying ChEMBL for the compound ID ", compound, " and cross its compounds with DisGeNET data." )
  }

  # endpoint
  endpoint <- "http://rdf.disgenet.org/sparql/"

  # oql is the query that let us look for diseases in DisGeNET
  oql <- "PREFIX cco: <http://rdf.ebi.ac.uk/terms/chembl#>
          SELECT DISTINCT
            ?molecule
            ?moleculeLabel
            ?uniprot
            ?gene
            str(?geneName) as ?name
            str(?geneSymbol) as ?geneSymbol
            ?disease
            str(?diseaseName) as ?diseaseName
            WHERE {
            # Query ChEMBL for activity data for the input molecule
              {
                SELECT
                  ?molecule
                  ?moleculeLabel
                  ?uniprot
                WHERE {
                  SERVICE <http://www.ebi.ac.uk/rdf/services/chembl/sparql> {
                    SELECT
                      ?activity
                      ?molecule
                      ?moleculeLabel
                      ?assay
                      ?target
                      ?targetcmpt
                      ?uniprot
                    WHERE{
                      ?activity a cco:Activity ;
                      cco:hasMolecule ?molecule ;
                      cco:hasAssay ?assay .
                      ?molecule rdfs:label ?moleculeLabel.
                      VALUES ?moleculeLabel {'CHEMBL_ID'} .
                      ?assay cco:hasTarget ?target .
                      ?target cco:hasTargetComponent ?targetcmpt .
                      ?targetcmpt cco:targetCmptXref ?uniprot .
                      ?uniprot a cco:UniprotRef
                    } # end chembl query
                  } # end of service
                } # end of select
              } # end of subquery
            ?gda sio:SIO_000628 ?gene,?disease .
            ?gene rdf:type ncit:C16612 ;
            dcterms:title ?geneName ;
            sio:SIO_010078 ?protein ;
            sio:SIO_000205 ?geneSymbolURI .
            ?geneSymbolURI dcterms:title ?geneSymbol .
            ?disease rdf:type ncit:C7057 ;
            dcterms:title ?diseaseName .
            ?protein skos:exactMatch ?uniprot .
            FILTER regex(?uniprot, 'http://purl.uniprot.org/uniprot/')
            }"

  # compound
  # http://rdf.ebi.ac.uk/resource/chembl/molecule/CHEMBL281124
  # input: query=single, namespace=CHEMBL. Parse input to check ID format.
  if (substr(compound,1,6) == 'CHEMBL' & !is.na(as.numeric(substring(compound,7)))) {
    oql <- stringr::str_replace(
      string = oql,
      pattern = "CHEMBL_ID",
      replacement = compound
    )
  } else {
    stop( "\nThe compound ID introduced: '", compound, "' is not a valid input.
          Remember that the valid input is: CHEMBLID (inputted as \"CHEMBL281124\").
          Please, check that the compound introduced is a valid CHEMBL ID and it is inputted in the correct format, and try again.\n\n" )
  }

  # SPARQL query
  # perform the SPARQL query to DisGeNET
  prefix <- c("sio","http://semanticscience.org/resource/","skos","http://www.w3.org/2004/02/skos/core#")
  message("Performing the query. This is a federated query with ChEMBL and may take some time, please wait...")
  res <- tryCatch({
    SPARQL(url=endpoint,query=oql,ns=prefix)
  },
  error = function(err){
    print(paste0("The query did not work. The error: "),err)
  })
  if (length(res$results) == 0){
    warning("The compound input with ID ", compound, " does not have drug target(s) encoded by disease genes in the DisGeNET database.")
  } else {
    result <- res$result
    result<- getFormattedDataFrame(result)
    result <- new( "DataGeNET.RDF",
                   input     = compound,
                   search    = "disease",
                   selection = "chembl",
                   mapping   = nrow(result),
                   qresult   = result
    )
    return( result )

  }
}

setMethod( "show",
           signature = "DataGeNET.DGN",
           definition = function( object ) {
             cat( "Object of class 'DataGeNET.DGN'\n" )
             cat( " . Search:     ", object@search, "\n" )
             cat( " . Type:       ", object@type, "\n" )
             cat( " . Database:    ", object@database, "\n" )
             cat( " . Score:       ", object@scoreRange, "\n" )
             if( object@search == "single" ) {
               cat( " . Term:       ", object@term, "\n" )
             } else {
               n <- length( object@term )
               cat( " . Term:      ", object@term[ 1 ], "...", object@term[ n ], "\n" )
             }
             if ( object@type == "gene-disease"){
               cat( " . Results: ", length( unique( object@qresult$diseaseid ) ), "\n" )
             } else if (  object@type == "variant-disease"){
               cat( " . Results: ", length( unique( object@qresult$diseaseid ) ), "\n" )
             }
             else if ( object@type == "disease-variant" ){
               cat( " . Results: ", length( unique( object@qresult$variantid)), "\n" )
             }
             else if( object@type == "disease-gene"){
               cat( " . Results: ", length( unique( object@qresult$geneid ) ), "\n" )
             }
             else if( object@type == "disease-disease-gene" | object@type == "disease-disease-variant"){
               cat( " . Results: ",  dim( unique( object@qresult ) )[1], "\n" )
             }
           }
)

setMethod( "show",
           signature = "DataGeNET.RDF",
           definition = function( object ) {
             cat( "Object of class 'DataGeNET.RDF'\n" )
             cat( " . Term:      ", object@input, "\n" )
             cat( " . Type:     ", object@search, "\n" )
             cat( " . Database:    ", object@database, "\n" )
             cat( " . Score:       ", object@scoreRange, "\n" )
             cat( " . Selection:  ", object@selection, "\n" )
             cat( " . Results:    ", object@mapping, "\n" )
           }
)

get_url_disgenet <- function() {
  url <- "https://www.disgenet.org/api/"
  # url <- "http://miranda/disgenetv6/api/"
  # url <- "http://localhost:5555/disgenetv6/api/"
  return( url )
}


get_api_connection <- function(url = url, api_key = NULL) {

  if(is.null(api_key)){
      api_key = Sys.getenv('DISGENET_API_KEY')
      if(api_key == ""){
        stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
      }
  }

  api_key <- paste0('Bearer ', api_key )
  res <- httr::GET(url = url,
                   httr::add_headers(.headers=c(  'accept' = "application/json",
                                                  'Authorization' = api_key)
                   ))

  return( res )
}

#' Plots the content of a \code{DataGeNET.DGN} object.
#' This functions allows to create a variety of plots for \code{DataGeNET.DGN} objects.
#'
#' @name plot
#' @rdname plot-methods
#' @aliases DataGeNET.DGN-methods
#'
#' @param x Object of class \code{DataGeNET.DGN}
#' @param y NOT USED
#' @param layout Function to design the location of the different nodes. By
#' default \code{layout.fruchterman.reingold} from \code{igraph} is used.
#' @param class Type of the drawn chart. By default it is \code{"disease"} but
#' it also can be \code{"gene"}, \code{"DiseaseClass"},
#' \code{"DiseaseDisease"}, \code{"Heatmap"}, \code{"DiseaseClassHeatmap"},
#' \code{"ProteinClass"}, \code{"ProteinClassHeatmap"}, \code{"Barplot"},
#' \code{"Venn"}.
#' @param verbose By default \code{FALSE}. If set to \code{TRUE} information
#' on the drawing process will be shown.
#' @param ... Passed to inner functions for different plots.
#' @return A plot for \code{DataGeNET.DGN}.
#' @examples
#' \dontrun{
#' #Being x an DataGeNET.DGN
#' qr <- plot(x) # Get number of unique diseases
#' }
#' @export plot

setMethod(
  f = "plot",
  signature = "DataGeNET.DGN",
  definition = function( x, y, ... ) {
    plot_datagenet_dis( x, ... )
  }
)


plot_datagenet_dis <- function( object, layout = igraph::layout.fruchterman.reingold, class = "disease", topLevel = FALSE, prop = 1, limit = 100, verbose = FALSE, cutoff = 0, ... ) {

  if( !class %in% c( "disease", "gene", "DiseaseClass", "DiseaseDisease", "Comorbidity", "Heatmap", "DiseaseClassHeatmap", "ProteinClass", "ProteinClassHeatmap", "Barplot", "Venn", "gda" ) ) {
    stop( "Invalid content of argument 'class'." )
  }

  if( object@type == "variant" | object@type == "variant-disease") {
    if (class == "disease" ){
      plot_variant_disease( search = object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop )
    }
    if (class == "gene" ){
      plot_variant_gene( search = object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop )
    }
    if (class == "gda" ){
      plot_variant_gda( search = object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop )
    }
    if (class == "Heatmap" ){
      plot_variant_disease_heatmap( type= object@type, search= object@search, input = object@qresult, cutoff = cutoff, verbose = verbose, limit = limit )
    }
    if (class == "DiseaseClass" ){
      plot_variant_disclass( search = object@search, type = object@type, input = object@qresult, nchars = nchars, layout = layout, verbose = verbose, prop = prop )
    }
    if (class == "DiseaseClassHeatmap" ){
      plot_dis_heatmapDiseaseClass( search = object@search, type = object@type, input = object@qresult,nchars=nchars, verbose = verbose)
    }
  }

  else if( object@type == "disease") {
    if(object@search == "dis-dis" & class == "disease"){
      plot_dis_comorbidity( search= object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose ,  prop = prop, limit = limit)
    }
    else if(object@search == "dis-dis" &  class == "DiseaseClass" ) {
      plot_dis_Class( search= object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, nchars = nchars,prop = prop )
    }
    else if(object@search == "dis-dis" &  class == "Comorbidity" ) {
      plot_dis_dis_associations( search= object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose ,  prop = prop, limit = limit,  database= object@database )
    }
    else if( class == "disease" ) {
      plot_dis_disease( search = object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop , limit = limit)
    }  else if( class == "DiseaseDisease" ) {
      plot_dis_comorbidity( search= object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop, limit = limit )
    }  else if( class == "Heatmap" ) {
      plot_dis_heatmapDisease( type= object@type, search= object@search, input = object@qresult, cutoff = cutoff, nchars = nchars, verbose = verbose, limit = limit )
    } else if( class == "ProteinClass" ) {
      plot_dis_Panther(  search= object@search, input = object@qresult, layout = layout, verbose = verbose )
    }else if( class == "ProteinClassHeatmap" ) {
      plot_dis_heatmapPanther(  type= object@type, search= object@search, input = object@qresult,nchars= nchars, verbose = verbose )
    } else if( class == "Barplot" ) {
      plot_dis_barplot(  type= object@type, search= object@search, input = object@qresult, verbose = verbose, limit = limit )
    }  else if( class == "Venn" ) {
      plot_dis_venn(  type= object@type, search= object@search, input = object@qresult, verbose = verbose, database= object@database )
    }
    else{
      stop( "Invalid content of argument 'class' for type = 'disease'." )
    }
  }

  else if( object@type  == "gene" ) {
    if( class == "disease" ) {
      plot_dis_disease( search = object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop , limit = limit)
    } else if( class == "DiseaseClass" ) {
      plot_dis_Class( search= object@search, type = object@type, input = object@qresult, layout = layout, nchars= nchars, verbose = verbose, prop = prop )
    } else if( class == "Heatmap" ) {
      plot_dis_heatmapDisease( type= object@type, search= object@search, input = object@qresult, cutoff = cutoff, nchars= nchars, verbose = verbose, limit = limit )
    }  else if( class == "DiseaseClassHeatmap" ) {
      plot_dis_heatmapDiseaseClass( type= object@type, search= object@search, input = object@qresult, nchars= nchars, verbose = verbose, limit = limit)
    }  else{
      stop( "Invalid content of argument 'class' for type = 'gene'." )
    }
  }
  else{
    stop( "Invalid content of argument 'type'." )
  }
}


plot_variant_disease<- function( input, type, layout, prop, search, verbose ) {

  input <- unique(input[c("c0.score", "c0.diseaseId", "c2.name", "c0.snpId")])
  l <- length(unique(input$c0.snpId))
  input$score <- as.numeric(as.character(input$c0.score))
  input <-  aggregate(score ~ c0.diseaseId + c2.name + c0.snpId, input , max)
  if(l > 1 ) {
    ttl <- "Variant-Disease Network"
  }else if ( l == 1 ){
    ttl <- paste0( "Diseases associated to ", input$c0.snpId[ 1 ] )
  }

  edges <- data.frame( input[ , "c2.name"], input[ , "c0.snpId"] )
  netw  <- igraph::graph.data.frame( edges, directed = FALSE )
  netw  <- igraph::simplify( netw )
  lay   <- layout( netw )
  diseases <- unique( input$c2.name )
  igraph::plot.igraph( netw,
                       vertex.frame.color  = "white",
                       layout              = lay,
                       vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "royalblue2", "goldenrod3" ),
                       vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                       vertex.frame.color  = 'blue', #the color of the border of the dots
                       vertex.label.color  = 'black',#the color of the name labels
                       vertex.label.font   = 0,      #the font of the name labels
                       vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                       edge.color          = "darkgrey",
                       edge.width          = 1 + ( prop * input$score ),
                       edge.arrow.size     = 0.5,
                       vertex.size         = 15,
                       vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                       main                = ttl
  )
}

plot_variant_gene<- function( input, type, layout, prop, search, verbose ) {

  input <- unique(input[c("c0.snpId", "c1.DSI", "c1.DPI" , "c1.symbol")])
  l <- length(unique(input$c0.snpId))
  #input$score <- as.numeric(as.character(input$score))
  #input[input$c0.score < 0.01,"c0.score" ] <- 0.09
  #input <-  aggregate(score ~ geneId + geneSymbol  + snp, input , max)
  tt <- as.data.frame( transDiseaseClass ( input ) )
  row.names(tt) <- NULL
  tt[,"V4"] <- gsub("null", NA, tt[ ,"V4"] )
  nd <- length(unique(subset(tt, is.na(V4))$c0.snpId))
  input <- subset(tt, !is.na(V4))

  if( l > 1 ) {
    ttl <- "Variant-Gene Network"
  }else if ( l == 1 ){
    ttl <- paste0( "Genes associated to ", input$c0.snpId[ 1 ] )
  }
  if (nd > 0){
    show( paste0("warning: ", nd , " variant(s) not shown in the plot" ))
  }
  colnames(input)<- c("c0.snpId", "c1.DSI", "c1.DPI", "V4")
  edges <- data.frame( input[ , "V4"], input[ , "c0.snpId"] )
  netw  <- igraph::graph.data.frame( edges, directed = FALSE )
  netw  <- igraph::simplify( netw )
  lay   <- layout( netw )
  genes <- unique( input$V4 )
  igraph::plot.igraph( netw,
                       vertex.frame.color  = "white",
                       layout              = lay,
                       vertex.color        = ifelse( igraph::V( netw )$name %in% genes, "#ff349a" , "goldenrod3"),
                       vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                       vertex.frame.color  = 'blue', #the color of the border of the dots
                       vertex.label.color  = 'black',#the color of the name labels
                       vertex.label.font   = 0,      #the font of the name labels
                       vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                       edge.color          = "darkgrey",
                       edge.width          = 1 + ( prop  ),
                       edge.arrow.size     = 0.5,
                       vertex.size         = 15,
                       vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                       main                = ttl
  )
}

plot_variant_gda<- function( input, type, layout, prop, search, verbose ) {

  input <- unique(input[c("c0.score", "c0.snpId",  "c2.name", "c1.symbol")])
  input <- data.frame(lapply(input, as.character), stringsAsFactors=FALSE)
  l <- length(unique(input$c0.snpId))

  #input[input$c0.score < 0.01,"c0.score" ] <- 0.09
  tt <- as.data.frame( transDiseaseClass ( input ) )
  row.names(tt) <- NULL
  tt[,"V4"] <- gsub("null", NA, tt[ ,"V4"] )
  nd <- length(unique(subset(tt, is.na(V4))$c0.snpId))
  #input <- subset(tt, !is.na(V4))
  colnames(tt) <- colnames(input)
  input <-tt
  input$c0.score <- as.numeric(as.character(input$c0.score))
  aa <-  aggregate(c0.score ~  c1.symbol +c0.snpId , input , max)
  bb <-  aggregate(c0.score ~ c2.name +c0.snpId , input , max)
  cc <- unique(input[c("c2.name", "c1.symbol",  "c0.score")])
  colnames(aa) <- c("A1", "A2", "score")
  colnames(bb) <- c("A1", "A2", "score")
  colnames(cc) <- c("A1", "A2", "score")

  tt <- rbind(aa,bb)
  tt <- rbind(tt,cc)

  if( l > 1 ) {
    ttl <- "Variant-Gene-Disease Network"
  }else if ( l == 1 ){
    ttl <- paste0( "Variant-Gene-Disease Network for ", input$snp[ 1 ] )
  }
  tt <- subset( tt, !is.na(A1) & !is.na(A2))
  edges <- data.frame( tt[ ,1], tt[ , 2] )
  netw  <- igraph::graph.data.frame( edges, directed = FALSE )
  netw  <- igraph::simplify( netw )
  lay   <- layout( netw )
  genes <- unique( input$c1.symbol )
  diseases <- unique( input$c2.name )
  variants <- unique( input$c0.snpId )

  igraph::plot.igraph( netw,
                       vertex.frame.color  = "white",
                       layout              = lay,
                       vertex.color        = ifelse( igraph::V( netw )$name %in% genes, "#ff349a" , ifelse(igraph::V( netw )$name %in% diseases, "royalblue2", "goldenrod3")),
                       vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                       vertex.frame.color  = 'blue', #the color of the border of the dots
                       vertex.label.color  = 'black',#the color of the name labels
                       vertex.label.font   = 0,      #the font of the name labels
                       vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                       edge.color          = "darkgrey",
                       edge.width          = 1 + ( prop * tt$score ),
                       edge.arrow.size     = 0.5,
                       vertex.size         = 15,
                       vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                       main                = ttl
  )
}


plot_variant_disclass <- function( input, type, layout, nchars, prop, search, verbose ) {
  results <- unique(input[c("c0.score", "c0.snpId", "c2.name", "c2.diseaseClassName")])
  l <- length(unique(results$c0.snpId))
  #input$score <- as.numeric(as.character(input$score))
  if(l > 1 ) {
    stop( "Chart not possible for list. Use instead the plot function with DiseaseClassHeatmap class argument" )
  }

  tt <- as.data.frame( transDiseaseClass ( results ) )
  rownames(tt) <- NULL
  tt[,4] <- gsub (" ; ", ";", tt[,4] )
  tt[,4] <- gsub ( "null", NA, tt[,4] )
  tt[,4] <- gsub ( "Wounds and Injuries", NA, tt[,4] )
  tt[,4] <- gsub ( "Animal Diseases", NA, tt[,4] )

  nd <- length(unique(subset(tt, is.na(V4))$c2.name))
  tt <- subset(tt, !is.na(V4))
  for( i in 1:nrow(tt)){
    if(nchar(as.character(tt$V4[i])) > nchars){
      rename <- substr(tt$V4[i], 1, nchars)
      tt$V4[i] <- paste0(rename, "...")
    }
  }


  results <- tt

  freq <- as.data.frame ( table ( results$V4 ) )
  freq$perc <- ( freq$Freq / sum( freq$Freq ) ) * 100

  rw <- matrix ( c( as.character( results[ 1, "c0.snpId" ] ), 10, 10), ncol=3 )
  colnames( rw ) <- colnames( freq )
  freq <- rbind( freq, rw )

  sizes <- as.numeric( freq[ , 3 ] )
  names( sizes ) <- freq[ , 1 ]

  #plot
  edges <- data.frame( results[, "c0.snpId" ], results[ , "V4" ] )
  netw  <- igraph::graph.data.frame( edges, directed = FALSE )
  netw  <- igraph::simplify( netw )
  lay   <- layout( netw )

  if( verbose ) {
    message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
  }

  diseases <- unique( results$V4 )
  ttl <- paste0("Disease Classes associated to ", results$c0.snpId[1] )
  if (nd > 0){
    show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
  }
  igraph::plot.igraph( netw,
                       vertex.frame.color  = "white",
                       layout              = lay,
                       vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "royalblue2", "goldenrod3" ),
                       vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                       vertex.frame.color  = 'blue', #the color of the border of the dots
                       vertex.label.color  = 'black',#the color of the name labels
                       vertex.label.font   = 0,      #the font of the name labels
                       vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                       edge.color          = "darkgrey",
                       edge.arrow.size     = 0.5,
                       edge.width          = 0.5,
                       vertex.size         = as.numeric(sizes[ igraph::V( netw )$name ])*prop,
                       vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                       main                = ttl
  )
}


plot_dis_disease <- function( input, type, layout, prop, search, verbose ,  limit) {

  if( search == "dis-dis" ) {
    #     print(limit)
    #     print(dim(input)[1])
    #     if (dim(input)[1]> limit){
    #       input <- input[c(1:limit),]
    #     }
    #     edges <- data.frame( input[ , 2 ], input[ , 4 ] )
    #     netw  <- igraph::graph.data.frame( edges, directed = FALSE )
    #     netw  <- igraph::simplify( netw )
    #     lay   <- layout( netw )
    #
    #     genNum <- input[ , c( 4, 6 ) ]
    #
    #     rw <- matrix ( c ( as.character ( input [ 1, 2 ] ), 10 ), ncol = 2 )
    #     colnames( rw ) <- colnames ( genNum )
    #     genNum <- rbind ( genNum, rw )
    #
    #     sizes <- as.numeric(genNum[ , 2 ])
    #     names( sizes ) <- genNum[ , 1 ]
    #
    #     if( verbose ) {
    #       message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
    #     }
    #     #diseases <- unique( input$c1.name )
    #     #ttl <- paste0( "Diseases associated to ", input$c1.name[ 1 ] )
    #     ttl <- "Disease-Disease Network"
    #     igraph::plot.igraph( netw,
    #                          vertex.frame.color = "white",
    #                          layout              = lay,
    #                          vertex.color        = ifelse ( igraph::V( netw )$name %in% diseases, "royalblue2", "#9bcdff" ),
    #                          vertex.label.dist   = 0,      #puts the name labels slightly off the dots
    #                          vertex.frame.color  = 'blue', #the color of the border of the dots
    #                          vertex.label.color  = 'black',#the color of the name labels
    #                          vertex.label.font   = 0,      #the font of the name labels
    #                          vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
    #                          edge.color          = "darkgrey",
    #                          edge.width          = 1 + ( prop * input$c0.score ),
    #                          edge.arrow.size     = 0.5,
    #                          vertex.size         = as.numeric( sizes[ igraph::V( netw )$name ] )*prop,
    #                          vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
    #                          main                = ttl
    #     )
    #
    #

  }else {

    if(search=="unify"){
      edges <- data.frame( input[ , 12 ], input[ , 6 ] )
      diseases <- unique( input$diseaseIdentifier )
    }else{
      edges <- data.frame( input[ , 2 ], input[ , 6 ] )
      diseases <- unique( input$c1.name )
    }

    netw  <- igraph::graph.data.frame( edges, directed = FALSE )
    netw  <- igraph::simplify( netw )
    lay   <- layout( netw )

    if( verbose ) {
      message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
    }


    if( search == "list" ) {
      ttl <- "Gene-Disease Network"
    }else if ( search == "single" ){
      if ( type == "gene"){
        ttl <- paste0( "Diseases associated to ", input$c2.name[ 1 ]  )
      }else if ( type == "disease"){
        ttl <- paste0( "Genes associated to ", input$c1.name[ 1 ] )
      }
    }
    else if( search == "unify" ) {
      ttl <- paste0( "Genes associated to ", input$diseaseIdentifier[ 1 ] )
    }

    igraph::plot.igraph( netw,
                         vertex.frame.color  = "white",
                         layout              = lay,
                         vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "royalblue2", "#ff349a" ),
                         vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                         vertex.frame.color  = 'blue', #the color of the border of the dots
                         vertex.label.color  = 'black',#the color of the name labels
                         vertex.label.font   = 0,      #the font of the name labels
                         vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                         edge.color          = "darkgrey",
                         edge.width          = 1 + ( prop * input$c0.score ),
                         edge.arrow.size     = 0.5,
                         vertex.size         = 15,
                         vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                         main                = ttl
    )
  }
}

plot_dis_Class <- function ( input, type, layout, search, nchars, verbose, prop ) {

  if( search == "list" ) {
    stop( "Chart not possible for list. Use instead the plot function with DiseaseClassHeatmap class argument" )
  }
  else if( search == "dis-dis" ) {
    #stop( "Chart not possible for disease-disease assoc query" )
    if (length(unique(input[, 1])) == 1){

      input[,"diseaseClass2"] <- gsub ( "null", NA, input[,"diseaseClass2"] )
      input[,"diseaseClass2"] <- gsub ( "Wounds and Injuries", NA, input[,"diseaseClass2"]  )
      input[,"diseaseClass2"]  <- gsub ( "Animal Diseases", NA, input[,"diseaseClass2"] )
      nd <- length(unique(subset(input, is.na(diseaseClass2))$Disease2) )
      input <- subset(input, !is.na(diseaseClass2) )
      # this means there is a central disease
      results <- input [, c (1, 4,5,6,8,9 )]

      tt <- as.data.frame( transDiseaseClass ( results ) )
      row.names(tt) <- NULL
      tt$V4 <- as.character(tt$V4)
      tt <- unique(tt[c("Disease2", "V4")])

      for( i in 1:nrow(tt)){
        if(nchar(as.character(tt$V4[i])) > nchars){
          rename <- substr(tt$V4[i], 1, nchars)
          tt$V4[i] <- paste0(rename, "...")
        }
      }
      if (nd > 0){
        show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
      }

      results <- merge(results[, c(2,3,5,6)], tt, by.x = "Disease2")
      freq <- as.data.frame ( table ( results$V4 ) )
      freq$perc <- ( freq$Freq / sum( freq$Freq ) ) * 100
      rw <- matrix ( c( as.character( input[ 1,2 ] ),10, 10), ncol=3 )
      colnames( rw ) <- colnames( freq )
      freq <- rbind( freq, rw )

      sizes <- as.numeric( freq[ , 3 ] )
      names( sizes ) <- freq[ , 1 ]

      results <- merge( input, results[c(1,5)], by="Disease2")

      #plot
      edges <- data.frame( results[ , "NameDisease1" ], results[ , "V4" ] )
      netw  <- igraph::graph.data.frame( edges, directed = FALSE )
      netw  <- igraph::simplify( netw )
      lay   <- layout( netw )

      if( verbose ) {
        message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
      }

      diseases <- unique( results$V4 )
      ttl <- paste0("Disease Classes associated to ", input[1,2] )

      igraph::plot.igraph( netw,
                           vertex.frame.color  = "white",
                           layout              = lay,
                           vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "#9bcdff", "royalblue2"),
                           vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                           vertex.frame.color  = 'blue', #the color of the border of the dots
                           vertex.label.color  = 'black',#the color of the name labels
                           vertex.label.font   = 0,      #the font of the name labels
                           vertex.label        = igraph::V( netw )$name, #specifies the lables of the vertices. in this case the 'name' attribute is used
                           edge.color          = "darkgrey",
                           edge.arrow.size     = 0.5,
                           edge.width          = 0.5,
                           vertex.size         = as.numeric(sizes[ igraph::V( netw )$name ])*prop,
                           vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                           main                = ttl
      )
    }
    else{
      stop( "Chart not possible for list. Use instead the plot function with DiseaseClassHeatmap class argument" )
    }
  }

  else if( search == "single" & type == "gene"  ) {
    results <- input [, c ( 6, 1, 2, 3 )]
    results[,4] <- gsub( "null", NA, results[ ,4 ] )

    results <- as.data.frame( transDiseaseClass ( results ) )
    nd <- dim(subset(results, is.na(V4)))[1]
    if (nd > 0){
      show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
    }
    results <- subset(results, !is.na(V4))
    freq <- as.data.frame ( table ( results$V4 ) )
    freq$perc <- ( freq$Freq / sum( freq$Freq ) ) * 100

    rw <- matrix ( c( as.character( results[ 1, 1 ] ), 10, 10), ncol=3 )
    colnames( rw ) <- colnames( freq )
    freq <- rbind( freq, rw )

    sizes <- as.numeric( freq[ , 3 ] )
    names( sizes ) <- freq[ , 1 ]

    #plot
    edges <- data.frame( results[ , 1 ], results[ , 4 ] )
    netw  <- igraph::graph.data.frame( edges, directed = FALSE )
    netw  <- igraph::simplify( netw )
    lay   <- layout( netw )

    if( verbose ) {
      message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
    }

    diseases <- unique( results$V4 )
    ttl <- paste0("Disease Classes associated to ", results$c2.name[1] )

    igraph::plot.igraph( netw,
                         vertex.frame.color  = "white",
                         layout              = lay,
                         vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "royalblue2", "#ff349a" ),
                         vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                         vertex.frame.color  = 'blue', #the color of the border of the dots
                         vertex.label.color  = 'black',#the color of the name labels
                         vertex.label.font   = 0,      #the font of the name labels
                         vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                         edge.color          = "darkgrey",
                         edge.arrow.size     = 0.5,
                         edge.width          = 0.5,
                         vertex.size         = as.numeric(sizes[ igraph::V( netw )$name ])*prop,
                         vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                         main                = ttl
    )
  }
}

plot_dis_heatmapDisease <- function( type, search, input, cutoff=0,nchars, limit, verbose ) {

  if( search == "single" | search == "unify" ) {
    stop( "For this type of chart, a multiple query created with 'disgenetDisease'is required. For single disease or unify disease is not possible to apply this graphic." )
  }

  if( search == "list" ) {

    if( type == "disease" ) {
      tt <- ( input[ , c( "c1.name", "c2.symbol", "c0.score" ) ] )
      tt$c1.name <- as.character(tt$c1.name)
      tt <- tt [ tt$c0.score>= cutoff, ]
      tt <- tt [ with ( tt , order(-c0.score)), ]
      if ( dim( tt )[ 1 ] > limit ){
        tt <- tt[ 1:limit ,]
        show( paste0("Dataframe of ", nrow(input), " rows has been reduced to ", limit, " rows." ))

      }

      for( i in 1:nrow(tt)){
        if(nchar(as.character(tt$c1.name[i])) > nchars){
          rename <- substr(tt$c1.name[i], 1, nchars)
          tt$c1.name[i] <- paste0(rename, "...")
        }
      }

      casted_tt <- reshape::cast( tt, c2.symbol ~ c1.name, value= "c0.score", length )
      l <- dim( casted_tt )[ 2 ]
      casted_tt[ is.na( casted_tt ) ] <- 0
      res <- hclust( dist( casted_tt[ 2:l ] ),  method = "ward.D")
      casted_tt$clus <- cutree( res, k = l+1 )
      ordered <- casted_tt[order(casted_tt$clus), "c2.symbol"]

      tt$c2.symbol  <- factor(tt$c2.symbol , levels= as.factor(ordered))
      ggplot2::qplot( x = c1.name, y = c2.symbol, data= tt , fill = c0.score, geom = "tile" ) +
        ggplot2::ylab( "Genes" ) + ggplot2::xlab( "Disease Name" ) +
        ggplot2::ggtitle( "Gene-Disease Heatmap") +
        ggplot2::scale_fill_gradient2(low = "#0000FF", high ="#2f30c9",guide = "colourbar", "Score") +
        ggplot2::theme ( axis.text = ggplot2::element_text ( size = 9),
                         axis.title=ggplot2::element_text(size=10 ),
                         panel.background = ggplot2::element_rect(fill="white", colour = "black"),
                         text = ggplot2::element_text(size = 11),
                         axis.text.x = ggplot2::element_text(angle=45, size = 11, hjust = 1)
        )


    } else  if( type == "gene" ) {
      tt <- ( input[ , c( "c0.score", "c2.symbol", "c1.name" ) ] )
      tt$c2.symbol <- as.character( tt$c2.symbol )
      tt <- tt [ tt$c0.score>= cutoff, ]


      if ( dim( tt )[ 1 ] > limit ){
        tt <- tt[ 1:limit ,]
        show( paste0("warning: dataframe of ", nrow(input), " rows has been reduced to ", limit, " rows." ))

      }

      for( i in 1:nrow(tt)){

        if(nchar(as.character(tt$c1.name[i])) > nchars){
          tt$c1.name <- as.character(tt$c1.name )
          rename <- substr(tt$c1.name[i], 1, nchars)
          tt$c1.name[i] <- paste0(rename, "...")
        }
      }

      casted_tt <- reshape::cast(tt, c1.name ~ c2.symbol, value= "c0.score" , length )
      l <- dim(casted_tt)[2]
      casted_tt[is.na( casted_tt)] <- 0
      res <- hclust(dist(casted_tt[2:l]),  method = "ward.D")
      casted_tt$clus <- cutree(res, k = l +1)
      ordered <- casted_tt[order(casted_tt$clus), "c1.name"]

      tt$c1.name  <- factor(tt$c1.name , levels= as.factor(ordered))
      ggplot2::qplot( x = c2.symbol, y = c1.name, data= tt , fill = c0.score, geom = "tile" ) +
        ggplot2::ylab( "Diseases" ) + ggplot2::xlab( "Genes" ) + ggplot2::ggtitle( "Gene-Disease Heatmap") +
        ggplot2::scale_fill_gradient2(low = "#0000FF", high ="#2f30c9",guide = "colourbar", "Score") +
        ggplot2::theme ( axis.text = ggplot2::element_text ( size = 9), axis.title=ggplot2::element_text(size=10 ), panel.background = ggplot2::element_rect(fill="white", colour = "black"),
                         text = ggplot2::element_text(size = 11),
                         axis.text.x = ggplot2::element_text(angle=45, size = 11, hjust = 1))
    }
  }
}

plot_dis_heatmapPanther <- function( type, search,nchars, input, verbose ) {

  if( type == "gene" ) {
    stop( "For this type of chart, a multiple query created with 'disgenetDisease' is required." )
  } else if( type == "disease" ) {

    if( search == "single" | search == "unify" ) {
      stop( "For this type of chart, a multiple query created with 'disgenetDisease' is required.
            For single disease or unify disease is not possible to apply this graphic." )
    }else if ( search == "list" ) {
      tt <- ( input[ , c( 2, 6, 10, 9 ) ] )
      tt <- as.data.frame( transDiseaseClass ( tt ) )
      row.names(tt) <- NULL
      tt$V4 <- as.character(tt$V4)

      tt[,4] <- gsub ( "null", NA, tt[,4] )
      tt$c1.name <- as.character(tt$c1.name)

      nd <- length(unique(as.character(subset(tt, is.na(V4))$c2.symbol)))
      if (nd > 0){
        show( paste0("warning: ", nd , " gene(s) not shown in the plot" ))
      }
      tt <- subset(tt, !is.na(V4))

      for( i in 1:nrow(tt)){
        if(nchar(as.character(tt$V4[i])) > nchars){
          rename <- substr(tt$V4[i], 1, nchars)
          tt$V4[i] <- paste0(rename, "...")
        }
      }
      for( i in 1:nrow(tt)){
        if(nchar(as.character(tt$c1.name[i])) > nchars){
          rename <- substr(tt$c1.name[i], 1, nchars)
          tt$c1.name[i] <- paste0(rename, "...")
        }
      }

      for ( i in 1:length(unique(tt$c1.name))){
        disease1 <- tt[tt$c1.name==unique(tt$c1.name)[i],]
        freq <- as.data.frame ( table ( as.character(disease1$V4 ) ))
        freq$perc <- (freq$Freq/sum(freq$Freq))*100
        freq$dis <- unique(tt$c1.name)[i]

        if ( i == 1){
          rr <- freq
        } else if ( i > 1){
          rr <- rbind(rr, freq)
        }
      }

      rr <- rr [ with ( rr , order(-perc)), ]
      casted_rr <- reshape::cast(rr, Var1 ~ dis, value= "perc"  )
      l <- dim(casted_rr)[2]
      Rowm  <- rowMeans(casted_rr[2:l], na.rm = T)
      casted_rr<- cbind(casted_rr, Rowm)
      ordered<-  casted_rr[order(casted_rr["Rowm"]), "Var1" ]
      rr$Var1  <- factor(rr$Var1  , levels= as.factor(ordered))
      m <- max(rr$perc)
      p <- ggplot2::ggplot(rr, ggplot2::aes(dis, Var1)) + ggplot2::geom_tile(ggplot2::aes(fill = perc), colour = "white") + ggplot2::scale_fill_gradient(name="%",limits = c(0,m), low = "lightgrey",   high = "darkolivegreen", na.value = "white")
      p <- p + ggplot2::theme_grey(base_size = 11) + ggplot2::labs(title = "Protein Class Heatmap", x = "Diseases",  y = "Protein class") + ggplot2::scale_x_discrete(expand = c(0, 0))
      p <- p + ggplot2::theme( plot.margin=unit(x=c(5,15,5,15),units="mm") , axis.line = ggplot2::element_line(size = 0.7, color = "black"), text = ggplot2::element_text(size = 11), axis.text.x = ggplot2::element_text(angle=45, size = 11, hjust = 1), panel.background = ggplot2::element_blank())
      p
      #qplot( x = dis, y = Var1, data= rr , fill = perc, geom = "tile" ) + ylab( "Panther Class" ) + xlab( "Disease Name" ) + ggtitle( "Panther class heatmap") + scale_fill_gradient2(low = "#0000FF", high ="#ffa244",guide = "colourbar") + theme ( axis.text = element_text ( size = 9) )
    }

  }
}

plot_dis_heatmapDiseaseClass <- function( type, search, input,nchars, limit, verbose ) {

  if( type == "disease" ) {
    if( search == "dis-dis" ){
      l <- length(unique( input$Disease1 ))
      if (l == 1){
        stop( "For this type of chart, a multiple query created with 'disgenetDisDis' is required." )
      }
      else{
        results <- input [, c (1,2, 5 ,6 )]

        tt <- as.data.frame( transDiseaseClass ( results ) )
        row.names(tt) <- NULL
        tt[,4] <- gsub (" ; ", ";", tt[,4] )
        tt[,4] <- gsub ( "null", NA, tt[,4] )
        tt[,4] <- gsub ( "Wounds and Injuries", NA, tt[,4] )
        tt[,4] <- gsub ( "Animal Diseases", NA, tt[,4] )
        tt$V4 <- as.character(tt$V4)
        tt <- unique(tt[c("NameDisease1", "NameDisease2",  "V4")])
        nd <- dim(subset(tt, is.na(V4)))[1]
        if (nd > 0){
          show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
        }
        for( i in 1:nrow(tt)){
          if(nchar(as.character(tt$V4[i])) > nchars){
            rename <- substr(tt$V4[i], 1, nchars)
            tt$V4[i] <- paste0(rename, "...")
          }
        }
        ##
        for ( i in 1:length(unique(tt$NameDisease1))){
          disease1 <- tt[tt$NameDisease1==unique(tt$NameDisease1)[i],]
          freq <- as.data.frame ( table ( as.character(disease1$V4 ) ))
          freq$perc <- (freq$Freq/sum(freq$Freq))*100
          freq$dis <- unique(tt$NameDisease1)[i]

          if ( i == 1){
            rr <- freq
          } else if ( i > 1){
            rr <- rbind(rr, freq)
          }
        }

        rr <- rr [ with ( rr , order(-perc)), ]
        casted_rr <- reshape::cast(rr, Var1 ~ dis, value= "perc"  )
        l <- dim(casted_rr)[2]
        Rowm  <- rowSums(casted_rr[2:l], na.rm = T)
        casted_rr<- cbind(casted_rr, Rowm)
        ordered<-  casted_rr[order(casted_rr["Rowm"]), "Var1" ]
        rr$Var1  <- factor(rr$Var1  , levels= as.factor(ordered))
        m <- max(rr$perc)
        p <- ggplot2::ggplot(rr, ggplot2::aes(dis, Var1)) + ggplot2::geom_tile(ggplot2::aes(fill = perc), colour = "white") + ggplot2::scale_fill_gradient(limits = c(0,m), low = "white",   high = "royalblue2", na.value = "white", "Percentage")
        p <- p + ggplot2::theme_grey(base_size = 10) + ggplot2::labs(title = "Gene-Disease Class Heatmap", x = "Genes",  y = "MeSH Disease Class") + ggplot2::scale_x_discrete(expand = c(0, 0))
        p <- p + ggplot2::theme( plot.margin=unit(x=c(5,15,5,15),units="mm") , axis.line = ggplot2::element_line(size = 0.7, color = "black"), text = ggplot2::element_text(size = 9),axis.title=ggplot2::element_text(size=10 ), axis.text.x = ggplot2::element_text(angle=45, size = 10, hjust = 1), panel.background = ggplot2::element_blank())
        p
      }
    }

  } else if( type == "gene" ) {

    if( search == "single" ) {
      stop( "For this type of chart, a multiple query created with 'disgenetGeneList' is required." )
    }else if ( search == "list" ) {
      tt <- ( input[ , c( 6, 5, 2, 3 ) ] )

      tt[,4] <- gsub (" ; ", ";", tt[,4] )
      tt[,4] <- gsub ( "null", NA, tt[,4] )
      tt[,4] <- gsub ( "Wounds and Injuries", NA, tt[,4] )
      tt[,4] <- gsub ( "Animal Diseases", NA, tt[,4] )

      tt <- as.data.frame( transDiseaseClass ( tt ) )
      row.names(tt) <- NULL
      tt$V4 <- as.character(tt$V4)

      nd <- length(unique(as.character(subset(tt, is.na(V4))$c1.name)))
      if (nd > 0){
        show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
      }
      tt <- subset(tt, !is.na(V4))

      for( i in 1:nrow(tt)){
        if(nchar(as.character(tt$V4[i])) > nchars){
          rename <- substr(tt$V4[i], 1, nchars)
          tt$V4[i] <- paste0(rename, "...")
        }
      }

      for ( i in 1:length(unique(tt$c2.symbol))){
        disease1 <- tt[tt$c2.symbol==unique(tt$c2.symbol)[i],]
        freq <- as.data.frame ( table ( as.character(disease1$V4 ) ))
        freq$perc <- (freq$Freq/sum(freq$Freq))*100
        freq$dis <- unique(tt$c2.symbol)[i]

        if ( i == 1){
          rr <- freq
        } else if ( i > 1){
          rr <- rbind(rr, freq)
        }
      }

      rr <- rr [ with ( rr , order(-perc)), ]
      casted_rr <- reshape::cast(rr, Var1 ~ dis, value= "perc"  )
      l <- dim(casted_rr)[2]
      Rowm  <- rowSums(casted_rr[2:l], na.rm = T)
      casted_rr<- cbind(casted_rr, Rowm)
      ordered<-  casted_rr[order(casted_rr["Rowm"]), "Var1" ]
      rr$Var1  <- factor(rr$Var1  , levels= as.factor(ordered))
      m <- max(rr$perc)
      p <- ggplot2::ggplot(rr, ggplot2::aes(dis, Var1)) + ggplot2::geom_tile(ggplot2::aes(fill = perc), colour = "white") + ggplot2::scale_fill_gradient(limits = c(0,m), low = "white",   high = "mediumorchid4", na.value = "white", "Percentage")
      p <- p + ggplot2::theme_grey(base_size = 10) + ggplot2::labs(title = "Gene-Disease Class Heatmap", x = "Genes",  y = "MeSH Disease Class") + ggplot2::scale_x_discrete(expand = c(0, 0))
      p <- p + ggplot2::theme( plot.margin=unit(x=c(5,15,5,15),units="mm") , axis.line = ggplot2::element_line(size = 0.7, color = "black"), text = ggplot2::element_text(size = 9),axis.title=ggplot2::element_text(size=10 ), axis.text.x = ggplot2::element_text(angle=45, size = 10, hjust = 1), panel.background = ggplot2::element_blank())
      p
    }
  }
  else if( type == "variant-disease"  ) {
    stop( "For this type of chart, a multiple query created with 'variant2disease' is required." )
  }
  else if( type == "variant"  ) {

    if( search == "single" ) {
      stop( "For this type of chart, a multiple query created with 'variant2disease' is required." )
    }

    tt <- unique( input[ , c( "c0.snpId" ,"c0.diseaseId" , "c2.name", "c2.diseaseClassName") ] )
    tt[,4] <- gsub (" ; ", ";", tt[,4] )
    tt[,4] <- gsub ( "null", NA, tt[,4] )
    tt[,4] <- gsub ( "Wounds and Injuries", NA, tt[,4] )
    tt[,4] <- gsub ( "Animal Diseases", NA, tt[,4] )

    nd <- length(unique(as.character(subset(tt, is.na(c2.diseaseClassName))$c0.diseaseId)))
    if (nd > 0){
      show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
    }
    tt <- subset(tt, !is.na(c2.diseaseClassName))
    tt <- as.data.frame( transDiseaseClass ( tt  ))
    row.names(tt) <- NULL
    tt$V4 <- as.character(tt$V4)
    for( i in 1:nrow(tt)){
      if(nchar(as.character(tt$V4[i])) > nchars){
        rename <- substr(tt$V4[i], 1, nchars)
        tt$V4[i] <- paste0(rename, "...")
      }
    }

    for ( i in 1:length(unique(tt$c0.snpId))){
      disease1 <- tt[tt$c0.snpId==unique(tt$c0.snpId)[i],]
      freq <- as.data.frame ( table ( as.character(disease1$V4 ) ))
      freq$perc <- (freq$Freq/sum(freq$Freq))*100
      freq$snp <- unique(tt$c0.snpId)[i]

      if ( i == 1){
        rr <- freq
      } else if ( i > 1){
        rr <- rbind(rr, freq)
      }
    }

    rr <- rr [ with ( rr , order(-perc)), ]
    casted_rr <- reshape::cast(rr, Var1 ~ snp, value= "perc"  )
    l <- dim(casted_rr)[2]
    Rowm  <- rowSums(casted_rr[2:l], na.rm = T)
    casted_rr<- cbind(casted_rr, Rowm)
    ordered<-  casted_rr[order(casted_rr["Rowm"]), "Var1" ]
    rr$Var1  <- factor(rr$Var1  , levels= as.factor(ordered))
    m <- max(rr$perc)
    p <- ggplot2::ggplot(rr, ggplot2::aes(snp, Var1)) + ggplot2::geom_tile(ggplot2::aes(fill = perc), colour = "white") + ggplot2::scale_fill_gradient(limits = c(0,m), low = "white",   high = "darkolivegreen", na.value = "white", "Percentage")
    p <- p + ggplot2::theme_grey(base_size = 10) + ggplot2::labs(title = "Variant-Disease Class Heatmap", x = "Variants",  y = "MeSH Disease Class") + ggplot2::scale_x_discrete(expand = c(0, 0))
    p <- p + ggplot2::theme( plot.margin=unit(x=c(5,15,5,15),units="mm") , axis.line = ggplot2::element_line(size = 0.7, color = "black"), text = ggplot2::element_text(size = 9),axis.title=ggplot2::element_text(size=10 ), axis.text.x = ggplot2::element_text(angle=45, size = 10, hjust = 1), panel.background = ggplot2::element_blank())
    p
  }
}

plot_dis_Panther <- function ( input, layout, search, verbose ) {

  if( search == "single"){
    results <- input [, c ( 1, 2, 6, 9 )]
    results <- as.data.frame( transDiseaseClass ( results  ))
    results[,4] <- gsub ( "null", NA, results[,4] )


    row.names(results) <- NULL
    nd <- dim(subset(results, is.na(V4)))[1]
    if (nd > 0){
      show( paste0("warning: ", nd , " gene(s) not shown in the plot" ))
    }
    results <- subset(results, !is.na(V4))

    freq <- as.data.frame ( table ( as.character(results$V4 ) ))
    freq$perc <- (freq$Freq/sum(freq$Freq))*100

    rw <- matrix(c(as.character(results[1,2]), 10, 10),ncol=3)
    colnames(rw) <- colnames(freq)
    freq <- rbind(freq,rw)

    sizes <- as.numeric(freq[ , 3 ])
    names( sizes ) <- freq[ , 1 ]

    #plot
    edges <- data.frame( results[ , 2 ], results[ , 4 ] )
    netw  <- igraph::graph.data.frame( edges, directed = FALSE )
    netw  <- igraph::simplify( netw )
    lay   <- layout( netw )

    if( verbose ) {
      message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
    }

    pantherClass <- unique( results$V4 )
    ttl <- paste0("Protein Classes associated to ", results$c1.name[ 1 ] )

    igraph::plot.igraph( netw,
                         vertex.frame.color  = "white",
                         layout              = lay,
                         vertex.color        = ifelse( igraph::V( netw )$name %in% pantherClass, "darkolivegreen", "royalblue2" ),
                         vertex.label.dist   = 0.2,      #puts the name labels slightly off the dots
                         vertex.frame.color  = 'blue', #the color of the border of the dots
                         vertex.label.color  = 'black',#the color of the name labels
                         vertex.label.font   = 0,      #the font of the name labels
                         vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                         edge.color          = "darkgrey",
                         edge.arrow.size     = 0.5,
                         edge.width          = 0.5,
                         vertex.size         = sizes[ igraph::V( netw )$name ],
                         vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                         main                = ttl
    )
  }
  if( search == "unify"){
    results <- input [, c ( 1, 12, 6, 9 )]

    results[,4] <- gsub ( "null", NA, results[,4] )
    results[,4] <- gsub ( "Unclassified", NA, results[,4] )
    results <- as.data.frame( transDiseaseClass ( results ) )
    row.names(results) <- NULL
    nd <- dim(subset(results, is.na(V4)))[1]
    if (nd > 0){
      show( paste0("warning: ", nd , " gene(s) not shown in the plot" ))
    }
    results <- subset(results, !is.na(V4))


    freq <- as.data.frame ( table ( as.character(results$V4 ) ))
    freq$perc <- (freq$Freq/sum(freq$Freq))*100

    rw <- matrix(c(as.character(results[1,2]), 10, 10),ncol=3)
    colnames(rw) <- colnames(freq)
    freq <- rbind(freq,rw)

    sizes <- as.numeric(freq[ , 3 ])
    names( sizes ) <- freq[ , 1 ]

    #plot
    edges <- data.frame( results[ , 2 ], results[ , 4 ] )
    netw  <- igraph::graph.data.frame( edges, directed = FALSE )
    netw  <- igraph::simplify( netw )
    lay   <- layout( netw )

    if( verbose ) {
      message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
    }

    pantherClass <- unique( results$V4 )
    ttl <- paste0("Protein Classes associated to ", results$diseaseIdentifier[ 1 ] )

    igraph::plot.igraph( netw,
                         vertex.frame.color  = "white",
                         layout              = lay,
                         vertex.color        = ifelse( igraph::V( netw )$name %in% pantherClass, "darkolivegreen", "royalblue2" ),
                         vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                         vertex.frame.color  = 'blue', #the color of the border of the dots
                         vertex.label.color  = 'black',#the color of the name labels
                         vertex.label.font   = 0,      #the font of the name labels
                         vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                         edge.color          = "darkgrey",
                         edge.arrow.size     = 0.5,
                         edge.width          = 0.5,
                         vertex.size         = sizes[ igraph::V( netw )$name ],
                         vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                         main                = ttl
    )
  }
}

plot_dis_barplot <- function ( input, type, search, verbose, limit ) {

  if( search != "dis-dis" ) {
    stop( "For this type of chart, a query created with 'disgenetDisDis' is required." )
  }
  #input <- input[c(1:20),]
  input$NameDisease1 <- as.character(input$NameDisease1)
  input$NameDisease2 <- as.character(input$NameDisease2)
  #   for( i in 1:nrow(input)){
  #     if(nchar(as.character(input$NameDisease1[i])) > 50){
  #       rename1 <- substr(input$NameDisease1[i], 1, 50)
  #       input$NameDisease1[i] <- paste0(rename1, "...")
  #     }
  #     if(nchar(as.character(input$NameDisease2[i])) > 50){
  #       rename2 <- substr(input$NameDisease2[i], 1, 50)
  #       input$NameDisease2[i] <- paste0(rename2, "...")
  #     }
  #   }

  input$commonGenes <- as.numeric(input$commonGenes)
  input$JaccardIndex <- as.numeric(input$JaccardIndex)
  input <- subset(input, commonGenes>0)
  input <- input [ with ( input , order(-commonGenes)), ]

  if (dim(input)[1]> limit){
    input <- input[c(1:limit),]
  }

  input$pairs <- paste(input$NameDisease1, input$NameDisease2, sep = " - ")
  orderedDiseases <- input[order(-as.numeric(input$commonGenes)), "pairs"  ]
  input$pairs <- factor(input$pairs , levels= as.factor(orderedDiseases))

  p <- ggplot2::ggplot (input, ggplot2::aes ( x = pairs, y = as.numeric(commonGenes) ), order = as.numeric(commonGenes) ) +
    ggplot2::geom_bar ( stat = "identity", fill = "grey" ) +
    ggplot2::labs ( title = paste0 ( "Disease-Disease Barplot" ) , x = "Disease Pairs", y = "# of shared genes")


  p <- p + ggplot2::theme_classic( ) + ggplot2::theme( plot.margin = unit ( x = c ( 5, 15, 5, 15 ), units = "mm" ),
                                                       axis.line = ggplot2::element_line ( size = 0.7, color = "black" ), text = ggplot2::element_text ( size = 14 ) ,
                                                       axis.text.x = ggplot2::element_text ( angle = 45, size = 9, hjust = 1 ))


  p <- p + ggplot2::geom_point(ggplot2::aes(x = pairs , y =as.numeric(JaccardIndex) *100))
  p <- p + ggplot2::geom_text(ggplot2::aes(x = pairs , y =as.numeric(JaccardIndex) *100 + 1), label = c(round(as.numeric(input$JaccardIndex), digits = 3 )), size=3)
  p

  }

plot_dis_venn <- function( search, type, input, verbose, database ) {

  if( search != "dis-dis" ) {
    stop("For this type of chart, objects comming from disgenetDisDis function is required." )
  }

  tt <- input
  diseases <- c(unique( as.character(unique(tt[, "Disease1"]))) )

  if( length(diseases) > 2 ) {
    stop( "For this type of chart, the diseases list should have 2 diseases" )
  }

  gen1 <-  disgenetDisease(diseases[1], database = database  )
  gen1 <- gen1@qresult$c2.geneId

  gen2 <-  disgenetDisease(diseases[2], database = database )
  gen2 <- gen2@qresult$c2.geneId



  grid.newpage()
  venn.plot <- draw.pairwise.venn(area1        = length(gen1),
                                  area2        = length(gen2),
                                  cross.area   = length(intersect(gen1, gen2)),
                                  scaled       = T,
                                  category     = c( tt[tt$Disease1 == diseases[1], "NameDisease1" ][1],  tt[tt$Disease1 == diseases[2], "NameDisease1" ][1]),
                                  scales       = TRUE,
                                  fill         = c("blue", "red"),
                                  alpha        = 0.3,
                                  lty          = "blank",
                                  cex          = 2,
                                  cat.cex      = 1.5,
                                  cat.pos      = c(0.5 , 1),
                                  cat.dist     = 0.04,
                                  cat.just     = list(c(0.5, 1), c(0.5, 1)),
                                  ext.pos      = 30,
                                  ext.dist     = -0.5,
                                  ext.length   = 0.85,
                                  ext.line.lwd = 2,
                                  ext.line.lty = "dashed")
  grid.draw(venn.plot)

}

plot_dis_pathway <- function( search, type, input, verbose , limit = 10) {

  if( type != "pathway" ) {
    stop( "For this type of chart, a multiple query created with 'disease2pathway' is required." )
  }

  input <- subset(input, pathwayName !="null")
  if (dim(input)[1] > limit){
    input <- input[1:limit, ]
  }

  input$pathwayName <- ifelse( nchar(input$pathwayName) > 30,  paste0(substr(input$pathwayName, 1, 25), "..."),
                    as.character(input$pathwayName) )
  rr <- as.data.frame(table(input$pathwayName))
  #rr <- rr[order(-as.numeric(rr$Freq)),   ]
  rr$Var1 <-factor(rr$Var1, levels=rr[order(-rr$Freq), "Var1"])
  p <- ggplot2::ggplot (rr, ggplot2::aes ( x = Var1, y = Freq ), order = as.numeric(Freq) ) +
    ggplot2::geom_bar ( stat = "identity", fill = "grey" ) +
    ggplot2::labs ( title = paste0 ( "Disease-Pathway Barplot" ) , x = "Pathway", y = "# of genes")


  p <- p + ggplot2::theme_classic( ) + ggplot2::theme( plot.margin = unit ( x = c ( 5, 15, 5, 15 ), units = "mm" ),
                                                       axis.line = ggplot2::element_line ( size = 0.7, color = "black" ), text = ggplot2::element_text ( size = 14 ) ,
                                                       axis.text.x = ggplot2::element_text ( angle = 45, size = 9, hjust = 1 ))


  p

}

plot_dis_comorbidity <- function( input, type, layout, search, verbose, prop, limit ) {

  if( search != "dis-dis" ) {
    stop("For this type of chart, objects comming from disgenetDisDis function is required." )
  } else  if( type != "disease" ) {
    stop("For this type of chart, objects comming from disgenetDisDis function is required." )
  }

  #   disNum <- length ( unique ( input$c1.name) )
  #   diseases <- as.character(unique ( input$c1.name) )
  #   pairs <- ( disNum *  disNum - disNum ) / 2
  #
  #   tb <- as.data.frame(setNames(replicate(5,numeric(0), simplify = F), c("dis1", "dis2", "gen1", "gen2", "intr")))
  #   cnt <- 1
  #
  #   for ( i in 1:disNum){
  #     dis1 <- input[ input$c1.name == unique( input$c1.name )[ i ] ,]
  #     gen1 <- unique( dis1$c2.name)
  #
  #     for ( j in 2:disNum){
  #       if ( i < j){
  #         dis2 <- input[ input$c1.name == unique( input$c1.name )[ j ] ,]
  #         gen2 <- unique( dis2$c2.name)
  #         tb[ cnt, ] <- c(diseases[ i ], diseases[ j ], length( gen1 ), length( gen2 ), length( intersect( gen1, gen2 ) ))
  #         cnt <- cnt + 1
  #       }
  #     }
  #   }
  input <- subset(input, commonGenes>0)
  a <- nrow(input)
  if (dim(input)[1]> limit){
    input <- input[c(1:limit),]
    show( paste0("warning: dataframe of ", a , " rows has been reduced to ", limit, " rows." ))
  }
  edges <- data.frame( input[ , "NameDisease1" ], input[ , "NameDisease2" ] )
  netw  <- graph.data.frame( edges, directed = FALSE )
  netw  <- simplify( netw )
  lay   <- layout(netw)

  if( verbose ) {
    message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
  }
  if( search == "single" ) {
    stop ( "This network is only available for objects comming from disgenetDisease function where search is a list of diseases" )
  }else if ( search == "list" ){
    if ( type == "gene"){
      stop ( "This network is only available for objects comming from disgenetDisease function where search is a list of diseases" )
    }
  }
  dn1 <- unique(input$NameDisease1)
  if (length(dn1) == 1){
    ttl <- paste0( "Disease-Disease Network for ", dn1 )
  }
  else{
    ttl <- paste0( "Disease-Disease Network" )
  }

  ds1 <- input[,c( "NameDisease1", "NGenes1" ) ]
  colnames( ds1 ) <- c("dis", "gen")
  ds2 <- input[, c("NameDisease2", "NGenes2") ]
  colnames( ds2 ) <- c("dis", "gen")

  fnl <- rbind ( ds1, ds2)
  fnl <- fnl[!duplicated(fnl), ]

  sizes <- as.numeric( fnl[ , 2 ] )
  names( sizes ) <- fnl[ , 1 ]

  igraph::plot.igraph( netw,
                       vertex.frame.color  = "white",
                       layout              = lay,
                       vertex.color        = ifelse( igraph::V( netw )$name %in% ds1$dis, "royalblue2", "#b4daff" ),
                       vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                       vertex.frame.color  = 'blue', #the color of the border of the dots
                       vertex.label.color  = 'black',#the color of the name labels
                       vertex.label.font   = 0,      #the font of the name labels
                       vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                       edge.color          = "black",
                       edge.width          = prop * (as.numeric( input$commonGenes ))^1/2,
                       edge.arrow.size     = 0.5,
                       vertex.size         = prop *30*log2(as.numeric(sizes[ igraph::V( netw )$name ])+1),
                       vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                       main                = ttl
  )
}

plot_dis_dis_associations <- function( input, type, layout, search, verbose, prop, limit, database ) {

  if( search != "dis-dis" ) {
    stop("For this type of chart, objects comming from disgenetDisDis function is required." )
  } else  if( type != "disease" ) {
    stop("For this type of chart, objects comming from disgenetDisDis function is required." )
  }
  l <- unique(input$Disease1)
  if (length(l) == 1){
    stop("For this type of chart, objects generated with disgenetDisDis function, and a disease list, are required ." )

  }

  input <- subset(input, commonGenes>0)
  disNum <- length ( unique ( input$Disease1) )
  diseases <- as.character(unique (  input$Disease1) )

  res <- disgenetDisease(disease = diseases,
                         database = as.character(database))
  res <- res@qresult
  pairs <- ( disNum *  disNum - disNum ) / 2
  tb <- as.data.frame(setNames(replicate(7,numeric(0), simplify = F), c("disease1","NameDisease1", "disease2","NameDisease2", "NGenes1", "NGenes2", "intr")))
  cnt <- 1
  for ( i in 1:disNum){
    dis1 <- diseases[i]
    nd1 <- as.character (  res[res[,1]==diseases[i],"c1.name"][1]  )
    gen1 <- unique( subset(res, c1.cui == dis1 )$c2.geneId)
    for ( j in 2:disNum){
      if ( i < j){
        dis2 <- diseases[j]
        nd2 <- as.character (  res[res[,1]==diseases[j],"c1.name"][1]  )
        gen2 <- unique( subset(res, c1.cui == dis2 )$c2.geneId)
        tb[ cnt, ] <- c(diseases[ i ], nd1, diseases[ j ],nd2, length( gen1 ), length( gen2 ), length( intersect( gen1, gen2 ) ))
        cnt <- cnt + 1
      }
    }
  }
  tb <- tb[tb[,"intr"]>0 ,]
  finaldiseases <- unique( c(as.character(tb$disease1), as.character(tb$disease2)))
  #   if (dim(input)[1]> limit){
  #     input <- input[c(1:limit),]
  #     show( paste0("warning: dataframe of ", a , " rows has been reduced to ", limit, " rows." ))
  #   }
  edges <- data.frame( tb[ , "NameDisease1" ], tb[ , "NameDisease2" ] )
  netw  <- graph.data.frame( edges, directed = FALSE )
  netw  <- simplify( netw )
  lay   <- layout(netw)

  if( verbose ) {
    message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
  }
  if( search == "single" ) {
    stop ( "This network is only available for objects comming from disgenetDisease function where search is a list of diseases" )
  }else if ( search == "list" ){
    if ( type == "gene"){
      stop ( "This network is only available for objects comming from disgenetDisease function where search is a list of diseases" )
    }
  }
  ttl <- paste0( "Disease-Disease Network" )

  #input<- subset(input,Disease1 %in% finaldiseases & Disease2 %in% finaldiseases  )
  ds1 <- input[,c( "NameDisease1", "NGenes1" ) ]
  colnames( ds1 ) <- c("dis", "gen")
  ds2 <- input[, c("NameDisease2", "NGenes2") ]
  colnames( ds2 ) <- c("dis", "gen")

  fnl <- rbind ( ds1, ds2)
  fnl <- fnl[!duplicated(fnl), ]

  sizes <- as.numeric( fnl[ , 2 ] )
  names( sizes ) <- fnl[ , 1 ]

  igraph::plot.igraph( netw,
                       vertex.frame.color  = "white",
                       layout              = lay,
                       vertex.color        =  "royalblue2" ,
                       vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                       vertex.frame.color  = 'blue', #the color of the border of the dots
                       vertex.label.color  = 'black',#the color of the name labels
                       vertex.label.font   = 0,      #the font of the name labels
                       vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                       edge.color          = "black",
                       edge.width          = prop * (as.numeric( input$commonGenes ))^1/2,
                       edge.arrow.size     = 0.5,
                       # vertex.size         = 10,
                       vertex.size         = prop *30*log2(as.numeric(sizes[ igraph::V( netw )$name ])+1),
                       vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                       main                = ttl
  )
}

plot_variant_disease_heatmap <- function( type, search, input, cutoff=cutoff, limit, verbose ) {

  if( search == "single" ) {
    stop( "For this type of chart, a multiple query created with 'variant2disease'is required. " )
  }

  if( type == "variant-disease" ) {
    tt <- unique( input[ , c( "diseaseId","diseaseName", "snp","score" ) ] )
    tt$snp <- as.character(tt$snp)
    tt$diseaseName <- as.character(tt$diseaseName)

    tt <- tt [ tt$score>= cutoff, ]
    tt <- tt [ with ( tt , order(-score)), ]
    if ( dim( tt )[ 1 ] > limit ){
      tt <- tt[ 1:limit ,]
      show( paste0("Dataframe of ", nrow(input), " rows has been reduced to ", limit, " rows." ))
    }

    #       for( i in 1:nrow(tt)){
    #         if(nchar(as.character(tt$diseaseName[i])) > 30){
    #           rename <- substr(tt$diseaseName[i], 1, 30)
    #           tt$c1.name[i] <- paste0(rename, "...")
    #         }
    #       }

    casted_tt <- reshape::cast( tt, snp ~diseaseName, value= "score", length )
    l <- dim( casted_tt )[ 2 ]
    casted_tt[ is.na( casted_tt ) ] <- 0
    res <- hclust( dist( casted_tt[ 2:l ] ),  method = "ward.D")
    casted_tt$clus <- cutree( res, k = 5 )
    ordered <- casted_tt[order(casted_tt$clus), "snp"]

    #tt$diseaseName  <- factor(tt$diseaseName , levels= as.factor(ordered))
    tt$snp  <- factor(tt$snp , levels= as.factor(ordered))

    p<- ggplot2::qplot( x = snp, y = diseaseName, data= tt , fill = score, geom = "tile" ) +
      ggplot2::ylab( "Diseases" ) + ggplot2::xlab( "Variants" ) +
      ggplot2::ggtitle( "Variant-Disease Heatmap") +
      ggplot2::scale_fill_gradient2(low = "#0000FF", high ="#2f30c9",guide = "colourbar", "Score") +
      ggplot2::theme ( axis.text = ggplot2::element_text ( size = 9),
                       axis.title=ggplot2::element_text(size=10 ),
                       panel.background = ggplot2::element_rect(fill="white", colour = "black"),
                       text = ggplot2::element_text(size = 11),
                       axis.text.x = ggplot2::element_text(angle=45, size = 11, hjust = 1)
      )
    print(p)

  } else  if( type == "variant" ) {

    tt <- unique( input[ , c( "diseaseId","diseaseName", "snp","score" ) ] )
    tt$snp <- as.character(tt$snp)
    tt$diseaseName <- as.character(tt$diseaseName)

    tt <- tt [ tt$score>= cutoff, ]
    if ( dim( tt )[ 1 ] > limit ){
      tt <- tt[ 1:limit ,]
      show( paste0("warning: dataframe of ", nrow(input), " rows has been reduced to ", limit, " rows." ))
    }

    #       for( i in 1:nrow(tt)){
    #
    #         if(nchar(as.character(tt$c1.name[i])) > 30){
    #           rename <- substr(tt$c1.name[i], 1, 30)
    #           tt$c1.name[i] <- paste0(rename, "...")
    #         }
    #       }

    casted_tt <- reshape::cast( tt, diseaseName~snp, value= "score", length )

    l <- dim(casted_tt)[2]
    casted_tt[is.na( casted_tt)] <- 0
    res <- hclust(dist(casted_tt[2:l]),  method = "ward.D")
    casted_tt$clus <- cutree(res, k = 5)
    ordered <- casted_tt[order(casted_tt$clus), "diseaseName"]

    tt$diseaseName  <- factor(tt$diseaseName , levels= as.factor(ordered))
    p <- ggplot2::ggplot( tt,  ggplot2::aes ( x = diseaseName, y = snp ) )
    p <- p + ggplot2::geom_tile(ggplot2::aes(fill = score), colour = "white")
    p <- p + ggplot2::labs(title = "Variant-Disease Heatmap", x = "Diseases",  y = "Variants")
    p <- p + ggplot2::scale_fill_gradient2(low = "#0000FF", high ="#2f30c9",guide = "colourbar", "Score")
    p <- p + ggplot2::theme ( axis.text = ggplot2::element_text ( size = 9),
                     axis.title=ggplot2::element_text(size=10 ),
                     panel.background = ggplot2::element_rect(fill="white", colour = "black"),
                     text = ggplot2::element_text(size = 11),
                     axis.text.x = ggplot2::element_text(angle=45, size = 11, hjust = 1) )

    print(p)
   }
}

#' Retrieves variants associated to a disease, or list of diseases and generates an \code{DataGeNET.DGN}
#'
#' Given the name of one or multiple diseases and retrieves the associated variant(s)
#'  and creates an object of type \code{DataGeNET.RDF}.
#' @param disease A disease or a list of disease identifiers (CUIs, MeSH, OMIMs...)
#' @param vocabulary   The vocabulary of the disease identifier(s)
#' Select one of the available: \code{OMIM} (OMIM), \code{MSH} (MeSH), \code{DO} (Disease Ontology),
#' \code{NCI} (NCI thesaurus), \code{ORDO} (Orphanet),
#' \code{ICD9CM} (ICD9-CM) or \code{EFO} (EFO). Default \code{'UMLS'}.
#' @param score A vector with two elements: 1) initial value of score 2) final value of score
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to hide the warnings.
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @return An object of class \code{DataGeNET.DGN}
#' @examples
#' dis2var <- disease2variant( disease = "C0751955",vocabulary = "UMLS", database = "ALL", score=c(0,1) )
#' @export disease2variant


disease2variant <- function( disease = "C0751955", vocabulary = "UMLS", database = "CURATED", score = c(0,1), api_key=NULL,  verbose = FALSE, warnings = TRUE ) {
  if(is.null(api_key)){
    api_key = Sys.getenv('DISGENET_API_KEY')
    if(api_key == ""){
      stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
    }
  }
  check_disgenet_sources(database)
  vocabularies <- c("UMLS", "OMIM", "NCI", "MESH", "ICD9CM", "EFO", "DO", "HPO", "ORDO")
  vv <- intersect(vocabulary, vocabularies)
  if (length(vv) == 0) {
    stop(paste0(vocabulary,  " is a wrong vocabulary! Allowed vocabularies are: \n", paste(vocabularies, collapse = "\n")))
  }
  if (vv != "UMLS") {
    vv <- paste0(tolower(vv), "_id")
  }
  if (  database == "CTD_human" | database == "CTD_rat" |
        database == "CTD_mouse" |database == "RGD" | database == "MGD" |
        database == "ANIMAL_MODELS" | database == "HPO" | database == "PSYGENET" |
        database == "LHGDN"  ) {

    stop("This resource does not have variant-disease associations.")
  }


  if( length( disease ) != length( unique( disease ) ) ) {
    disease <- unique( disease )
    warning(
      "Removing duplicates from input list."
    )
  }

  if(length(score) != 2) {
    stop("Invalid argument 'score'. It must have two elements: initial value of the score, and final value of the score")
  }

  list_of_diseases <- paste(disease,collapse=",")

  result <- NULL
  if (vocabulary== "UMLS") {
    url <- paste0( get_url_disgenet(), "vda/disease/", list_of_diseases , "?source=",database, "&min_score=", score[1],"&max_score=", score[2],  "&format=tsv")
  } else {
    url <- paste0( get_url_disgenet(), "vda/disease/",tolower(vocabulary),"/", list_of_diseases , "?source=", database, "&min_score=",score[1],"&max_score=", score[2],  "&format=tsv")
  }
  #print(url)
  r <- get_api_connection(url = url, api_key=api_key)

  #r <- httr::GET(url)
  if (r$status_code == 200) {
    myTextConnection <- textConnection(rawToChar(r$content ))
    result <- read.csv( myTextConnection, header = TRUE, sep = "\t" )
    close(myTextConnection)
  }else{
    print(httr::http_status(r))
    print(httr::content(r, "text"))
  }
  # x = RCurl::getURL(url)
  # if (grepl("status_code",x) == F) {
  #   dataTsv <- RCurl::getURLContent( url     )
  #   myTextConnection <- textConnection( dataTsv )
  #   result <- read.csv( myTextConnection, header = TRUE, sep = "\t" )
  #
  #   close(myTextConnection)
  # }
  # else{
  #   x <- jsonlite::fromJSON(x)
  #   print(x$detail)
  # }

  if(length( disease )==1){
    cls <- "single"
  }else{
    cls <- "list"
  }

  scR <- paste0( score[1],"-", score[2])
  if (!is.null(result)){
    if(vocabulary == "UMLS"){
      wDiseases <- setdiff(disease, result$diseaseid)
      eDiseases <- intersect(disease, result$diseaseid)
    }else {
      wDiseases <- setdiff(disease,result[, vv])
      eDiseases <- intersect(disease, result[, vv])
    }

    if( length( wDiseases ) != 0 ) {
      diseases <- paste( paste( "   -", wDiseases ), collapse = "\n" )
      if( warnings ) {
        warning( "One or more of the diseases in the list is not in DisGeNET ( '", database, "' ):\n", diseases  )
      }
    }

    result$score <- as.numeric(as.character(result$score))
    result <- new( "DataGeNET.DGN",
                   type = "disease-variant",
                   search = cls,
                   term = as.character( disease ),
                   scoreRange = scR,
                   database = database,
                   qresult = result )

    return( result )
  } else {
    print("no results for the query")
  }
}

apply_layout <- function( layout, netw){
  if(layout == "layout.fruchterman.reingold"){
    lay   <- igraph::layout.fruchterman.reingold( netw )
  }else if(layout == "layout.auto"){
    lay   <- igraph::layout.auto( netw )
  }else if(layout == "layout.random"){
    lay   <- igraph::layout.random( netw )
  }else if(layout == "layout.circle"){
    lay   <- igraph::layout.circle( netw )
  }else if(layout == "layout.sphere"){
    lay   <- igraph::layout.sphere( netw )
  }else if(layout == "layout.fruchterman.reingold"){
    lay   <- igraph::layout.fruchterman.reingold( netw )
  }else if(layout == "layout.kamada.kawai"){
    lay   <- igraph::layout.kamada.kawai( netw )
  }else if(layout == "layout.spring"){
    lay   <- igraph::layout.spring( netw )
  }else if(layout == "layout.reingold.tilford"){
    lay   <- igraph::layout.reingold.tilford( netw )
  }else if(layout == "layout.fruchterman.reingold.grid"){
    lay   <- igraph::layout.fruchterman.reingold.grid( netw )
  }else if(layout == "layout.lgl"){
    lay   <- igraph::layout.lgl( netw )
  }else if(layout == "layout.svd"){
    lay   <- igraph::layout.svd( netw )
  }else if(layout == "layout.graphopt"){
    lay   <- igraph::layout.graphopt( netw )
  }else if(layout == "layout.norm"){
    lay   <- igraph::layout.norm( netw )
  }else{
    stop
    message("Check if your layout is included in the igraph layout options:
            layout.auto, layout.random, layout.circle, layout.sphere,
            layout.fruchterman.reingold, layout.kamada.kawai, layout.spring,
            layout.reingold.tilford, layout.fruchterman.reingold.grid,
            layout.lgl, layout.graphopt, layout.svd, layout.norm"
    )
  }
  return(lay)
}

check_disgenet_sources <- function( database,
                            allowed_db = c( "CTD_HUMAN", "UNIPROT", "HPO",
                                            "ORPHANET", "PSYGENET", "CGI",
                                            "GENOMICS_ENGLAND", "CLINGEN",
                                            "CLINVAR", "GWASCAT", "GWASDB",
                                            "CURATED",
                                            "CTD_MOUSE", "CTD_RAT","MGD", "RGD",
                                            "ANIMAL_MODELS", "INFERRED",
                                             "LHGDN","BEFREE", "ALL" ) ) {
  database <- toupper( database )
  if( sum( database %in% allowed_db ) == 1 ) {
    return( database )
  } else {
    stop("Invalid given 'database' ('", database, '). Try ?disease2gene or ',
         '?gene2disease to check the available databases.')
  }
}

#' Retrieves evidences supporting a gene-disease association, for a gene, or list of genes and generates an \code{DataGeNET.DGN}
#'
#' @param variant a variant or a list of variants
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param score A vector with two elements: 1) initial value of score 2) final value of score
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to not see
#' the warnings.
#' @return An object of class \code{DataGeNET.Dis}
#' @examples
#' g <- variant2evidence( variant = "rs121913279", "CURATED", score=c(0,1)  )
#' @export variant2evidence


variant2evidence <- function( variant,
                           disease = NULL, year=c(0,2050),
                           database = "CURATED", score=c(0,1), api_key=NULL,  verbose = FALSE, warnings = TRUE ) {
  if(is.null(api_key)){
    api_key = Sys.getenv('DISGENET_API_KEY')
    if(api_key == ""){
      stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
    }
  }
  check_disgenet_sources( database )

  if( length( variant ) != length( unique( variant ) ) ) {
    variant <- unique( variant )
    warning(
      "Removing duplicates from input genes list."
    )
  }


  if(length(score) != 2) {
    stop("Invalid argument 'score'. It must have two elements: initial value of the score, and final value of the score")
  }
  if(length(year) != 2) {
    stop("Invalid argument 'year'. It must have two elements: initial year and final year")
  }

  list_of_variants <- paste(variant,collapse=",")
  list_of_diseases <- paste(disease,collapse=",")

  result <- NULL
  if(!is.null(disease)){
    url <- paste0( get_url_disgenet(), "vda/evidences/variant/", list_of_variants , "?disease=",list_of_diseases , "&source=",database, "&min_score=",score[1],"&max_score=", score[2], "&min_year=",year[1],"&max_year=", year[2])
  }
  else{
    url <- paste0( get_url_disgenet(), "vda/evidences/variant/", list_of_variants , "?source=",database, "&min_score=",score[1],"&max_score=", score[2], "&min_year=",year[1],"&max_year=", year[2])

  }
  r <- get_api_connection(url = url, api_key=api_key)
  if (r$status_code == 200) {

    res<-jsonlite::fromJSON(httr::content(r, as = "text", encoding = "UTF-8"), flatten = F)
    result <- res$results

    while (is.null(res$`next` )==F) {
      r <- get_api_connection(url = res$`next`, api_key=api_key)
      if (r$status_code == 200) {

        res <- jsonlite::fromJSON(httr::content(r, as = "text", encoding = "UTF-8"), flatten = F)
        result <- rbind(result, res$results)
      }
    }

  } else{
    print(httr::http_status(r))
    print(httr::content(r, "text"))
  }



  if(length( variant )==1){
    cls <- "single"
  }else{
    cls <- "list"
  }

  scR <- paste0( score[1],"-", score[2])

  if (! is.null(result) > 0){
    missing_variants <- setdiff(variant, result$variant_id)
    found_variants <- intersect(variant, result$variant_id)

    if( length( missing_variants) > 0 ) {
      missing_variants <- paste( paste( "   -", missing_variants ), collapse = "\n" )
      if( warnings ) {
        warning( "\n One or more of the variants in the list is not in DisGeNET ( '", database, "' ):\n", missing_variants )
      }
    }

    result <- new( "DataGeNET.DGN",
                   type = "evidence",
                   search = cls,
                   term = as.character( found_variants ),
                   scoreRange = scR,
                   database = database,
                   qresult = result )

    return( result )
  } else {
    print("no results for the query")
  }
}

setGeneric ("ndisease",
  function(object){standardGeneric("ndisease")}
)
setGeneric ("ngene",
  function(object){standardGeneric("ngene")}
)
setGeneric ("extract",
  function(object){standardGeneric("extract")}
)
setGeneric ("extractTable",
  function(object){standardGeneric("extractTable")}
)
setGeneric ("plotN",
  function(x,...){standardGeneric("plotN")}
)

#' Retrieves disease-disease associations via shared genes and generates an \code{DataGeNET.DGN}
#'
#' Given the CUI of one or multiple diseases, retrieves the associated diseases
#' from DisGeNET and creates an object of type \code{DataGeNET.Dis}.
#'
#' @param disease a CUI or a vector of CUIs
#' The diseases non existing in DisGeNET will
#' be removed from the output.
#' @param vocabulary   The vocabulary of the disease identifier(s)
#' Select one of the available:  \code{UMLS} (UMLS), \code{OMIM} (OMIM), \code{MSH} (MeSH), \code{DO} (Disease Ontology),
#' \code{NCI} (NCI thesaurus), \code{ORDO} (Orphanet),
#' \code{ICD9CM} (ICD9-CM) or \code{EFO} (EFO). Default \code{'UMLS'}.
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param ndiseases The number of associated diseases to retrieve. By default 10. Set to XX to retrieve all diseases
#' @param pvalue p value of the bootstrap. See more info at www.disgenet.org. By default 1
#' @param verbose By default \code{FALSE}. Set to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Set to \code{FALSE} to hide the warnings.
#' @return An object of class \code{DataGeNET.Dis}
#' @examples
#' dd1 <- disease2disease_by_variant( "C0028754", database = "CURATED" , pvalue = 0.05)
#' @export disease2disease_by_variant


disease2disease_by_variant <- function( disease, vocabulary= "UMLS",  ndiseases =10, database = "CURATED", pvalue = 1,  api_key=NULL,  verbose = FALSE, warnings = TRUE ) {
  if(is.null(api_key)){
    api_key = Sys.getenv('DISGENET_API_KEY')
    if(api_key == ""){
      stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
    }
  }
  check_disgenet_sources( database )
  if (  database == "CTD_human" | database == "CTD_rat" |
        database == "CTD_mouse" |database == "RGD" | database == "MGD" |
        database == "ANIMAL_MODELS" | database == "HPO" | database == "PSYGENET" |
        database == "LHGDN"  ) {

    stop("This resource does not have variant-disease associations.")
  }


  vocabularies <- c("UMLS", "OMIM", "NCI", "MESH", "ICD9CM", "EFO", "DO", "HPO", "ORDO")
  vv <- intersect(vocabulary, vocabularies)
  if (length(vv) == 0) {
    stop(paste0(vocabulary,  " is a wrong vocabulary! Allowed vocabularies are: \n", paste(vocabularies, collapse = "\n")))
  }
  if (vv != "UMLS") {
    vv <- paste0(tolower(vv), "_id")
  }

  if( length( disease ) != length( unique( disease ) ) ) {
    disease <- unique( disease )
    if( warnings ) {
      warning(
        "Removing duplicates from input diseases list."
      )
    }
  }

  result    <- data.frame()
  for (ii in 1:length(disease) ){

    if( verbose ) {
      message(
        "Retrieving data for ", disease[ii], " from DisGeNET"
      )
    }
    if (vocabulary== "UMLS") {
      url <- paste0( get_url_disgenet(), "dda/variants/disease/", disease[ii] ,"?limit=", ndiseases, "&source=", database, "&format=tsv")
    } else {
      url <- paste0( get_url_disgenet(), "dda/variants/disease/",tolower(vocabulary),"/", disease[ii] ,"?limit=", ndiseases, "&source=", database, "&format=tsv")
    }
    r <- get_api_connection(url = url, api_key=api_key)

    if (r$status_code == 200) {
      myTextConnection <- textConnection(rawToChar(r$content ))
      dataNew <- read.csv( myTextConnection, header = TRUE, sep = "\t" )
      result <- rbind(result, dataNew)
      close(myTextConnection)
    } else if (r$status_code == 404){
      message(
        "The disease ", disease[ii], " is not present in DisGeNET, data source ", database
      )
    } else{
      #print(httr::http_status(r))
      print(httr::content(r, "text"))
    }

  }

  if(length( disease )==1){
    cls <- "single"
  }else {
    cls <- "list"
  }
  # print(result)
  result <- result[result$nvariants > 0,]
  # if (!is.null(result)){
  if ( dim(result)[2]> 0){
    if(vocabulary == "UMLS"){
      wDiseases <- setdiff(disease, result$diseaseid1)
      eDiseases <- intersect(disease, result$diseaseid1)
    }else {
      wDiseases <- setdiff(disease,result[, vv])
      eDiseases <- intersect(disease, result[, vv])
    }

    if( length( wDiseases ) != 0 ) {
      diseases <- paste( paste( "   -", wDiseases ), collapse = "\n" )
      if( warnings ) {
        warning( "One or more of the diseases in the list is not in DisGeNET ( '", database, "' ):\n", diseases  )
      }
    }
    result <- pvalue_estimation(result, database = database, nboot = 1000, api_key = api_key)
     result$pvalue <- as.numeric(as.character(result$pvalue))
    result$pvalue <- round(result$pvalue, 3)
    result$jaccard_variants <- as.numeric(as.character(result$jaccard_variants))
    result$jaccard_variants <- round(result$jaccard_variants, 3)
    result <- result[ result$pvalue < pvalue  , ]

    result <- result[c( "diseaseid1", "disease1_name", "diseaseid2", "disease2_name",
                        "disease1_disease_class", "disease1_disease_class_name",
                        "disease2_disease_class", "disease2_disease_class_name",
                        "jaccard_variants", "pvalue", "nvariants",
                        "nvariants1" ,"nvariants2" ,  "source"  )]

    result <- new( "DataGeNET.DGN",
                   type     = "disease-disease-variant",
                   search   = cls,
                   term       = as.character( eDiseases ),
                   database = database,
                   scoreRange =  "",
                   qresult  = result
    )

    return( result )
  } else{
    message(
      "There are no results for those parameters "
    )
  }

}

#' Retrieves diseases associated to a variant or list of variants and generates an \code{DataGeNET.DGN}
#'
#' Given a variant or a list of variants, it retrieves the variant-disease associations
#' related to diseases in DisGeNET. It creates an object of type \code{DataGeNET.DGN}.
#'
#' @param variant a variant, or list of variants
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' @param score A vector with two elements: 1) initial value of score 2) final value of score
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to not see
#' the warnings.
#' @return An object of class \code{DataGeNET.DGN}
#' @examples
#' vd <- variant2disease(variant = "rs121909211", database = "CURATED",  verbose = FALSE, warnings = TRUE)
#' @export variant2disease


variant2disease <- function( variant, database = "CURATED", score=c(0,1),  api_key=NULL,  verbose = FALSE, warnings = TRUE ) {
  if(is.null(api_key)){
    api_key = Sys.getenv('DISGENET_API_KEY')
    if(api_key == ""){
      stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
    }
  }
  check_disgenet_sources(database)

  if (  database == "CTD_human" | database == "CGI" | database == "CLINGEN"
        | database == "GENOMICS_ENGLAND" | database == "PSYGENET" |  database == "CTD_rat" |
        database == "CTD_mouse" |database == "RGD" | database == "MGD" |
        database == "ANIMAL_MODELS" | database == "HPO" |  database == "INFERRED" |
        database == "LHGDN"  ) {
    stop("This datasource does not annotate variants.")
  }
  if(length(score) != 2) {
    stop("Invalid argument 'score'. It must have two elements: initial value of the score, and final value of the score")
  }

  list_of_variants <- paste(variant,collapse=",")
  result <- NULL

  url <- paste0( get_url_disgenet(), "vda/variant/", list_of_variants ,"?source=",database, "&min_score=",score[1],"&max_score=", score[2],  "&format=tsv")
  r <- get_api_connection(url = url, api_key=api_key)
  if (r$status_code == 200) {
    myTextConnection <- textConnection(rawToChar(r$content ))
    result <- read.csv( myTextConnection, header = TRUE, sep = "\t" )
    close(myTextConnection)
  }else{
    print(httr::http_status(r))
    print(httr::content(r, "text"))
  }

  if(length( variant )==1){
    cls <- "single"
  }else{
    cls <- "list"
  }

  scR <- paste0( score[1],"-", score[2])

  if (!is.null(result)){
    wVariants <- setdiff(variant,result$variantid)
    eVariants <- intersect(variant, result$variantid)
    if( length( wVariants ) != 0 ) {
      variants <- paste( paste( "   -", wVariants ), collapse = "\n" )
      if( warnings ) {
        warning( "\n One or more of the variants in the list is not in DisGeNET ( '", database, "' ):\n", variants )
      }
    }

    result <- new( "DataGeNET.DGN",
                   type = "variant-disease",
                   search = cls,
                   term = as.character( eVariants ),
                   scoreRange = scR,
                   database = database,
                   qresult = result )

    return( result )
  } else {
    print("no results for the query")
  }
}

#' Query for given gene(s) and generates an \code{DataGeNET.RDF}
#
#' Given the NCBI gene identifier, retrieves the information
#' related to drugs which interacts with the gene product and
#' their indications and creates an object of type \code{DataGeNET.RDF}.
#
#' @param gene NCBI gene ID
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to don't see
#' the warnings.
#' @return An object of class \code{DataGeNET.RDF}
# @examples
# gene2indi <- gene2indication( gene = 1588 )
#' @export gene2indication


gene2indication <- function( gene,  verbose = FALSE, warnings = TRUE ) {

    # endpoint
  endpoint <- "http://rdf.disgenet.org/sparql/"

  # oql is the query that let us look for drug indications in Wikidata
  query <- "PREFIX wd: <http://www.wikidata.org/entity/>
  PREFIX wdt: <http://www.wikidata.org/prop/direct/>

  SELECT str(?ncbigene_id) as ?ncbi_geneid ?gene_iri str(?gene_product_label) as ?gene_product_label str(?chembl_id) as ?chembl_id str(?drug_label) as ?drug_label ?drug_iri str(?indication_label) as ?indication_label ?indication_iri WHERE {

    # Wikidata query
    SERVICE <https://query.wikidata.org/sparql> {
      ?gene wdt:P351 ?ncbigene_id . FILTER (?ncbigene_id = \"%s\")
      ?gene wdt:P688 ?gene_product .  # gene_product (usually a protein) is a product of a gene (a region of DNA)
      ?gene_product rdfs:label ?gene_product_label .
      filter (lang(?gene_product_label) = 'en')
      ?drug_iri wdt:P129 ?gene_product ;   # drug interacts with a gene_product
      wdt:P2175 ?indication_iri ;
      wdt:P592 ?chembl_id .
      ?drug_iri rdfs:label ?drug_label . filter (lang(?drug_label) = 'en')
      ?indication_iri rdfs:label ?indication_label . filter (lang(?indication_label) = 'en')
  }

  # DisGeNET query
  BIND(IRI(CONCAT(\"http://identifiers.org/ncbigene/\",?ncbigene_id)) as ?gene_iri)
  ?gene_iri rdf:type ncit:C16612 .
  }"

  query <- sprintf(query,  as.character(gene))

  # SPARQL query
  # perform the SPARQL query to DisGeNET
  prefix <- c("sio","http://semanticscience.org/resource/","skos","http://www.w3.org/2004/02/skos/core#")
  message("Performing the query. This is a federated query with Wikidata and may take some time, please wait...")
  res <- tryCatch({
    SPARQL(url=endpoint,query=query,ns=prefix)
  },
  error = function(err){
    print(paste0("The query did not work. The error: "),err)
  })

  if (length(res$results) == 0){
    warning("There is no indications data in Wikidata for gene ", gene)
    #warning("There are no genes ", gene, " and the input parameters that have annotations in Wikidata.")
  } else {

    result <- new( "DataGeNET.RDF",
                   input     = as.character(gene),
                   search    = "indication",
                   selection = "gene",
                   mapping   = nrow(res$result),
                   qresult   = res$result
    )
    return( result )
  }

}

#' Obtain the raw query from DisGeNET from a \code{DataGeNET.RDF} object.
#'
#' @name extract
#' @rdname extract-methods
#' @aliases DataGeNET.Dis-methods
#' @param object Object of class \code{DataGeNET.RDF}
#' @return A \code{data.frame} containing the raw result from DisGeNET
#' @examples
#' \dontrun{
#' #Being x an DataGeNET.RDF
#' qr <- extract(x) 
#' }
#' @export
setMethod( "extract",
           signature = "DataGeNET.RDF",
           definition = function( object ) {
             return( object@qresult )
           }
)

#' Class DataGeNET.DGN
#'
#' Class \code{DataGeNET.DGN} is one of the two objects used in \code{disgenet2r}
#' package. It is the main data container to using the different functions to
#' query DisGeNET database and generate their output.
#'
#' @name DataGeNET.DGN-class
#' @rdname DataGeNET.DGN-class
#' @exportClass DataGeNET.DGN
#' @slot type type of query: \code{'gene-disease'} or  \code{'variant-disease'}
#'  or \code{'disease-gene'},  or \code{'disease-variant'} or \code{'disease-disease'} or \code{'disease-enrichment'}.
#' @slot search Character containing \code{'single'} of \code{'list'}.It is
#' used to perform the correct query to DisGeNET
#' @slot database Character containing the name of the database that will be
#' queried. It can take the values
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use GENOMICS England;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @slot scoreRange the disGeNET score range to retrieved the GDAs or VDAs
#' @slot term Character with the term(s) to search into the database(s).
#' @slot qresult \code{data.frame} with the obtained result
#' @seealso disease2gene, gene2disease, DataGeNET.DGN-methods


setClass( "DataGeNET.DGN",
          representation =
              representation( type       = "character",  # type of query
                              search     = "character",  # single or list
                              database   = "character",  # where to search
                              scoreRange = "character",  # score
                              term       = "character",  # what to search
                              qresult    = "data.frame"  # result
              ),
          prototype =
              prototype( type       = "",
                         search     = "",
                         database   = "",
                         scoreRange = "",
                         term       = "",
                         qresult    = data.frame()
              )
)

#' Class DataGeNET.RDF
#'
#' Class \code{DataGeNET.RDF} is the basic object generated when RDF is needed.
#' It can be passed to other disgenet2r package functions.
#'
#' @name DataGeNET.RDF-class
#' @rdname DataGeNET.RDF-class
#' @exportClass DataGeNET.RDF
#' @slot input Character containing \code{'ontology'}, \code{'phenotype'} or
#' \code{'disease'}. used as input to the query.
#' @slot search Character containing \code{'ontology'},  \code{'phenotype'} or
#' \code{'disease'} it is looking for.It is used to perform the correct query
#' @slot database Character containing the name of the database that will be
#' queried. It can take the values
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use GENOMICS England;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @slot scoreRange the disGeNET score range to retrieved the GDAs/VDAs
#' @slot selection Character containing the name of the ontoloyg selected
#' @slot mapping Number with the mappings obtained.
#' @slot qresult \code{data.frame} with the obtained result
#' @seealso ontology2disease, disease2ontology, phenotype2disease, disease2phenotype

setClass( "DataGeNET.RDF",
          representation =
            representation( input     = "character",  # disease, ontology, phenotype, gene
                            search    = "character",  # what is looked for
                            database = "character",  # where to search
                            scoreRange = "character", # score
                            selection = "character",  # resource/namespace where the search is performed
                            mapping   = "numeric",    # number of mappings
                            qresult   = "data.frame"  # result
            ),
          prototype =
            prototype( input     = "",
                       search    = "",
                       database = "",
                       scoreRange = "",
                       selection = "",
                       mapping   = 0,
                       qresult   = data.frame()
            )
)

#' Query for given pathway(s) and generates an \code{DataGeNET.RDF}
#'
#' Given the WikiPathway ID of a pathway in WikiPathways, it retrieves the genes in DisGeNET,
#' and the diseases associated to those genes. It creates an object of type \code{DataGeNET.RDF}.
#'
#' @param WikiPathways ID
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param score A vector with two elements: 1) initial value of score 2) final value of score
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to don't see
#' the warnings.
#' @return An object of class \code{DataGeNET.RDF}
#' @examples
#' path2dis <- pathway2disease( pathway = "WP1545" )
#' @export pathway2disease


pathway2disease <-  function(pathway ,   database = "CURATED",    score = c(0,1), verbose = FALSE, warnings = TRUE) {
    # this function, gives you the disease profile from DisGeNET for an specific pathway in WikiPathways
    if (verbose) {
      message(
        "Starting querying WikiPathways for the pathway ID ",
        pathway,
        " and check the intersects with DisGeNET data."
      )
    }
   check_disgenet_sources( database )
   if (substr(pathway, 1, 2) == 'WP' &
       !is.na(as.numeric(substring(pathway, 3)))) {
    WP_ID <- pathway
   } else {
     stop(
       "\nThe pathway ID introduced: '",
       pathway,
       "' is not a valid input.
       Remember that the valid input is: WIKIPATHWAYSID (input as \"WP1545\").
       Please, check that the pathway introduced is a valid WIKIPATHWAYS ID and it is input in the correct format, and try again.\n\n"
     )
   }
    DB_ID <- "\"\""
    if (database == "CURATED") {
      DB_ID <- toupper(" \"uniprot|ctd_human|clinvar|orphanet|CLINGEN|GENOMICS_ENGLAND|CGI|psygenet\" ")
    }
    else if (database == "ANIMAL_MODELS") {
      DB_ID <- toupper("\"ctd_mouse|mgd|ctd_rat|rgd\"")
    }
    else if (database == "ALL") {
      DB_ID <- "\"\""
    }
    else{
      DB_ID <- paste0("\"", toupper(database), "\"")
    }

    if(length(score) != 2) {
      stop("Invalid argument 'score'. It must have two elements: initial value of the score, and final value of the score")
    }



    # endpoint
    endpoint <- "http://rdf.disgenet.org/sparql/"

    query <- "PREFIX wp:<http://vocabularies.wikipathways.org/wp#>

    SELECT DISTINCT ?pathwayid str(?pathwayName) as ?pathwayName
    ?geneid str(?geneSymbol) as ?geneSymbol str(?geneName) as ?geneName
    ?diseaseid str(?diseaseName) as ?diseaseName ?score ?source
    WHERE {
      # Query WikiPathways for pathway-gene
      SERVICE <http://sparql.wikipathways.org/sparql> {
        ?pathwayid dc:identifier <http://identifiers.org/wikipathways/%s>;
        dc:title ?pathwayName .
        ?geneProduct a wp:GeneProduct ;
        dcterms:isPartOf ?pathwayid ;
        rdfs:label ?geneLabel ;
        wp:bdbEntrezGene ?gene .
      }
      ?gda sio:SIO_000628 ?gene,?disease;
      sio:SIO_000216 ?scoreIRI;
      sio:SIO_000253 ?source .
      ?gene rdf:type ncit:C16612 ;
      dcterms:identifier ?geneid;
      sio:SIO_000205 ?gSymbol;
      dcterms:title ?geneName .
      ?gSymbol dcterms:title ?geneSymbol .
      ?disease rdf:type ncit:C7057 ;
      dcterms:identifier ?diseaseid;
      dcterms:title ?diseaseName .
      ?scoreIRI sio:SIO_000300 ?score .
      FILTER (?score >= %f && ?score<= %f)
    FILTER regex( ?source, %s )
    }
    ORDER BY ASC(?diseaseName)"


  query <- sprintf(query, WP_ID, score[1],score[2],DB_ID)
  # print(    query)
    # SPARQL query
    # perform the SPARQL query to DisGeNET

    prefix <-
      c(
        "sio",
        "http://semanticscience.org/resource/",
        "skos",
        "http://www.w3.org/2004/02/skos/core#"
      )
    message(
      "Performing the query. This is a federated query with WikiPathways and may take some time, please wait..."
    )
    res <- tryCatch({
      #print(query)
      SPARQL(url = endpoint, query = query, ns = prefix)
    },
    error = function(err) {
      print(paste0("The query did not work. The error: "), err)
    })
    if (length(res$results) == 0) {
      warning(
        "The pathway input with ID ",
        pathway,
        " does not have disease gene(s) in the DisGeNET database."
      )
    }
    else{
      scR <- paste0( score[1],"-", score[2])

      results <- res$result
      results <- getFormattedDataFrame(results)
      result <- new(
        "DataGeNET.RDF",
        input     = pathway,
        search    = "disease",
        database = database,
        scoreRange = scR,
        selection = "wikipathways",
        mapping   = nrow(results),
        qresult   = results
      )
      return(result)
    }
  }

#' Query for a disease or a list of diseases and generates an \code{DataGeNET.RDF}
#'
#' Given a disease or a list of diseases, retrieves the GO BP of the gene products
#' associated to the disease(s) and creates an object of type \code{DataGeNET.RDF}.
#'
#' @param disease a CUI or a vector of CUIs
#' @param database Name of the database that will be queried.
#' It can take the values \code{'CTD_human'} to use Comparative
#' Toxicogenomics Database, human data; \code{'UNIPROT'} to use Universal
#' Protein Resource;\code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype; \code{'GWASCAT'} to use
#' the NHGRI-EBI GWAS Catalog; \code{'ORPHANET'}, to use
#' Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'RGD'}, to use Rat Genome Database; \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'PREDICTED'} to use the expert curated, animal models data;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param score A vector with two elements: 1) character with greather
#' \code{'>'} or with lower \code{'<'} meaing greather or equal and lower or
#' equal; 2) the score to be compared. By default: \code{c('>', 0)}.
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to don't see
#' the warnings.
#' @return An object of class \code{DataGeNET.RDF}
#' @examples
#' disease2bp <- disease2molecularfunction( disease = "C1859062" )
#' @export disease2molecularfunction


disease2molecularfunction <- function( disease, vocabulary = "umls", database = "CURATED", score = c(0,1), verbose = FALSE, warnings = TRUE ) {
  check_disgenet_sources(database);

  if(length(score) != 2) {
    stop("Invalid argument 'score'. It must have two elements: initial value of the score, and final value of the score")
  }
  gdas <- disease2gene(disease, vocabulary= "UMLS", database =  database , score = score)
  genes <- unique(gdas@qresult$geneid)
  message(paste0("There are ",length(genes) ," genes to be queried on the
                 Wikidata SPARQL endopoint which may take some time, please wait..."));



  results <- data.frame()
  for (gene in genes ){
    if( verbose ) {
      message(
        "Retrieving data for gene ", gene, " from Wikidata"
      )
    }

    g2mf <- gene2molecularfunction(gene = gene )
    if(!is.null(g2mf)){
      results <- rbind(results, g2mf@qresult)
    } else{
      warning(paste0("There were no annotations for ", gene, " in Wikidata"))
    }
  }


  if (dim(results)[1] > 0){
    result <- new( "DataGeNET.RDF",
                   input     = as.character(disease),
                   search    = "GOMF",
                   selection = "disease",
                   mapping   = nrow(results),
                   qresult   = results
    )
    return( result )
  }else {
    if( verbose ) {
      message("The genes associated to disease ", disease, " have no annotations in Wikidata.")
    }
  }

}

#' Obtain the number of unique genes in a \code{DataGeNET.DGN}.
#'
#' @name ngene
#' @rdname ngene-methods
#' @aliases DataGeNET.DGN-methods
#' @param object Object of class \code{DataGeNET.DGN}
#' @return The number of unique genes
#' @examples
#' \dontrun{
#' #Being x an DataGeNET.DGN
#' nd <- ngene(x) # Get number of unique genes
#' }
#' @export
setMethod( "ngene",
  signature = "DataGeNET.DGN",
  definition = function( object ) {
    return( length( unique( object@qresult$geneid ) ) )
  }
)

#' Retrieves DisGeNET data version
#' @examples
#' dgn_version <- get_disgenet_version()
#' @export get_disgenet_version


get_disgenet_version <- function() {
  url <- paste0( get_url_disgenet(), "version/")
  #x = RCurl::getURL(url)
  #x <- jsonlite::fromJSON(x)
  r <- httr::GET(url)
  r <- httr::content(r, "text", encoding = "UTF-8")
  r <- gsub('\\"', " ", r)
  print(r)
}

#' Plots the content of a \code{DataGeNET.DGN} object.
#' This functions allows to create a variety of plots for \code{DataGeNET.DGN} objects.
#'
#' @name plot
#' @rdname plot-methods
#' @aliases DataGeNET.DGN-methods
#'
#' @param x Object of class \code{DataGeNET.DGN}
#' @param y NOT USED
#' @param layout Function to design the location of the different nodes. By
#' default \code{layout.fruchterman.reingold} from \code{igraph} is used.
#' @param class Type of the drawn chart. By default it is \code{"network"} but
#' it also can be \code{"Piechart"}, \code{"DiseaseClass"}, \code{"Venn"}
#' \code{"Heatmap"}, \code{"ProteinClass"}, \code{"Barplot"}, or \code{"Lollipop"}.
#' @param verbose By default \code{FALSE}. If set to \code{TRUE} information
#' on the drawing process will be shown.
#' @param ... Passed to inner functions for different plots.
#' @return A plot for \code{DataGeNET.DGN}.
#' @examples
#' \dontrun{
#' Being x an DataGeNET.DGN
#' qr <- plot(x) # Get number of unique diseases
#' }
#' @export plot

setMethod(
  f = "plot",
  signature = "DataGeNET.DGN",
  definition = function( x, y, ... ) {
    plot_disgenet( x, ... )
  }
)


plot_disgenet <- function( object, layout = "layout.fruchterman.reingold", class = "Network",
                          prop = 1, limit = 50, verbose = FALSE, cutoff = 0, count = 1,
                          showGenes =F, nboot=100 , nchars=30, interactive=F, pvalue=F, ncores=1) {

  if(dim(object@qresult)[1] == 0 ) {
    stop( "Empty object!" )
  }

  if( !class %in% c( "Network",  "Heatmap", "DiseaseClass",  "ProteinClass", "Barplot", "Venn", "Diseasome", "Piechart", "Enrichment", "Lollipop" ) ) {
    stop( "Invalid content of argument 'class'." )
  }

  if (class == "Network" ){
    if( object@type %in%  c("gene-disease", "disease-gene")) {
      plot_gda_network( search = object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop , limit = limit, interactive= interactive)
    }
    else if( object@type %in%  c("variant-disease", "disease-variant")) {
      if (showGenes == T){
        plot_vgda_network( search = object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop , interactive = interactive )
      }
      else {
        plot_vda_network( search = object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop, interactive = interactive  )
      }
    }
    else if( object@type %in%  c("disease-disease-gene", "disease-disease-variant")) {
        # if(object@search == "single"){
        #   plot_dis_comorbidity( search= object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose ,  prop = prop, limit = limit)
        # }
        # else if(object@search == "list") {
          plot_dis_comorbidity( search= object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose ,  prop = prop, limit = limit, interactive = interactive )
        #}
    }
    else{
      stop( "Invalid content of argument 'type' for class = 'Network'." )
    }
  }
  if (class == "Heatmap" ){
    if( object@type %in%  c("variant-disease", "disease-variant") & object@search == "list") {
      plot_variant_disease_heatmap( type= object@type, search= object@search, input = object@qresult,nchars = nchars, cutoff = cutoff, verbose = verbose, limit = limit )
    }
    else if( object@type %in%  c("gene-disease", "disease-gene")) {
      plot_gda_heatmap( type= object@type, search= object@search, input = object@qresult, cutoff = cutoff, nchars=nchars, verbose = verbose, limit = limit )    }
    else if( object@type %in%  c("disease-disease-gene", "disease-disease-variant")) {
      plot_dda_network( search = object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop , limit = limit)
    }
    else{
      stop( "Invalid content of argument 'type' for class = 'Heatmap'." )
    }
  }
  if (class == "DiseaseClass" ){
    if( object@type %in%  c("variant-disease")) {
      if (object@search == "single"){
        plot_disease_class( search = object@search, type = object@type, input = object@qresult, nchars = nchars, layout = layout, verbose = verbose, prop = prop )
      }
      else if (object@search == "list"){
        plot_gda_heatmap_DiseaseClass( type= object@type, search= object@search, input = object@qresult, nchars=nchars, verbose = verbose, limit = limit)
      }
    }
    else if( object@type %in%  c("gene-disease")) {
      if (object@search == "single"){
        plot_disease_class( search= object@search, type = object@type, input = object@qresult, layout = layout, nchars=nchars,  verbose = verbose, prop = prop )
      }
      else if (object@search == "list"){
        plot_gda_heatmap_DiseaseClass( search = object@search, type = object@type, input = object@qresult, nchars=nchars, verbose = verbose)
      }
    }
    else if( object@type %in%  c("disease-disease-gene", "disease-disease-variant")) {
      plot_disease_class( search = object@search, type = object@type, input = object@qresult, layout = layout, nchars= nchars, verbose = verbose, prop = prop)
    }
    else{
      stop( "Invalid content of argument 'type' for class = 'DiseaseClass'." )
    }
  }
  if (class == "ProteinClass" ){
    if( object@type %in%  c("variant-disease")) {
      stop( "Invalid object for Protein class!" )
    }
    else if( object@type %in%  c("disease-gene")) {
      if (object@search == "single"){
        plot_gda_Panther(  search= object@search, input = object@qresult, layout = layout, verbose = verbose )
      }
      else if (object@search == "list"){
        plot_gda_heatmapPanther(  type= object@type, search= object@search, input = object@qresult, nchars =nchars, verbose = verbose )
      }
    }
    else if( object@type %in%  c("disease-disease-gene", "disease-disease-variant")) {
      stop( "Invalid object for Protein class!" )
    }
    else{
      stop( "Invalid content of argument 'type' for class = 'ProteinClass'." )
    }
  }
  else if( class == "Barplot" ) {
    if( ! object@type %in%  c("disease-disease-gene", "disease-disease-variant")) {
      stop( "Invalid object for Barplot!" )
    }
    plot_barplot(  type = object@type, search= object@search, input = object@qresult, verbose = verbose, limit = limit )
  }

  else if( class == "Venn" ) {
    if( ! object@type %in%  c("disease-disease-gene", "disease-disease-variant")) {
      stop( "Invalid object for Barplot!" )
    }
    plot_venn(  type= object@type, search= object@search, input = object@qresult, verbose = verbose, database= object@database )
  }
  else if (class == "Diseasome" ){
    if( ! object@type %in%  c("disease-disease-gene", "disease-disease-variant")) {
      stop( "Invalid object for Barplot!" )
    }
    plot_diseasome( search= object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose ,  prop = prop, limit = limit,  database= object@database, pvalue = pvalue, nboot = nboot, interactive = interactive , cutoff = cutoff, ncores = ncores )

  }
  else if (class == "Enrichment"){
    if( ! object@type %in%  c("disease-enrichment")) {
      stop( "Invalid object for plot Enrichment!" )
    }
    plot_enrichment( input = object@qresult, count = count,  cutoff = cutoff ,nchars = nchars, limit = limit )
  }
}

# plot_variant_gene( search = object@search, type = object@type, input = object@qresult, layout = layout, verbose = verbose, prop = prop )

######
plot_gda_network <- function( input, type, layout, prop, search, verbose ,  limit, interactive) {
  edges <- data.frame( input[ , c("gene_symbol", "disease_name") ])
  diseases <- unique( input$disease_name )
  netw  <- igraph::graph.data.frame( edges, directed = FALSE )
  netw  <- igraph::simplify( netw )
  #lay   <- layout( netw )
  lay <- apply_layout(layout, netw)
  if( verbose ) {
    message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
  }


  if( search == "list" ) {
    ttl <- "Gene-Disease Network"
  }else if ( search == "single" ){
    if ( type == "disease-gene"){
      ttl <- paste0( "Genes associated to ", input$disease_name[ 1 ]  )
    }else if ( type == "gene-disease"   ){
      ttl <- paste0( "Diseases associated to ", input$gene_symbol[ 1 ] )
    }
    else{
      ttl <- ""
      show( paste0("warning: ",type , " not correct" ))
    }
  }

  if (interactive == F){
  igraph::plot.igraph( netw,
                       vertex.frame.color  = "white",
                       layout              = lay,
                       vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "royalblue2", "#ff349a" ),
                       vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                       vertex.frame.color  = 'blue', #the color of the border of the dots
                       vertex.label.color  = 'black',#the color of the name labels
                       vertex.label.font   = 0,      #the font of the name labels
                       vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                       edge.color          = "darkgrey",
                       edge.width          = 1 + ( prop * input$score ),
                       edge.arrow.size     = 0.5,
                       vertex.size         = 15,
                       vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                       main                = ttl
  )
  }else if (interactive == TRUE){
    igraph::tkplot(netw,  vertex.frame.color  = "white",
                   layout              = lay,
                   vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "royalblue2", "#ff349a" ),
                   vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                   vertex.frame.color  = 'blue', #the color of the border of the dots
                   vertex.label.color  = 'black',#the color of the name labels
                   vertex.label.font   = 0,      #the font of the name labels
                   vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                   edge.color          = "darkgrey",
                   edge.width          = 1 + ( prop * input$score ),
                   edge.arrow.size     = 0.5,
                   vertex.size         = 15,
                   vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                   main                = ttl
    )
  }
}

plot_vda_network<- function( input, type, layout, prop, search, verbose, interactive ) {

  input <- unique(input[c("score", "diseaseid", "disease_name", "variantid")])
  l <- length(unique(input$variantid))
  input$score <- as.numeric(as.character(input$score))
  input <-  aggregate(score ~ diseaseid + disease_name + variantid, input , max)
  if(l > 1 ) {
    ttl <- "Variant-Disease Network"
  }else if ( l == 1 ){
    ttl <- paste0( "Diseases associated to ", input$variantid[ 1 ] )
  }

  edges <- data.frame( input[ , "disease_name"], input[ , "variantid"] )
  netw  <- igraph::graph.data.frame( edges, directed = FALSE )
  netw  <- igraph::simplify( netw )
  #lay   <- layout( netw )
  lay <- apply_layout(layout, netw)

  diseases <- unique( input$disease_name )
  if (interactive == F){
    igraph::plot.igraph( netw,
                         vertex.frame.color  = "white",
                         layout              = lay,
                         vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "royalblue2", "goldenrod3" ),
                         vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                         vertex.frame.color  = 'blue', #the color of the border of the dots
                         vertex.label.color  = 'black',#the color of the name labels
                         vertex.label.font   = 0,      #the font of the name labels
                         vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                         edge.color          = "darkgrey",
                         edge.width          = 1 + ( prop * input$score ),
                         edge.arrow.size     = 0.5,
                         vertex.size         = 15,
                         vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                         main                = ttl
    )
  } else {
    igraph::tkplot( netw,
                    vertex.frame.color  = "white",
                    layout              = lay,
                    vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "royalblue2", "goldenrod3" ),
                    vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                    vertex.frame.color  = 'blue', #the color of the border of the dots
                    vertex.label.color  = 'black',#the color of the name labels
                    vertex.label.font   = 0,      #the font of the name labels
                    vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                    edge.color          = "darkgrey",
                    edge.width          = 1 + ( prop * input$score ),
                    edge.arrow.size     = 0.5,
                    vertex.size         = 15,
                    vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                    main = ttl)
  }
}

plot_vgda_network<- function( input, type, layout, prop, search, verbose, interactive  ) {

  results <- unique(input[c("score", "variantid",  "disease_name", "gene_symbol")])
  #input <- data.frame(lapply(input, as.character), stringsAsFactors=FALSE)
  l <- length(unique(input$variantid))

  #input[input$c0.score < 0.01,"c0.score" ] <- 0.09
  results <- tidyr::separate_rows(results, gene_symbol, sep = ",")
  nd <- length(unique(subset(results, gene_symbol!="")$variantid))
  results <- subset(results, gene_symbol!="")

  results$score <- as.numeric(as.character(results$score))
  aa <-  aggregate(score ~  gene_symbol +variantid , results , max)
  bb <-  aggregate(score ~ disease_name +variantid , results , max)
  cc <- unique(input[c("disease_name", "gene_symbol",  "score")])
  colnames(aa) <- c("A1", "A2", "score")
  colnames(bb) <- c("A1", "A2", "score")
  colnames(cc) <- c("A1", "A2", "score")

  results <- rbind(aa,bb)
  results <- rbind(results,cc)

  if( l > 1 ) {
    ttl <- "Variant-Gene-Disease Network"
  }else if ( l == 1 ){
    ttl <- paste0( "Variant-Gene-Disease Network for ", results$variantid[ 1 ] )
  }
  results <- subset( results, !is.na(A1) & !is.na(A2))
  edges <- data.frame( results[ ,1], results[ , 2] )
  netw  <- igraph::graph.data.frame( edges, directed = FALSE )
  netw  <- igraph::simplify( netw )
  #lay   <- layout( netw )
  lay <- apply_layout(layout, netw)
  genes <- unique( input$gene_symbol )
  diseases <- unique( input$disease_name )
  variants <- unique( input$variantid )
 if(interactive == F){
  igraph::plot.igraph( netw,
                       vertex.frame.color  = "white",
                       layout              = lay,
                       vertex.color        = ifelse( igraph::V( netw )$name %in% genes, "#ff349a" , ifelse(igraph::V( netw )$name %in% diseases, "royalblue2", "goldenrod3")),
                       vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                       vertex.frame.color  = 'blue', #the color of the border of the dots
                       vertex.label.color  = 'black',#the color of the name labels
                       vertex.label.font   = 0,      #the font of the name labels
                       vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                       edge.color          = "darkgrey",
                       edge.width          = 1 + ( prop * results$score ),
                       edge.arrow.size     = 0.5,
                       vertex.size         = 15,
                       vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                       main                = ttl
  )
 } else {
   igraph::tkplot( netw,
                        vertex.frame.color  = "white",
                        layout              = lay,
                        vertex.color        = ifelse( igraph::V( netw )$name %in% genes, "#ff349a" , ifelse(igraph::V( netw )$name %in% diseases, "royalblue2", "goldenrod3")),
                        vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                        vertex.frame.color  = 'blue', #the color of the border of the dots
                        vertex.label.color  = 'black',#the color of the name labels
                        vertex.label.font   = 0,      #the font of the name labels
                        vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                        edge.color          = "darkgrey",
                        edge.width          = 1 + ( prop * results$score ),
                        edge.arrow.size     = 0.5,
                        vertex.size         = 15,
                        vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                        main                = ttl
   )
 }
}



plot_dis_comorbidity <- function( input, type, layout, search, verbose, prop, limit, interactive ) {

  # if( type != "disease-disease-gene" | type !="disease-disease-variant" ) {
  #   stop("For this type of chart, objects created with disease2disease_by_gene function is required." )
  # }
  if( type == "disease-disease-gene"){
    input$common <- input$ngenes
    ds1 <- input[,c( "disease1_name", "ngenes1" ) ]
    colnames( ds1 ) <- c("dis", "gen")
    ds2 <- input[, c("disease2_name", "ngenes2") ]
    colnames( ds2 ) <- c("dis", "gen")
  }
  else if(type == "disease-disease-variant"){
    input$common <- input$nvariants
    ds1 <- input[,c( "disease1_name", "nvariants1" ) ]
    colnames( ds1 ) <- c("dis", "gen")
    ds2 <- input[, c("disease2_name", "nvariants2") ]
    colnames( ds2 ) <- c("dis", "gen")
  }
  else {
    stop("For this type of chart, objects created with **disease2disease_by_gene** or **disease2disease_by_variant** functions is required.")
  }


  a <- nrow(input)
  if (dim(input)[1]> limit){
    input <- input[c(1:limit),]
    show( paste0("warning: dataframe of ", a , " rows has been reduced to ", limit, " rows." ))
  }
  edges <- data.frame( input[ c("disease1_name", "disease2_name")] )
  netw  <- igraph::graph.data.frame( edges, directed = FALSE )
  netw  <- igraph::simplify( netw )
  #lay   <- layout(netw)
  lay <- apply_layout(layout = layout, netw = netw)

  if( verbose ) {
    message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
  }

  dn1 <- unique(input$disease1_name)
  if (length(dn1) == 1){
    ttl <- paste0( "Disease-Disease Network" )
  }   else{
    ttl <- paste0( "Disease-Disease Network" )
  }



  fnl <- rbind ( ds1, ds2)
  fnl <- fnl[!duplicated(fnl), ]

  sizes <- as.numeric( fnl[ , 2 ] )
  names( sizes ) <- fnl[ , 1 ]

  if (interactive == F){
  igraph::plot.igraph( netw,
                       vertex.frame.color  = "white",
                       layout              = lay,
                       vertex.color        = ifelse( igraph::V( netw )$name %in% ds1$dis, "royalblue2", "#b4daff" ),
                       vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                       vertex.frame.color  = 'blue', #the color of the border of the dots
                       vertex.label.color  = 'black',#the color of the name labels
                       vertex.label.font   = 0,      #the font of the name labels
                       vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                       edge.color          = "black",
                       edge.width          = prop * (as.numeric( input$commonGenes ))^1/2,
                       edge.arrow.size     = 0.5,
                       vertex.size         = prop *30*log2(as.numeric(sizes[ igraph::V( netw )$name ])+1),
                       vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                       main                = ttl
  ) } else {
    igraph::tkplot( netw,
                         vertex.frame.color  = "white",
                         layout              = lay,
                         vertex.color        = ifelse( igraph::V( netw )$name %in% ds1$dis, "royalblue2", "#b4daff" ),
                         vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                         vertex.frame.color  = 'blue', #the color of the border of the dots
                         vertex.label.color  = 'black',#the color of the name labels
                         vertex.label.font   = 0,      #the font of the name labels
                         vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                         edge.color          = "black",
                         edge.width          = 3,
                         edge.arrow.size     = 0.5,
                         vertex.size         = prop *30*log2(as.numeric(sizes[ igraph::V( netw )$name ])+1),
                         vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                         main                = ttl
    )
  }
}

#
# plot_dis_dis_associations <- function( input, type, layout, search, verbose, prop, limit, database ) {
#
#   # if( search != "dis-dis" ) {
#   #   stop("For this type of chart, objects comming from disgenetDisDis function is required." )
#   # } else  if( type != "disease" ) {
#   #   stop("For this type of chart, objects comming from disgenetDisDis function is required." )
#   # }
#   l <- unique(input$disease1_name)
#   if (length(l) == 1){
#     stop("For this type of chart, objects generated with disease2disease_by_gene, or disease2disease_by_variant
#          function, and search = list, are required ." )
#   }
#
#   if( type == "disease-disease-gene"){
#     input$common <- input$ngenes
#     disNum <- length ( unique ( input$diseaseid1) )
#     diseases <- as.character(unique (  input$diseaseid1) )
#
#     res <- disease2gene(disease = diseases,
#                         database = as.character(database))
#     res <- res@qresult
#     pairs <- ( disNum *  disNum - disNum ) / 2
#     tb <- as.data.frame(setNames(replicate(7,numeric(0), simplify = F), c("disease1","NameDisease1", "disease2","NameDisease2", "NGenes1", "NGenes2", "intr")))
#     cnt <- 1
#     for ( i in 1:disNum){
#       dis1 <- diseases[i]
#       nd1 <- as.character (  res[res[,"diseaseid"]==diseases[i],"disease_name"][1]  )
#       gen1 <- unique( subset(res, diseaseid == dis1 )$geneid)
#       for ( j in 2:disNum){
#         if ( i < j){
#           dis2 <- diseases[j]
#           nd2 <- as.character (  res[res[,"diseaseid"]==diseases[j],"disease_name"][1]  )
#           gen2 <- unique( subset(res, diseaseid == dis2 )$geneid)
#           tb[ cnt, ] <- c(diseases[ i ], nd1, diseases[ j ],nd2, length( gen1 ), length( gen2 ), length( intersect( gen1, gen2 ) ))
#           cnt <- cnt + 1
#         }
#       }
#     }
#   }
#   else if(type == "disease-disease-variant"){
#     input$common <- input$nvariants
#     disNum <- length ( unique ( input$diseaseid1) )
#     diseases <- as.character(unique (  input$diseaseid1) )
#
#     res <- disease2variant(disease = diseases,
#                            database = as.character(database))
#     res <- res@qresult
#     pairs <- ( disNum *  disNum - disNum ) / 2
#     tb <- as.data.frame(setNames(replicate(7,numeric(0), simplify = F), c("disease1","NameDisease1", "disease2","NameDisease2", "NGenes1", "NGenes2", "intr")))
#     cnt <- 1
#     for ( i in 1:disNum){
#       dis1 <- diseases[i]
#       nd1 <- as.character (  res[res[,"diseaseid"]==diseases[i],"disease_name"][1]  )
#       gen1 <- unique( subset(res, diseaseid == dis1 )$variantid)
#       for ( j in 2:disNum){
#         if ( i < j){
#           dis2 <- diseases[j]
#           nd2 <- as.character (  res[res[,"diseaseid"]==diseases[j],"disease_name"][1]  )
#           gen2 <- unique( subset(res, diseaseid == dis2 )$variantid)
#           tb[ cnt, ] <- c(diseases[ i ], nd1, diseases[ j ],nd2, length( gen1 ), length( gen2 ), length( intersect( gen1, gen2 ) ))
#           cnt <- cnt + 1
#         }
#       }
#     }
#   }
#
#
#   tb <- tb[tb[,"intr"]>0 ,]
#   finaldiseases <- unique( c(as.character(tb$disease1), as.character(tb$disease2)))
#   #   if (dim(input)[1]> limit){
#   #     input <- input[c(1:limit),]
#   #     show( paste0("warning: dataframe of ", a , " rows has been reduced to ", limit, " rows." ))
#   #   }
#   edges <- data.frame( tb[ , "NameDisease1" ], tb[ , "NameDisease2" ] )
#   netw  <- graph.data.frame( edges, directed = FALSE )
#   netw  <- simplify( netw )
#   lay   <- layout(netw)
#
#   if( verbose ) {
#     message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
#   }
#
#   ttl <- paste0( "Disease-Disease Network" )
#
#   if( type == "disease-disease-gene"){
#     ds1 <- input[,c( "disease1_name", "disease1_ngenes" ) ]
#     colnames( ds1 ) <- c("dis", "gen")
#     ds2 <- input[, c("disease2_name", "disease2_ngenes") ]
#     colnames( ds2 ) <- c("dis", "gen")
#   }
#   else if ( type == "disease-disease-variant"){
#     ds1 <- input[,c( "disease1_name", "disease1_nvariants" ) ]
#     colnames( ds1 ) <- c("dis", "gen")
#     ds2 <- input[, c("disease2_name", "disease2_nvariants") ]
#     colnames( ds2 ) <- c("dis", "gen")
#   }
#
#   fnl <- rbind ( ds1, ds2)
#   fnl <- fnl[!duplicated(fnl), ]
#
#   sizes <- as.numeric( fnl[ , 2 ] )
#   names( sizes ) <- fnl[ , 1 ]
#
#   igraph::plot.igraph( netw,
#                        vertex.frame.color  = "white",
#                        layout              = lay,
#                        vertex.color        =  "royalblue2" ,
#                        vertex.label.dist   = 0,      #puts the name labels slightly off the dots
#                        vertex.frame.color  = 'blue', #the color of the border of the dots
#                        vertex.label.color  = 'black',#the color of the name labels
#                        vertex.label.font   = 0,      #the font of the name labels
#                        vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
#                        edge.color          = "black",
#                        edge.width          = prop * (as.numeric( input$ngenes ))^1/2,
#                        edge.arrow.size     = 0.5,
#                        # vertex.size         = 10,
#                        vertex.size         = prop *30*log2(as.numeric(sizes[ igraph::V( netw )$name ])+1),
#                        vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
#                        main                = ttl
#   )
# }

##################################################################
## HEATMAP
##################################################################

plot_variant_disease_heatmap <- function( type, search, input,nchars, cutoff, limit, verbose ) {

  if( search == "single" ) {
    stop( "For this type of chart, a multiple query created with 'variant2disease'is required. " )
  }

  if( type == "variant-disease" ) {
    results <- unique( input[ , c( "diseaseid","disease_name", "variantid","score" ) ] )

    results <- results [ results$score>= cutoff, ]
    results <- results [ with ( results , order(-score)), ]
    if ( dim( results )[ 1 ] > limit ){
      results <- results[ 1:limit ,]
      show( paste0("Dataframe of ", nrow(input), " rows has been reduced to ", limit, " rows." ))
    }
    results$disease_name <- as.character(results$disease_name)
    for( i in 1:nrow(results)){

      if(nchar(as.character(results$disease_name[i])) > nchars){
        rename <- substr(results$disease_name[i], 1, nchars)
        results$disease_name[i] <- paste0(rename, "...")
      }
    }
    casted_tt <- reshape::cast( results, variantid ~disease_name, value= "score", length )
    l <- dim( casted_tt )[ 2 ]
    casted_tt[ is.na( casted_tt ) ] <- 0
    res <- hclust( dist( casted_tt[ 2:l ] ),  method = "ward.D")
    casted_tt$clus <- cutree( res, k = 5 )
    ordered <- casted_tt[order(casted_tt$clus), "variantid"]

    #results$diseaseName  <- factor(results$diseaseName , levels= as.factor(ordered))
    results$variantid  <- factor(results$variantid , levels= as.factor(ordered))

    p<- ggplot2::qplot( x = variantid, y = disease_name, data= results , fill = score, geom = "tile" ) +
      ggplot2::ylab( "Diseases" ) + ggplot2::xlab( "Variants" ) +
      ggplot2::ggtitle( "Variant-Disease Heatmap") +
      ggplot2::scale_fill_gradient2(low = "#0000FF", high ="#2f30c9",guide = "colourbar", "Score") +
      ggplot2::theme ( axis.text = ggplot2::element_text ( size = 9),
                       axis.title=ggplot2::element_text(size=10 ),
                       panel.background = ggplot2::element_rect(fill="white", colour = "black"),
                       text = ggplot2::element_text(size = 11),
                       axis.text.x = ggplot2::element_text(angle=45, size = 11, hjust = 1)
      )
    print(p)

  } else  if( type == "disease-variant" ) {

    results <- unique( input[ , c( "diseaseid","disease_name", "variantid","score" ) ] )

    results <- results [ results$score>= cutoff, ]
    if ( dim( results )[ 1 ] > limit ){
      results <- results[ 1:limit ,]
      show( paste0("warning: dataframe of ", nrow(input), " rows has been reduced to ", limit, " rows." ))
    }

    #       for( i in 1:nrow(results)){
    #
    #         if(nchar(as.character(results$c1.name[i])) > 30){
    #           rename <- substr(results$c1.name[i], 1, 30)
    #           results$c1.name[i] <- paste0(rename, "...")
    #         }
    #       }

    casted_tt <- reshape::cast( results, disease_name~variantid, value= "score", length )

    l <- dim(casted_tt)[2]
    casted_tt[is.na( casted_tt)] <- 0
    res <- hclust(dist(casted_tt[2:l]),  method = "ward.D")
    mm<-max(res$order)
    if (mm>4){
      casted_tt$clus <- cutree(res, k = 5)
    } else {
      casted_tt$clus <- cutree(res, k = mm)
    }

    ordered <- casted_tt[order(casted_tt$clus), "disease_name"]

    results$disease_name  <- factor(results$disease_name , levels= as.factor(ordered))
    p <- ggplot2::ggplot( results,  ggplot2::aes ( x = disease_name, y = variantid ) )
    p <- p + ggplot2::geom_tile(ggplot2::aes(fill = score), colour = "white")
    p <- p + ggplot2::labs(title = "Variant-Disease Heatmap", x = "Diseases",  y = "Variants")
    p <- p + ggplot2::scale_fill_gradient2(low = "#0000FF", high ="#2f30c9",guide = "colourbar", "Score")
    p <- p + ggplot2::theme ( axis.text = ggplot2::element_text ( size = 9),
                              axis.title=ggplot2::element_text(size=10 ),
                              panel.background = ggplot2::element_rect(fill="white", colour = "black"),
                              text = ggplot2::element_text(size = 11),
                              axis.text.x = ggplot2::element_text(angle=45, size = 11, hjust = 1) )

    print(p)
  }
}
##################################################################
## BARPLOTS
##################################################################
plot_barplot <- function ( input, type, search, verbose, limit ) {

  #input <- input[c(1:20),]
  input$disease1_name <- as.character(input$disease1_name)
  input$disease2_name <- as.character(input$disease2_name)
  #   for( i in 1:nrow(input)){
  #     if(nchar(as.character(input$NameDisease1[i])) > 50){
  #       rename1 <- substr(input$NameDisease1[i], 1, 50)
  #       input$NameDisease1[i] <- paste0(rename1, "...")
  #     }
  #     if(nchar(as.character(input$NameDisease2[i])) > 50){
  #       rename2 <- substr(input$NameDisease2[i], 1, 50)
  #       input$NameDisease2[i] <- paste0(rename2, "...")
  #     }
  #   }

  if (type =="disease-disease-gene"){
    input$common <- as.numeric(input$ngenes)
    input$JaccardIndex <- as.numeric(input$jaccard_genes)
    input <- subset(input, common>0)
    input <- input [ with ( input , order(-common)), ]
  } else if (type =="disease-disease-variant"){
    input$common <- as.numeric(input$nvariants)
    input$JaccardIndex <- as.numeric(input$jaccard_variants)
    input <- subset(input, common>0)
    input <- input [ with ( input , order(-common)), ]
  }


  if (dim(input)[1]> limit){
    input <- input[c(1:limit),]
  }

  input$pairs <- paste(input$disease1_name, input$disease2_name, sep = " - ")
  orderedDiseases <- input[order(-as.numeric(input$common)), "pairs"  ]
  input$pairs <- factor(input$pairs , levels= as.factor(orderedDiseases))

  p <- ggplot2::ggplot (input, ggplot2::aes ( x = pairs, y = as.numeric(common) ), order = as.numeric(commonGenes) ) +
    ggplot2::geom_bar ( stat = "identity", fill = "grey" ) +
    ggplot2::labs ( title = paste0 ( "Disease-Disease Barplot" ) , x = "Disease Pairs", y = "# of shared genes")


  p <- p + ggplot2::theme_classic( ) + ggplot2::theme( plot.margin = grid::unit( x = c ( 5, 15, 5, 15 ), units = "mm" ),
                                                       axis.line = ggplot2::element_line ( size = 0.7, color = "black" ), text = ggplot2::element_text ( size = 14 ) ,
                                                       axis.text.x = ggplot2::element_text ( angle = 45, size = 9, hjust = 1 ))


  p <- p + ggplot2::geom_point(ggplot2::aes(x = pairs , y =as.numeric(JaccardIndex) *100))
  p <- p + ggplot2::geom_text(ggplot2::aes(x = pairs , y =as.numeric(JaccardIndex) *100 + 1), label = c(round(as.numeric(input$JaccardIndex), digits = 3 )), size=3)
  p

}
##################################################################
## VENN
##################################################################
plot_venn <- function( search, type, input, verbose, database ) {

  # if( type != "" ) {
  #   stop("For this type of chart, objects comming from disgenetDisDis function is required." )
  # }

  results <- input
  diseases <- c(unique( as.character(unique(results[, "diseaseid1"]))) )

  if( length(diseases) > 5 | length(diseases) ==1 ) {
    stop( "For this type of chart, the diseases list should have 2-5 diseases" )
  }

  else if (length(diseases) == 2){
    gen1 <- disease2gene(disease = diseases[1] )
    name1 <-as.character(unique(gen1@qresult$disease_name))
    gen1 <- unique(gen1@qresult$gene_symbol)
    gen2 <- disease2gene(disease = diseases[2] )
    name2 <-as.character(unique(gen2@qresult$disease_name))
    gen2 <- unique(gen2@qresult$gene_symbol)

    grid::grid.newpage()
    venn.plot <- VennDiagram::draw.pairwise.venn(
      area1        = length(gen1),
      area2        = length(gen2),
      cross.area   = length(intersect(gen1, gen2)),
      scaled       = T,
      category     = c(name1, name2),
      scales       = TRUE,
      fill         = c("blue", "red"),
      alpha        = 0.3,
      lty          = "blank",
      cex          = 2,
      cat.cex      = 1.5,
      cat.pos      = c(0.5 , 1),
      cat.dist     = 0.04,
      cat.just     = list(c(0.5, 1), c(0.5, 1)),
      ext.pos      = 30,
      ext.dist     = -0.5,
      ext.length   = 0.85,
      ext.line.lwd = 2,
      ext.line.lty = "dashed")
  }
  else if (length(diseases) == 3) {

    gen1 <- disease2gene(disease = diseases[1] )
    name1 <-as.character(unique(gen1@qresult$disease_name))
    gen1 <- unique(gen1@qresult$gene_symbol)
    gen2 <- disease2gene(disease = diseases[2] )
    name2 <-as.character(unique(gen2@qresult$disease_name))
    gen2 <- unique(gen2@qresult$gene_symbol)
    gen3 <- disease2gene(disease = diseases[3] )
    name3 <-unique(gen3@qresult$disease_name)
    gen3 <- unique(gen3@qresult$gene_symbol)

    grid::grid.newpage()
    venn.plot <- VennDiagram::draw.triple.venn(
      area1           = length(gen1),
      area2           = length(gen2),
      area3           = length(gen3),
      n12             = length(intersect(gen1, gen2)),
      n23             = length(intersect(gen2, gen3)),
      n13             = length(intersect(gen1, gen3)),
      n123            = length(intersect(intersect(gen1, gen2), gen3)),
      category        = c(name1, name2, name3),
      fill            = c('red', 'blue', 'green'),
      alpha = c(0.4,0.4,0.4),
      cat.col         = c('red', 'blue', 'green'),
      cat.pos = 1,
      #cex             = c(1/2,2/2,3/2,4/2,5/2,6/2,7/2),
      cex             = 2,
      cat.cex         = c(1.5,1.5,1.5),
      euler           = TRUE,
      euler.d  = TRUE,
      scaled          = TRUE
    )
  }
  else if (length(diseases) == 4) {

    gen1 <- disease2gene(disease = diseases[1] )
    name1 <-as.character(unique(gen1@qresult$disease_name))
    gen1 <- unique(gen1@qresult$gene_symbol)
    gen2 <- disease2gene(disease = diseases[2] )
    name2 <-as.character(unique(gen2@qresult$disease_name))
    gen2 <- unique(gen2@qresult$gene_symbol)
    gen3 <- disease2gene(disease = diseases[3] )
    name3 <-as.character(unique(gen3@qresult$disease_name))
    gen3 <- unique(gen3@qresult$gene_symbol)
    gen4 <- disease2gene(disease = diseases[4] )
    name4 <-as.character(unique(gen4@qresult$disease_name))
    gen4 <- unique(gen4@qresult$gene_symbol)
    grid::grid.newpage()
    venn.plot <- VennDiagram::draw.quad.venn(
      area1  = length(gen1),
      area2  = length(gen2),
      area3  = length(gen3),
      area4  = length(gen4),
      n12    = length(intersect(gen1, gen2)),
      n23    = length(intersect(gen2, gen3)),
      n13    = length(intersect(gen1, gen3)),
      n14 = length(intersect(gen1, gen4)),
      n24= length(intersect(gen2, gen4)),
      n34= length(intersect(gen3, gen4)),
      n123 = length(intersect(intersect(gen1, gen2), gen3)),
      n124 = length(intersect(intersect(gen1, gen2), gen4)),
      n134 = length(intersect(intersect(gen1, gen3), gen4)),
      n234 = length(intersect(intersect(gen2, gen3), gen4)),
      n1234 = length(intersect(intersect(intersect(gen1, gen2), gen3),gen4)),

      category        = c(name1, name2, name3, name4),

      fill = c("dodgerblue", "goldenrod1", "darkorange1", "seagreen3"),
      cat.col = c("dodgerblue", "goldenrod1", "darkorange1", "seagreen3"),
      cat.cex = 2,
      cat.pos = c(-20, 20, 60, 120),
      margin = 0.3,
      cex = 1.5,
      euler           = TRUE,
      scaled          = FALSE
    )
  }
  else if (length(diseases) == 5){

    gen1 <- disease2gene(disease = diseases[1] )
    name1 <-as.character(unique(gen1@qresult$disease_name))
    gen1 <- unique(gen1@qresult$gene_symbol)
    gen2 <- disease2gene(disease = diseases[2] )
    name2 <-as.character(unique(gen2@qresult$disease_name))
    gen2 <- unique(gen2@qresult$gene_symbol)
    gen3 <- disease2gene(disease = diseases[3] )
    name3 <-as.character(unique(gen3@qresult$disease_name))
    gen3 <- unique(gen3@qresult$gene_symbol)
    gen4 <- disease2gene(disease = diseases[4] )
    name4 <-as.character(unique(gen4@qresult$disease_name))
    gen4<- unique(gen4@qresult$gene_symbol)
    gen5 <- disease2gene(disease = diseases[5] )
    name5 <-as.character(unique(gen5@qresult$disease_name))
    gen5<- unique(gen5@qresult$gene_symbol)

    grid::grid.newpage()
    venn.plot <- VennDiagram::draw.quintuple.venn(
      area1  = length(gen1),
      area2  = length(gen2),
      area3  = length(gen3),
      area4  = length(gen4),
      area5 = length(gen5),
      n12 = length(intersect(gen1, gen2)),
      n13 = length(intersect(gen1, gen3)),
      n14 = length(intersect(gen1, gen4)),
      n15 = length(intersect(gen1, gen5)),
      n23 = length(intersect(gen2, gen3)),
      n24 = length(intersect(gen2, gen4)),
      n25 = length(intersect(gen2, gen5)),
      n34 = length(intersect(gen3, gen4)),
      n35 = length(intersect(gen3, gen5)),
      n45 = length(intersect(gen4, gen5)),
      n123 = length(intersect(intersect(gen1, gen2), gen3)),
      n124 = length(intersect(intersect(gen1, gen2), gen4)),
      n125 = length(intersect(intersect(gen1, gen2), gen5)),
      n134 = length(intersect(intersect(gen1, gen3), gen4)),
      n135 = length(intersect(intersect(gen1, gen3), gen5)),
      n145 = length(intersect(intersect(gen1, gen4), gen5)),
      n234 = length(intersect(intersect(gen2, gen3), gen4)),
      n235 = length(intersect(intersect(gen2, gen3), gen5)),
      n245 = length(intersect(intersect(gen2, gen4), gen5)),
      n345 = length(intersect(intersect(gen3, gen4), gen5)),
      n1234 = length(intersect(intersect(intersect(gen1, gen2), gen3),gen4)),
      n1235 = length(intersect(intersect(intersect(gen1, gen2), gen3),gen5)),
      n1245 = length(intersect(intersect(intersect(gen1, gen2), gen4),gen5)),
      n1345 = length(intersect(intersect(intersect(gen1, gen3), gen4),gen5)),
      n2345 = length(intersect(intersect(intersect(gen2, gen3), gen4),gen5)),
      n12345 = length(intersect(intersect(intersect(intersect(gen1, gen2), gen3),gen4), gen5)),
      category        = c(name1, name2, name3, name4, name5),
      fill = c("dodgerblue", "goldenrod1", "darkorange1", "seagreen3", "orchid3"),
      cat.col = c("dodgerblue", "goldenrod1", "darkorange1", "seagreen3", "orchid3"),
      cat.cex = 2,
      margin = 0.05,
      cat.pos =  1,
     # cex = c(1.5, 1.5, 1.5, 1.5, 1.5, 1, 0.8, 1, 0.8, 1, 0.8, 1, 0.8, 1, 0.8,
      #        1, 0.55, 1, 0.55, 1, 0.55, 1, 0.55, 1, 0.55, 1, 1, 1, 1, 1, 1.5),
     cex = 1.5,

      ind = TRUE
    )
  }
  else {
    stop("venn for more than 5 groups not possible! ")
  }
  grid::grid.draw(venn.plot)

}

##################################################################
##################################################################
# plot_variant_gene<- function( input, type, layout, prop, search, verbose ) {
#
#   results <- unique(input[c("variantid",  "gene_symbol")])
#   l <- length(unique(results$variantid))
#   #input <-  aggregate(score ~ geneId + geneSymbol  + snp, input , max)
#   results <- separate_rows(results, gene_symbol, sep = ",")
#   nd <- length(unique(subset(results, gene_symbol!="")$variantid))
#   results <- subset(results, gene_symbol!="")
#
#   if( l > 1 ) {
#     ttl <- "Variant-Gene Network"
#   }else if ( l == 1 ){
#     ttl <- paste0( "Genes associated to ", results$variantid[ 1 ] )
#   }
#   if (nd > 0){
#     show( paste0("warning: ", nd , " variant(s) not shown in the plot" ))
#   }
#
#   edges <- data.frame( results[c("variantid", "gene_symbol")] )
#   netw  <- igraph::graph.data.frame( edges, directed = FALSE )
#   netw  <- igraph::simplify( netw )
#   lay   <- layout( netw )
#   genes <- unique( results$gene_symbol )
#   igraph::plot.igraph( netw,
#                        vertex.frame.color  = "white",
#                        layout              = lay,
#                        vertex.color        = ifelse( igraph::V( netw )$name %in% genes, "#ff349a" , "goldenrod3"),
#                        vertex.label.dist   = 0,      #puts the name labels slightly off the dots
#                        vertex.frame.color  = 'blue', #the color of the border of the dots
#                        vertex.label.color  = 'black',#the color of the name labels
#                        vertex.label.font   = 0,      #the font of the name labels
#                        vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
#                        edge.color          = "darkgrey",
#                        edge.width          = 1 + ( prop  ),
#                        edge.arrow.size     = 0.5,
#                        vertex.size         = 15,
#                        vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
#                        main                = ttl
#   )
# }


plot_disease_class <- function ( input, type, layout, search, nchars, verbose, prop ) {

  if( search == "list" ) {
    stop( "Chart not possible for list. Use instead the plot function with DiseaseClassHeatmap class argument" )
  }
  else if( type == "disease-disease-gene" | type == "disease-disease-variant" ) {

    if (length(unique(input[, "diseaseid1"])) == 1){
      disats <- disease2attribute(disease = unique(c(input$diseaseid1 , input$diseaseid2)))
      disats <- disats@qresult[c("diseaseid", "diseaseclassname")]
      disats$disease_class_name <- disats$diseaseclassname
      disats <- tidyr::separate_rows(disats, disease_class_name, sep = "; ")
      disats$disease_class_name <- gsub ( "Wounds and Injuries", NA, disats$disease_class_name )
      disats$disease_class_name  <- gsub ( "Animal Diseases", NA, disats$disease_class_name)
      disats$disease_class_name <-ifelse(disats$disease_class_name == "", NA, as.character(disats$disease_class_name))
      nd <- length(unique(subset(disats, is.na(disease_class_name))$diseaseid))
      input<- merge(input, disats,by.x = "diseaseid1", by.y = "diseaseid")
      input <- merge(input, disats,by.x = "diseaseid2", by.y = "diseaseid")

      if(dim(input[is.na(input$disease_class_name.x), ])[1]> 0){
        stop("index diseases has no disease class")
      }
      results <- subset(input, !is.na(disease_class_name.y) )
      # this means there is a central disease
      results <- unique(results[c("diseaseid2", "disease_class_name.y")])

      for( i in 1:nrow(results)){
        if(nchar(as.character(results$disease_class_name.y[i])) > nchars){
          rename <- substr(results$disease_class_name.y[i], 1, nchars)
          results$disease_class_name.y[i] <- paste0(rename, "...")
        }
      }
      if (nd > 0){
        show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
      }

      #results <- merge(results[, c(2,3,5,6)], results, by.x = "Disease2")
      freq <- as.data.frame ( table ( results$disease_class_name.y ) )
      freq$perc <- ( freq$Freq / sum( freq$Freq ) ) * 100
      rw <- matrix ( c( as.character( input[ 1,"disease1_name" ] ),10, 10), ncol=3 )
      colnames( rw ) <- colnames( freq )
      freq <- rbind( freq, rw )

      sizes <- as.numeric( freq[ , 3 ] )
      names( sizes ) <- freq[ , 1 ]

      results <- merge( input, results, by="diseaseid2")

      #plot
      edges <- data.frame( results[ , "disease1_name" ], results[ , "disease_class_name.y.y" ] )
      netw  <- igraph::graph.data.frame( edges, directed = FALSE )
      netw  <- igraph::simplify( netw )
      #lay   <- layout( netw )
      lay <- apply_layout(layout, netw)
      if( verbose ) {
        message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
      }

      diseases <- unique( results$disease_class_name.y.y )
      ttl <- paste0("Disease Classes associated to ", input[1,"disease1_name"] )

      igraph::plot.igraph( netw,
                           vertex.frame.color  = "white",
                           layout              = lay,
                           vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "#9bcdff", "royalblue2"),
                           vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                           vertex.frame.color  = 'blue', #the color of the border of the dots
                           vertex.label.color  = 'black',#the color of the name labels
                           vertex.label.font   = 0,      #the font of the name labels
                           vertex.label        = igraph::V( netw )$name, #specifies the labels of the vertices. in this case the 'name' attribute is used
                           edge.color          = "darkgrey",
                           edge.arrow.size     = 0.5,
                           edge.width          = 0.5,
                           vertex.size         = as.numeric(sizes[ igraph::V( netw )$name ])*prop,
                           vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                           main                = ttl
      )

    }
    else{
      stop( "Chart not possible for list. Use instead the plot function with DiseaseClassHeatmap class argument" )
    }
  }

  else if( search == "single" & type == "gene-disease" ) {
    results <- as.data.frame(input [, c ("gene_symbol", "diseaseid", "disease_name", "disease_class_name")])
    # results$gene_symbol <- as.character(results$gene_symbol)
    results$disease_class_name <- gsub ( "Wounds and Injuries", NA, results$disease_class_name )
    results$disease_class_name  <- gsub ( "Animal Diseases", NA, results$disease_class_name )
    results$disease_class_name <- gsub(";\\s+", ";", results$disease_class_name)
    results$disease_class_name <- gsub("^\\s+", "", results$disease_class_name)
    results <- as.data.frame (  tidyr::separate_rows(results, disease_class_name, sep = ";"))
    results$disease_class_name <-ifelse(results$disease_class_name == "", NA, as.character(results$disease_class_name))

    nd <- dim(subset(results, is.na(disease_class_name)))[1]
    if (nd > 0){
      show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
    }
    results <- subset(results, !is.na(disease_class_name))
    freq <- as.data.frame ( table ( results$disease_class_name ) )
    freq$perc <- ( freq$Freq / sum( freq$Freq ) ) * 100

    rw <- matrix ( c( as.character( results[ 1, 1 ] ), 10, 10), ncol=3 )
    colnames( rw ) <- colnames( freq )
    freq <- rbind( freq, rw )

    sizes <- as.numeric( freq[ , 3 ] )
    names( sizes ) <- freq[ , 1 ]

    #plot
    edges <- data.frame( results[ , c("gene_symbol" ,"disease_class_name") ] )
    netw  <- igraph::graph.data.frame( edges, directed = FALSE )
    netw  <- igraph::simplify( netw )
    #lay   <- layout( netw )
    lay <- apply_layout(layout, netw)

    if( verbose ) {
      message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
    }

    diseases <- unique( results$disease_class_name )
    ttl <- paste0("Disease Classes associated to ", results$gene_symbol[1] )

    igraph::plot.igraph( netw,
                         vertex.frame.color  = "white",
                         layout              = lay,
                         vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "royalblue2", "#ff349a" ),
                         vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                         vertex.frame.color  = 'blue', #the color of the border of the dots
                         vertex.label.color  = 'black',#the color of the name labels
                         vertex.label.font   = 0,      #the font of the name labels
                         vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                         edge.color          = "darkgrey",
                         edge.arrow.size     = 0.5,
                         edge.width          = 0.5,
                         vertex.size         = as.numeric(sizes[ igraph::V( netw )$name ])*prop,
                         vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                         main                = ttl
    )
  }

  else if (search == "single" & type == "variant-disease"){
    results <- unique(input[c("score", "variantid", "disease_name", "disease_class_name")])
    l <- length(unique(results$variantid))

    if(l > 1 ) {
      stop( "Chart not possible for list. Use instead the plot function with DiseaseClassHeatmap class argument" )
    }

    results$disease_class_name <- gsub ( "Wounds and Injuries", NA, results$disease_class_name )
    results$disease_class_name  <- gsub ( "Animal Diseases", NA, results$disease_class_name )
    results <- data.frame( tidyr::separate_rows(results, disease_class_name, sep = "; "))
    results$disease_class_name <-ifelse(results$disease_class_name == "", NA, as.character(results$disease_class_name))

    nd <- dim(subset(results, is.na(disease_class_name)))[1]
    if (nd > 0){
      show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
    }
    results <- subset(results, !is.na(disease_class_name))

    for( i in 1:nrow(results)){
      if(nchar(as.character(results$disease_class_name[i])) > nchars){
        rename <- substr(results$disease_class_name[i], 1, nchars)
        results$disease_class_name[i] <- paste0(rename, "...")
      }
    }

    freq <- as.data.frame ( table ( results$disease_class_name ) )
    freq$perc <- ( freq$Freq / sum( freq$Freq ) ) * 100

    rw <- matrix ( c( as.character( results[ 1, "variantid" ] ), 10, 10), ncol=3 )
    colnames( rw ) <- colnames( freq )
    freq <- rbind( freq, rw )

    sizes <- as.numeric( freq[ , 3 ] )
    names( sizes ) <- freq[ , 1 ]

    #plot
    edges <- data.frame( results[, "variantid" ], results[ , "disease_class_name" ] )
    netw  <- igraph::graph.data.frame( edges, directed = FALSE )
    netw  <- igraph::simplify( netw )
    #lay   <- layout( netw )
    lay <- apply_layout(layout, netw)

    if( verbose ) {
      message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
    }

    diseases <- unique( results$disease_class_name )
    ttl <- paste0("Disease Classes associated to ", results$variantid[1] )
    if (nd > 0){
      show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
    }
    igraph::plot.igraph( netw,
                         vertex.frame.color  = "white",
                         layout              = lay,
                         vertex.color        = ifelse( igraph::V( netw )$name %in% diseases, "royalblue2", "goldenrod3" ),
                         vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                         vertex.frame.color  = 'blue', #the color of the border of the dots
                         vertex.label.color  = 'black',#the color of the name labels
                         vertex.label.font   = 0,      #the font of the name labels
                         vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                         edge.color          = "darkgrey",
                         edge.arrow.size     = 0.5,
                         edge.width          = 0.5,
                         vertex.size         = as.numeric(sizes[ igraph::V( netw )$name ])*prop,
                         vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                         main                = ttl
    )
  }
  else {
    stop("disease class plot not for this type of object")
  }

}

plot_gda_heatmap <- function( type, search, input, nchars, cutoff=0, limit, verbose ) {

  if( search == "single"  ) {
    stop( "For this type of chart, a multiple query created with 'disease2gene', or 'gene2disease' is required. For single disease is not possible to plot this graphic." )
  }
  if( search == "list" ) {
    if( type == "disease-gene" ) {
      results <- ( input[ , c( "disease_name", "gene_symbol", "score" ) ] )
      results$disease_name <- as.character(results$disease_name)
      results <- results [ results$score>= cutoff, ]
      results <- results [ with ( results , order(-score)), ]
      if ( dim( results )[ 1 ] > limit ){
        results <- results[ 1:limit ,]
        show( paste0("Dataframe of ", nrow(input), " rows has been reduced to ", limit, " rows." ))

      }

      for( i in 1:nrow(results)){
        if(nchar(as.character(results$disease_name[i])) > nchars){
          rename <- substr(results$disease_name[i], 1, nchars)
          results$disease_name[i] <- paste0(rename, "...")
        }
      }

      casted_tt <- reshape::cast( results, gene_symbol ~ disease_name, value= "score", length )
      l <- dim( casted_tt )[ 2 ]
      casted_tt[ is.na( casted_tt ) ] <- 0
      res <- hclust( dist( casted_tt[ 2:l ] ),  method = "ward.D")
      casted_tt$clus <- cutree( res, k = l+1 )
      ordered <- casted_tt[order(casted_tt$clus), "gene_symbol"]

      results$gene_symbol  <- factor(results$gene_symbol , levels= as.factor(ordered))
      p<- ggplot2::qplot( x = disease_name, y = gene_symbol, data= results , fill = score, geom = "tile" ) +
        ggplot2::ylab( "Genes" ) + ggplot2::xlab( "Disease Name" ) +
        ggplot2::ggtitle( "Gene-Disease Heatmap") +
        # ggplot2::scale_fill_gradient2(low = "#0000FF", high ="#2f30c9",guide = "colourbar", "Score") +
        ggplot2::scale_fill_gradient(low = "#0000FF", high ="#2f30c9",  guide = "colourbar", "Score", breaks = c(0,1))  +
        ggplot2::theme ( axis.text = ggplot2::element_text ( size = 9),
                         axis.title=ggplot2::element_text(size=10 ),
                         panel.background = ggplot2::element_rect(fill="white", colour = "black"),
                         text = ggplot2::element_text(size = 11),
                         axis.text.x = ggplot2::element_text(angle=45, size = 11, hjust = 1)
        )
      print(p)

    }

    else  if( type == "gene-disease" ) {

      results <- ( input[ , c( "score", "gene_symbol", "disease_name" ) ] )
      results$gene_symbol <- as.character( results$gene_symbol )
      results <- results [ results$score>= cutoff, ]


      if ( dim( results )[ 1 ] > limit ){
        results <- results[order(-results$score), ]
        results <- results[ 1:limit ,]
        show( paste0("warning: dataframe of ", nrow(input), " rows has been reduced to ", limit, " rows." ))

      }

      for( i in 1:nrow(results)){

        if(nchar(as.character(results$disease_name[i])) > nchars){
          results$disease_name <- as.character(results$disease_name )
          rename <- substr(results$disease_name[i], 1, nchars)
          results$disease_name[i] <- paste0(rename, "...")
        }
      }

      casted_tt <- reshape::cast(results, disease_name ~ gene_symbol, value= "score" , length )
      l <- dim(casted_tt)[2]
      casted_tt[is.na( casted_tt)] <- 0
      res <- hclust(dist(casted_tt[2:l]),  method = "ward.D")

      casted_tt$clus <- cutree(res, k = 5)
      ordered <- casted_tt[order(casted_tt$clus), "disease_name"]

      results$disease_name  <- factor(results$disease_name , levels= as.factor(ordered))
      p<- ggplot2::qplot( x = gene_symbol, y = disease_name, data= results , fill = score, geom = "tile" ) +
        ggplot2::ylab( "Diseases" ) + ggplot2::xlab( "Genes" ) + ggplot2::ggtitle( "Gene-Disease Heatmap") +
        #ggplot2::scale_fill_gradient2(low = "#0000FF", high ="#2f30c9", breaks=c(0,1), guide = "colourbar", "Score") +
         ggplot2::scale_fill_gradient(low = "#0000FF", high ="#2f30c9",  guide = "colourbar", "Score", breaks = c(0,1))  +
        ggplot2::theme ( axis.text = ggplot2::element_text ( size = 9), axis.title=ggplot2::element_text(size=10 ), panel.background = ggplot2::element_rect(fill="white", colour = "black"),
                         text = ggplot2::element_text(size = 11),
                         axis.text.x = ggplot2::element_text(angle=45, size = 11, hjust = 1))
      #plot(p)
      print(p)
    }
  }
}

plot_gda_heatmapPanther <- function( type, search, input,nchars, verbose ) {
  results <- input [, c ("gene_symbol", "diseaseid", "disease_name", "protein_class_name")]
  results <- tidyr::separate_rows(results, protein_class_name, sep = "; ")
  results$protein_class_name <-ifelse(results$protein_class_name == "", NA, as.character(results$protein_class_name))
  nd <- length(unique(as.character(subset(results, is.na(protein_class_name))$gene_symbol)))
  if (nd > 0){
    show( paste0("warning: ", nd , " gene(s) not shown in the plot" ))
  }
  results <- subset(results, !is.na(protein_class_name))

  # for( i in 1:nrow(results)){
  #   if(nchar(as.character(results$disease_class_name)) > 25){
  #     rename <- substr(results$disease_class_name[i], 1, 25)
  #     results$disease_class_name[i] <- paste0(rename, "...")
  #   }
  # }
  for( i in 1:nrow(results)){
    if(nchar(as.character(results$disease_name[i])) > nchars){
      rename <- substr(results$disease_name[i], 1,nchars)
      results$disease_name[i] <- paste0(rename, "...")
    }
  }

  for ( i in 1:length(unique(results$disease_name))){
    disease1 <- results[results$disease_name==unique(results$disease_name)[i],]
    freq <- as.data.frame ( table ( as.character(disease1$protein_class_name ) ))
    freq$perc <- (freq$Freq/sum(freq$Freq))*100
    freq$dis <- unique(results$disease_name)[i]

    if ( i == 1){
      rr <- freq
    } else if ( i > 1){
      rr <- rbind(rr, freq)
    }
  }

  rr <- rr [ with ( rr , order(-perc)), ]
  casted_rr <- reshape::cast(rr, Var1 ~ dis, value= "perc"  )
  l <- dim(casted_rr)[2]
  Rowm  <- rowMeans(casted_rr[2:l], na.rm = T)
  casted_rr<- cbind(casted_rr, Rowm)
  ordered<-  casted_rr[order(casted_rr["Rowm"]), "Var1" ]
  rr$Var1  <- factor(rr$Var1  , levels= as.factor(ordered))
  m <- max(rr$perc)
  p <- ggplot2::ggplot(rr, ggplot2::aes(dis, Var1)) + ggplot2::geom_tile(ggplot2::aes(fill = perc), colour = "white") + ggplot2::scale_fill_gradient(name="%",limits = c(0,m), low = "lightgrey",   high = "darkolivegreen", na.value = "white")
  p <- p + ggplot2::theme_grey(base_size = 11) + ggplot2::labs(title = "Protein Class Heatmap", x = "Diseases",  y = "Protein class") + ggplot2::scale_x_discrete(expand = c(0, 0))
  p <- p + ggplot2::theme( plot.margin=grid::unit(x=c(5,15,5,15),units="mm") , axis.line = ggplot2::element_line(size = 0.7, color = "black"), text = ggplot2::element_text(size = 11), axis.text.x = ggplot2::element_text(angle=45, size = 11, hjust = 1), panel.background = ggplot2::element_blank())
  p<- p +   ggplot2::theme(plot.title = ggplot2::element_text(hjust = 0.5))
  print(p)

}

plot_gda_heatmap_DiseaseClass <- function( type, search, input, limit,nchars, verbose ) {

  # if( type == "disease-disease-gene" ) {
  #
  #   results <- input [, c (1,2, 5 ,6 )]
  #
  #   results <- as.data.frame( transDiseaseClass ( results ) )
  #   row.names(results) <- NULL
  #   results[,4] <- gsub (" ; ", ";", results[,4] )
  #   results[,4] <- gsub ( "null", NA, results[,4] )
  #   results[,4] <- gsub ( "Wounds and Injuries", NA, results[,4] )
  #   results[,4] <- gsub ( "Animal Diseases", NA, results[,4] )
  #   results$V4 <- as.character(results$V4)
  #   results <- unique(results[c("NameDisease1", "NameDisease2",  "V4")])
  #   nd <- dim(subset(results, is.na(V4)))[1]
  #   if (nd > 0){
  #     show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
  #   }
  #   for( i in 1:nrow(results)){
  #     if(nchar(as.character(results$V4[i])) > 25){
  #       rename <- substr(results$V4[i], 1, 25)
  #       results$V4[i] <- paste0(rename, "...")
  #     }
  #   }
  #   ##
  #   for ( i in 1:length(unique(results$NameDisease1))){
  #     disease1 <- results[results$NameDisease1==unique(results$NameDisease1)[i],]
  #     freq <- as.data.frame ( table ( as.character(disease1$V4 ) ))
  #     freq$perc <- (freq$Freq/sum(freq$Freq))*100
  #     freq$dis <- unique(results$NameDisease1)[i]
  #
  #     if ( i == 1){
  #       rr <- freq
  #     } else if ( i > 1){
  #       rr <- rbind(rr, freq)
  #     }
  #   }
  #
  #   rr <- rr [ with ( rr , order(-perc)), ]
  #   casted_rr <- reshape::cast(rr, Var1 ~ dis, value= "perc"  )
  #   l <- dim(casted_rr)[2]
  #   Rowm  <- rowSums(casted_rr[2:l], na.rm = T)
  #   casted_rr<- cbind(casted_rr, Rowm)
  #   ordered<-  casted_rr[order(casted_rr["Rowm"]), "Var1" ]
  #   rr$Var1  <- factor(rr$Var1  , levels= as.factor(ordered))
  #   m <- max(rr$perc)
  #   p <- ggplot2::ggplot(rr, ggplot2::aes(dis, Var1)) + ggplot2::geom_tile(ggplot2::aes(fill = perc), colour = "white") + ggplot2::scale_fill_gradient(limits = c(0,m), low = "white",   high = "royalblue2", na.value = "white", "Percentage")
  #   p <- p + ggplot2::theme_grey(base_size = 10) + ggplot2::labs(title = "Gene-Disease Class Heatmap", x = "Genes",  y = "MeSH Disease Class") + ggplot2::scale_x_discrete(expand = c(0, 0))
  #   p <- p + ggplot2::theme( plot.margin=grid::unit(x=c(5,15,5,15),units="mm") , axis.line = ggplot2::element_line(size = 0.7, color = "black"), text = ggplot2::element_text(size = 9),axis.title=ggplot2::element_text(size=10 ), axis.text.x = ggplot2::element_text(angle=45, size = 10, hjust = 1), panel.background = ggplot2::element_blank())
  #   p +   ggplot2::theme(plot.title = element_text(hjust = 0.5))
  #
  # }
  # else

  if( type == "gene-disease" ) {

    results <- ( input[ , c("geneid", "gene_symbol", "diseaseid", "disease_name", "disease_class_name") ] )
    results$disease_class_name <- gsub ( "Wounds and Injuries", NA, results$disease_class_name )
    results$disease_class_name  <- gsub ( "Animal Diseases", NA, results$disease_class_name )
    results <- tidyr::separate_rows(results, disease_class_name, sep = "; ")
    results$disease_class_name <-ifelse(results$disease_class_name == "", NA, as.character(results$disease_class_name))


    nd <- length(unique(as.character(subset(results, is.na(disease_class_name))$disease_name)))
    if (nd > 0){
      show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
    }
    results <- subset(results, !is.na(disease_class_name))

    for( i in 1:nrow(results)){
      if(nchar(as.character(results$disease_class_name[i])) > nchars){
        rename <- substr(results$disease_class_name[i], 1, nchars)
        results$disease_class_name[i] <- paste0(rename, "...")
      }
    }

    for ( i in 1:length(unique(results$gene_symbol))){
      disease1 <- results[results$gene_symbol==unique(results$gene_symbol)[i],]
      freq <- as.data.frame ( table ( as.character(disease1$disease_class_name ) ))
      freq$perc <- (freq$Freq/sum(freq$Freq))*100
      freq$dis <- unique(results$gene_symbol)[i]

      if ( i == 1){
        rr <- freq
      } else if ( i > 1){
        rr <- rbind(rr, freq)
      }
    }

    rr <- rr [ with ( rr , order(-perc)), ]
    casted_rr <- reshape::cast(rr, Var1 ~ dis, value= "perc"  )
    l <- dim(casted_rr)[2]
    Rowm  <- rowSums(casted_rr[2:l], na.rm = T)
    casted_rr<- cbind(casted_rr, Rowm)
    ordered<-  casted_rr[order(casted_rr["Rowm"]), "Var1" ]
    rr$Var1  <- factor(rr$Var1  , levels= as.factor(ordered))
    m <- max(rr$perc)
    p <- ggplot2::ggplot(rr, ggplot2::aes(dis, Var1)) + ggplot2::geom_tile(ggplot2::aes(fill = perc), colour = "white") + ggplot2::scale_fill_gradient(limits = c(0,m), low = "white",   high = "mediumorchid4", na.value = "white", "Percentage")
    p <- p + ggplot2::theme_grey(base_size = 10) + ggplot2::labs(title = "Gene-Disease Class Heatmap", x = "Genes",  y = "MeSH Disease Class") + ggplot2::scale_x_discrete(expand = c(0, 0))
    p <- p + ggplot2::theme( plot.margin=grid::unit(x=c(5,15,5,15),units="mm") , axis.line = ggplot2::element_line(size = 0.7, color = "black"), text = ggplot2::element_text(size = 9),axis.title=ggplot2::element_text(size=10 ), axis.text.x = ggplot2::element_text(angle=45, size = 10, hjust = 1), panel.background = ggplot2::element_blank())
    p<-  p +   ggplot2::theme(plot.title = ggplot2::element_text(hjust = 0.5))
    print(p)

  }

  else if( type == "variant-disease"  ) {

    if( search == "single" ) {
      stop( "For this type of chart, a multiple query created with 'variant2disease' is required." )
    }

    results <- unique( input[ , c( "variantid" ,"diseaseid" , "disease_name", "disease_class_name") ] )
    results$disease_class_name <- gsub ( "Wounds and Injuries", NA, results$disease_class_name )
    results$disease_class_name  <- gsub ( "Animal Diseases", NA, results$disease_class_name )
    results <- tidyr::separate_rows(results, disease_class_name, sep = "; ")
    results$disease_class_name <-ifelse(results$disease_class_name == "", NA, as.character(results$disease_class_name))


    nd <- length(unique(as.character(subset(results, is.na(disease_class_name))$disease_name)))
    if (nd > 0){
      show( paste0("warning: ", nd , " disease(s) not shown in the plot" ))
    }
    results <- subset(results, !is.na(disease_class_name))

    for( i in 1:nrow(results)){
      if(nchar(as.character(results$disease_class_name[i])) > nchars){
        rename <- substr(results$disease_class_name[i], 1, nchars)
        results$disease_class_name[i] <- paste0(rename, "...")
      }
    }


    for ( i in 1:length(unique(results$variantid))){
      disease1 <- results[results$variantid==unique(results$variantid)[i],]
      freq <- as.data.frame ( table ( as.character(disease1$disease_class_name ) ))
      freq$perc <- (freq$Freq/sum(freq$Freq))*100
      freq$snp <- unique(results$variantid)[i]

      if ( i == 1){
        rr <- freq
      } else if ( i > 1){
        rr <- rbind(rr, freq)
      }
    }

    rr <- rr [ with ( rr , order(-perc)), ]
    casted_rr <- reshape::cast(rr, Var1 ~ snp, value= "perc"  )
    l <- dim(casted_rr)[2]
    Rowm  <- rowSums(casted_rr[2:l], na.rm = T)
    casted_rr<- cbind(casted_rr, Rowm)
    ordered<-  casted_rr[order(casted_rr["Rowm"]), "Var1" ]
    rr$Var1  <- factor(rr$Var1  , levels= as.factor(ordered))
    m <- max(rr$perc)
    p <- ggplot2::ggplot(rr, ggplot2::aes(snp, Var1)) + ggplot2::geom_tile(ggplot2::aes(fill = perc), colour = "white") + ggplot2::scale_fill_gradient(limits = c(0,m), low = "white",   high = "darkolivegreen", na.value = "white", "Percentage")
    p <- p + ggplot2::theme_grey(base_size = 10) + ggplot2::labs(title = "Variant-Disease Class Heatmap", x = "Variants",  y = "Disease Class") + ggplot2::scale_x_discrete(expand = c(0, 0))
    p <- p + ggplot2::theme( plot.margin=grid::unit(x=c(5,15,5,15),units="mm") , axis.line = ggplot2::element_line(size = 0.7, color = "black"), text = ggplot2::element_text(size = 9),axis.title=ggplot2::element_text(size=10 ), axis.text.x = ggplot2::element_text(angle=45, size = 10, hjust = 1), panel.background = ggplot2::element_blank())
    p<- p +   ggplot2::theme(plot.title = ggplot2::element_text(hjust = 0.5))
    print(p)
  }
}

plot_gda_Panther <- function ( input, layout, search, verbose ) {

  if( search == "single"){
    results <- input [, c ("diseaseid", "disease_name", "geneid", "gene_symbol", "protein_class_name" )]

    results <- data.frame( tidyr::separate_rows(results, protein_class_name, sep = "; ") )
    results$protein_class_name <-ifelse(results$protein_class_name == "", NA, as.character(results$protein_class_name))


    nd <- length(unique(as.character(subset(results, is.na(protein_class_name))$gene_symbol)))
    if (nd > 0){
      show( paste0("warning: ", nd , " gene(s) not shown in the plot" ))
    }
    results <- subset(results, !is.na(protein_class_name))

    freq <- as.data.frame ( table ( as.character(results$protein_class_name ) ))
    freq$perc <- (freq$Freq/sum(freq$Freq))*100

    rw <- matrix(c(as.character(results[1,2]), 10, 10),ncol=3)
    colnames(rw) <- colnames(freq)
    freq <- rbind(freq,rw)

    sizes <- as.numeric(freq[ , 3 ])
    names( sizes ) <- freq[ , 1 ]

    #plot
    edges <- data.frame( results[c("disease_name", "protein_class_name") ] )
    netw  <- igraph::graph.data.frame( edges, directed = FALSE )
    netw  <- igraph::simplify( netw )
    #lay   <- layout( netw )
    lay <- apply_layout(layout, netw)

    if( verbose ) {
      message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
    }

    pantherClass <- unique( results$protein_class_name )
    ttl <- paste0("Protein Classes associated to ", results$disease_name[ 1 ] )

    igraph::plot.igraph( netw,
                         vertex.frame.color  = "white",
                         layout              = lay,
                         vertex.color        = ifelse( igraph::V( netw )$name %in% pantherClass, "darkolivegreen", "royalblue2" ),
                         vertex.label.dist   = 0.2,      #puts the name labels slightly off the dots
                         vertex.frame.color  = 'blue', #the color of the border of the dots
                         vertex.label.color  = 'black',#the color of the name labels
                         vertex.label.font   = 0,      #the font of the name labels
                         vertex.label        = igraph::V( netw )$names, #specifies the lables of the vertices. in this case the 'name' attribute is used
                         edge.color          = "darkgrey",
                         edge.arrow.size     = 0.5,
                         edge.width          = 0.5,
                         vertex.size         = sizes[ igraph::V( netw )$name ],
                         vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                         main                = ttl
    )
  }

}


plot_diseasome <- function( input, type, layout, search, verbose, prop, limit, cutoff , database, pvalue, nboot, ncores, interactive ) {

  indexdiseases <- unique(c(as.character(input$disease1_name)))
  diseases<- unique(c(as.character(input$diseaseid1), as.character(input$diseaseid2)))

  title <- ""

  if( type == "disease-disease-gene"  ) {
    title <- "DDA network via shared genes"

    input$pvalue_jaccard_genes <- as.numeric(as.character(input$pvalue))
    input  <- input[input$pvalue_jaccard_genes < cutoff,]
    res <- disease2gene(disease = diseases, database = database)

    res <- res@qresult
    pairs <- ( length(diseases) *   length(diseases) -  length(diseases) ) / 2
    tb <- as.data.frame(setNames(replicate(8,numeric(0), simplify = F), c("diseaseid1","disease1_name", "diseaseid2","disease2_name", "ngenes1", "ngenes2", "common", "jaccard_index")))
    cnt <- 1
    for ( i in 1:length(diseases)){
      dis1 <- diseases[i]
      nd1 <- as.character (  res[res[,"diseaseid"]==diseases[i],"disease_name"][1]  )
      gene1 <- unique( subset(res, diseaseid == dis1 )$geneid)
      for ( j in 2:length(diseases)){
        if ( i < j){
          dis2 <- diseases[j]
          nd2 <- as.character (  res[res[,"diseaseid"]==diseases[j],"disease_name"][1]  )
          gene2 <- unique( subset(res, diseaseid == dis2 )$geneid)
          ji <- round(length(intersect(gene1, gene2))/length(union(gene1, gene2)), 5)

          tb[ cnt, ] <- c(diseases[ i ], nd1, diseases[ j ],nd2, length( gene1 ), length( gene2 ), length( intersect( gene1, gene2 ) ), ji )
          cnt <- cnt + 1
        }
      }
    }
    tb <- tb[tb[,"common"]>0 ,]

    finaldiseases <- unique( c(as.character(tb$diseaseid1), as.character(tb$diseaseid2)))
    #   if (dim(input)[1]> limit){
    #     input <- input[c(1:limit),]
    #     show( paste0("warning: dataframe of ", a , " rows has been reduced to ", limit, " rows." ))
    #   }

    if(pvalue == T){
      if( verbose ) {
        message(paste0("performing ", nboot, " randomizations. Please wait..."))
      }
      tb <- pvalue_estimation(tb, database = "CURATED", ncores = ncores, nboot = nboot)
    }
    tb <- subset(tb, pvalue < 0.05)
    edges <- data.frame( tb[ , "disease1_name" ], tb[ , "disease2_name" ] )
    netw  <- igraph::graph.data.frame( edges, directed = FALSE )
    netw  <- igraph::simplify( netw )
    lay <- apply_layout(layout = layout, netw = netw)


    ds1 <- tb[,c( "disease1_name", "ngenes1" ) ]
    colnames( ds1 ) <- c("dis", "gen")
    ds2 <- tb[, c("disease2_name", "ngenes2") ]
    colnames( ds2 ) <- c("dis", "gen")

    fnl <- rbind ( ds1, ds2)
    fnl <- fnl[!duplicated(fnl), ]

    sizes <- as.numeric( fnl[ , 2 ] )
    names( sizes ) <- fnl[ , 1 ]
  }
   else if( type == "disease-disease-variant" ) {
    title <- "DDA network via shared variants"
    input$pvalue_jaccard_variants <- as.numeric(as.character(input$pvalue))

    res <- disease2variant(disease = diseases, database = database)

    res <- res@qresult
    pairs <- ( length(diseases) *   length(diseases) -  length(diseases) ) / 2
    tb <- as.data.frame(setNames(replicate(8,numeric(0), simplify = F), c("diseaseid1","disease1_name", "diseaseid2","disease2_name", "nvariants1", "nvariants2", "common", "jaccard_index")))
    cnt <- 1
    for ( i in 1:length(diseases)){
      dis1 <- diseases[i]
      nd1 <- as.character (  res[res[,"diseaseid"]==diseases[i],"disease_name"][1]  )
      gene1 <- unique( subset(res, diseaseid == dis1 )$variantid)
      for ( j in 2:length(diseases)){
        if ( i < j){
          dis2 <- diseases[j]
          nd2 <- as.character (  res[res[,"diseaseid"]==diseases[j],"disease_name"][1]  )
          gene2 <- unique( subset(res, diseaseid == dis2 )$variantid)
          ji <- round(length(intersect(gene1, gene2))/length(union(gene1, gene2)), 5)

          tb[ cnt, ] <- c(diseases[ i ], nd1, diseases[ j ],nd2, length( gene1 ), length( gene2 ), length( intersect( gene1, gene2 ) ), ji )
          cnt <- cnt + 1
        }
      }
    }
    tb <- tb[tb[,"common"]>0 ,]
    finaldiseases <- unique( c(as.character(tb$diseaseid1), as.character(tb$diseaseid2)))
    #   if (dim(input)[1]> limit){
    #     input <- input[c(1:limit),]
    #     show( paste0("warning: dataframe of ", a , " rows has been reduced to ", limit, " rows." ))
    #   }

    if(pvalue == T){
      if( verbose ) {
        message(paste0("performing ", nboot, " randomizations. Please wait..."))
      }
      tb <- pvalue_estimation(tb, database = "CURATED", ncores = ncores, nboot = nboot)
    }
    tb <- subset(tb, pvalue < 0.05)

    edges <- data.frame( tb[ , "disease1_name" ], tb[ , "disease2_name" ] )
    netw  <- igraph::graph.data.frame( edges, directed = FALSE )
    netw  <- igraph::simplify( netw )
    lay <- apply_layout(layout = layout, netw = netw)


    ds1 <- tb[,c( "disease1_name", "nvariants1" ) ]
    colnames( ds1 ) <- c("dis", "gen")
    ds2 <- tb[, c("disease2_name", "nvariants2") ]
    colnames( ds2 ) <- c("dis", "gen")

    fnl <- rbind ( ds1, ds2)
    fnl <- fnl[!duplicated(fnl), ]

    sizes <- as.numeric( fnl[ , 2 ] )
    names( sizes ) <- fnl[ , 1 ]

  }

  if( verbose ) {
    message( "The network contains ", igraph::vcount( netw ), " nodes and ", igraph::ecount( netw ), " edges." )
  }

  diseaseColor = "blue"
  comorColor = "lightblue"
  if(interactive == FALSE){
    igraph::plot.igraph( netw,
                         vertex.frame.color = "white",
                         layout              = lay,
                         vertex.color        = ifelse(igraph::V(netw)$name %in% indexdiseases, diseaseColor,comorColor),
                         vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                         vertex.frame.color  = 'blue', #the color of the border of the dots
                         vertex.label.color  = 'black',#the color of the name labels
                         vertex.label.font   = 0,      #the font of the name labels
                         vertex.label        = igraph::V( netw )$name, #specifies the lables of the vertices. in this case the 'name' attribute is used
                         #edge.label          = round(as.numeric(as.character(tb[,"jaccard_index"])), 3),
                         edge.color          = "darkgrey",
                         edge.width          =  1 + as.numeric(as.character(tb[,"jaccard_index"])) *3,
                         edge.arrow.size     = 0.5,
                         vertex.size         = as.numeric( sizes[ igraph::V( netw )$name ] * prop),
                         vertex.size         = 0.5,
                         vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                         main                = title
    )

  }else if (interactive == TRUE){
    igraph::tkplot(netw,
                           vertex.frame.color = "white",
                           layout              = lay,
                           vertex.color        = ifelse(igraph::V(netw)$name %in% indexdiseases, diseaseColor,comorColor),
                           vertex.label.dist   = 0,      #puts the name labels slightly off the dots
                           vertex.frame.color  = 'blue', #the color of the border of the dots
                           vertex.label.color  = 'black',#the color of the name labels
                           vertex.label.font   = 0,      #the font of the name labels
                           vertex.label        = igraph::V( netw )$name, #specifies the lables of the vertices. in this case the 'name' attribute is used
                           #edge.label          = round(as.numeric(as.character(tb[,"jaccard_index"])), 3),
                           edge.color          = "darkgrey",
                           edge.width          =  1 + as.numeric(as.character(tb[,"jaccard_index"])) *3,
                           edge.arrow.size     = 0.5,
                           vertex.size         = as.numeric( sizes[ igraph::V( netw )$name ] * prop),
                           vertex.size         = 0.5,
                           vertex.label.cex    = 0.8,    #specifies the size of the font of the labels
                           main                = title
    )
  }
}


plot_enrichment <- function( input, verbose, cutoff , count, nchars, limit ) {

  input<- subset(input, FDR < cutoff & Count > count  )
  if ( dim( input )[ 1 ] > limit ){
    input <- input[ 1:limit ,]
    show( paste0("warning: dataframe of ", nrow(input), " rows has been reduced to ", limit, " rows." ))
  }

  idx <- order(input$gg, decreasing = T)
  input$Description <- ifelse(nchar(input$Description) < nchars, as.character(input$Description), paste0(substr(input$Description, 0, nchars), "..."))
  input$Description<-factor(input$Description, levels=rev(unique(input$Description[idx])))
  title <- "DisGeNET enrichment"
  p <- ggplot2::ggplot(input, ggplot2::aes_string(x= input$gg, y="Description", size=input$Count, color=input$FDR)) +
    ggplot2::geom_point() +
    ggplot2::scale_color_continuous(low="red", high="blue", name = "FDR", guide=ggplot2::guide_colorbar(reverse=TRUE)) +
    ggplot2::xlab("Ratio") + ggplot2::ylab(NULL) +
    ggplot2::ggtitle(title) + ggplot2::theme_bw() +
    ggplot2::theme(axis.text.x = ggplot2::element_text(colour = "black",  size = 14, vjust = 1),
                   axis.text.y = ggplot2::element_text(colour = "black", size = 14, hjust = 1),
          axis.title = ggplot2::element_text(margin = ggplot2::margin(10, 5, 0, 0), color = "black", size = 12),
          axis.title.y = ggplot2::element_text(angle = 90)) + ggplot2::scale_size(range=c(3, 8))
   print(p)
}

#' Performs an enrichment analysis on a list of genes/variants and generates an object \code{DataGeNET.DGN}
#'
#' @param entities Name or vector of genes (Entrez identifiers or HGNC symbols) or variants (DBSNP identifiers) to
#' for the enrichment
#' @param vocabulary The vocabulary for the genes (ENTREZ or HGNC) and for the variants (DBSNP)
#' @param database Name of the database that will be queried to retrieve the gene/variant disease annotations.
#' The possible values are:
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param universe The universe to be used for the Fisher test.
#' The possible values are:
#' \code{DISGENET} - All genes in DisGeNET
#' \code{HUMAN} - All genes according to the NCBI
#' \code{HUMAN_CODING} - All protein coding genes to the NCBI
#' \code{CUSTOM} - A list of genes or variants submitted by the user
#' \code{custom_universe} a list of genes/variants as Entrez or symbols/dbSNP identifiers to be used
#' as universe when setting the universe="CUSTOM"
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to not see
#' the warnings.
#' @return An object of class \code{DataGeNET.Dis}
#' @examples
#' res <- disease_enrichment( entities =c("APP", "PSEN","APOE"), vocabulary = "HGNC", database = "CURATED", universe = "HUMAN_CODING")
#' @export disease_enrichment


disease_enrichment <- function(entities=entities, universe = "DISGENET", custom_universe ="", vocabulary = "HGNC",
                               verbose = TRUE, database = "CURATED", warnings = TRUE) {
  check_disgenet_sources( database )

  if( length(entities) != length( unique( entities ) ) ) {
    entities <- unique( entities )
    warning(
      "Removing duplicates from input list."
    )
  }

  type <- "symbol"
  if( vocabulary == "HGNC" ){
    #do nothing
  } else if( vocabulary == "ENTREZ" ){
    type <- "entrezid"
  } else if( vocabulary == "DBSNP" ){
    type <- "dbsnp"
  }else if( class( entities[1] ) == "factor"){
    message("Your input entities are in factor format.
    Please, revise your input entities and save them as numeric or as character.")
    stop()
  } else {
    message(paste0("Your input entities are a wrong vocabulary ", vocabulary,
                   ". Please, revise your input vocabulary. Remember that genes should be identified
                   using HGNC gene symbols or NCBI Entrez identifiersm and variants as DBSNP identifiers"))
    stop()
  }

  # if (!  universe %in% c("DISGENET", "HUMAN", "HUMAN_CODING", "CUSTOM")){
  #   message(paste0("Your input universe  ", universe,
  #                  "  should be one of the following:
  #                 - DISGENET - All genes/variants in DisGeNET \\n
  #                 - HUMAN - All genes according to the NCBI or \\n
  #                 - HUMAN - All variants according to CLINVAR, UNIPROT, all variants from GWASCAT and GWASDB without filtering by p-value. \\n
  #                 - HUMAN_CODING - All protein coding genes to the NCBI \\n
  #                 - CUSTOM - a list of genes supplied by the user \\n
  #                  "))
  #   stop()
  #
  # }
  # if (universe == "CUSTOM" & length(custom_universe ) < 2  ){
  #   message("To use the CUSTOM universe you must supply your own list of genes or variants!")
  #   stop()
  # }

  list_of_entities = paste(entities, collapse = ",")

  if (vocabulary == "DBSNP"){
      url <- paste0( get_url_disgenet(), "enrichment/variants")
      body <-  paste0("variants=",list_of_entities, "&source=",database)
      # if (universe== "CUSTOM"){
      #   custom_universe = paste(custom_universe, collapse = ",")
      #   body <-  paste0("variants=",list_of_entities, "&universe=CUSTOM&source=",database, "&custom_universe=", custom_universe)
      # } else {
      #   body <-  paste0("variants=",list_of_entities, "&universe=",universe, "&source=",database)
      # }

  } else if (vocabulary %in% c("HGNC", "ENTREZ" ) ){
    url <- paste0( get_url_disgenet(), "enrichment/genes")
    body <-  paste0("genes=",list_of_entities, "&typeid=",type ,  "&source=",database)
    # if (universe== "CUSTOM"){
    #   custom_universe = paste(custom_universe, collapse = ",")
    #   body <-  paste0("genes=",list_of_entities, "&typeid=",type ,"&universe=CUSTOM&source=",database, "&custom_universe=", custom_universe)
    # }
    # else{
    #       body <-  paste0("genes=",list_of_entities, "&typeid=",type ,"&universe=",universe, "&source=",database)
    #
    # }
  } else{
    message(paste0("Your input vocabulary  ", vocabulary,
                   "  should be one of the following:
                  - HGNC \\n
                  - ENTREZ  \\n
                  - DBSNP \\n"))
    stop()
  }

  r  <- httr::POST(url = url,
                     httr::add_headers('Content-Type' = "application/x-www-form-urlencoded"),
                     body = body)

  if (r$status_code == 200) {
    res <-jsonlite::fromJSON(httr::content(r, as = "text", encoding = "UTF-8"), flatten = F)
  }else{
    print(httr::http_status(r))
    print(httr::content(r, "text"))
    stop()

  }

  if (type == "dbsnp") {
    data <- res$results[,c("diseaseid", "disease_name", "source", "variant_ratio", "bg_ratio", "pvalue", "adjusted_pvalue")]
    # shared_entities <-   cbind(res$results$diseaseid, purrr::map_dfr(res$results$intersection, ~as_tibble(t(.), .name_repair = 'unique')))
    shared_entities <-  sapply(res$results$intersection, '[', seq(max(sapply(res$results$intersection, length))))
    shared_entities <- as.data.frame(t(shared_entities),stringsAsFactors =F)
    shared_entities <- cbind(res$results$diseaseid, shared_entities)
    shared_entities <- reshape2::melt(shared_entities, id.vars="res$results$diseaseid")
    colnames(shared_entities) <- c("diseaseid", "v1", "shared_variant")
    shared_entities <- aggregate(shared_variant~diseaseid, data= shared_entities , function(x)paste(x,collapse=";"))

  } else{

    l <- res$background$not_found_genes
    if(length(l) > 0){
      message(paste0(l, " gene(s) from the input list not found in DisGeNET ", database))
    }
    data <- res$results[,c("diseaseid", "disease_name", "source", "gene_ratio", "bg_ratio", "pvalue", "adjusted_pvalue")]
    shared_entities <-   cbind(res$results$diseaseid, res$results$intersection)
    shared_entities <- reshape2::melt(shared_entities, id.vars="res$results$diseaseid")
    colnames(shared_entities) <- c("diseaseid", "shared_geneid", "shared_symbol")
    shared_entities <- subset(shared_entities, !is.na(shared_symbol))
    ag1 <- aggregate(shared_geneid~diseaseid, data= shared_entities , function(x)paste(x,collapse=";"))
    ag2 <- aggregate(shared_symbol~diseaseid, data= shared_entities , function(x)paste(x,collapse=";"))
    shared_entities <- merge(ag1, ag2, by = "diseaseid")

  }

  if( dim( res$results$disease_class)[2] > 0){
    disclass <-   cbind(res$results$diseaseid, res$results$disease_class)
    colnames(disclass)[1] <-"diseaseid"
    disclass <- reshape2::melt(disclass, id = "diseaseid")
    disclass <- unique(disclass[! is.na(disclass$value), ])
    disclass$variable <- as.character(disclass$variable)
    disclass$value <- as.character(disclass$value)
    disclass <- disclass[ order(disclass$variable), ]
    disclass1 <- aggregate( variable ~ diseaseid, data= disclass ,  function(x)paste(x,collapse=";"))
    disclass2 <- aggregate( value ~ diseaseid, data= disclass ,  function(x)paste(x,collapse=";"))
    disclass <- merge(disclass1, disclass2, by = "diseaseid")
    colnames(disclass) <- c("diseaseid", "disease_class","disease_class_name")
    data <- merge(data, disclass, by = "diseaseid",all.x = T)
  } else {
    data$disease_class <- NA
    data$disease_class_name <- NA
  }

  disclass <-   cbind(res$results$diseaseid, res$results$semantic_type)
  colnames(disclass)[1] <-"diseaseid"
  disclass <- reshape2::melt(disclass, id = "diseaseid")
  disclass <- unique(disclass[! is.na(disclass$value), ])
  disclass$variable <- as.character(disclass$variable)
  disclass$value <- as.character(disclass$value)
  disclass <- disclass[ order(disclass$variable), ]
  disclass <- aggregate( value ~ diseaseid, data= disclass ,  function(x)paste(x,collapse=";"))
  colnames(disclass) <- c("diseaseid", "disease_semantic_type")

  data <- merge(data, disclass, by = "diseaseid",all.x = T)
  data <- merge(data, shared_entities, by = "diseaseid",all.x = T)

  colnames(data)[1:7] <- c("ID", "Description", "source",  "Ratio", "BgRatio", "pvalue", "FDR")
  data$Count <- sapply(strsplit(data$Ratio, "/"), `[`, 1)
  data$Count <- as.numeric(as.character(data$Count))

  data$gg <- data$Count/length(entities)
  data <- data[order(as.numeric(as.character(data$FDR))), ]
  result <- new( "DataGeNET.DGN",
                 type       = "disease-enrichment",
                 search     = "list",
                 term       = as.character( entities ),
                 database   = database,

                 qresult    = data
  )
  return( result )

}

#' Retrieves diseases associated to a gene, or list of genes and generates an \code{DataGeNET.DGN}
#'
#' Given the NCBI identifier, or HGNC symbol of one or multiple genes, retrieves their associated diseases
#' from DisGeNET and creates an object of type \code{DataGeNET.Dis}.
#'
#' @param gene a gene, or a list of genes identified by NCBI identifiers, or HGNC symbols.
#' The genes non contained in DisGeNET will be removed from the output.
#' @param vocabulary   The vocabulary of the gene identifier(s)
#' Select one of the available:  \code{HGNC} (Gene Symbols), \code{ENTREZ} (NCBI Gene Identifiers)
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param score A vector with two elements: 1) initial value of score 2) final value of score
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to not see
#' the warnings.
#' @return An object of class \code{DataGeNET.Dis}
#' @examples
#' g <- gene2disease( 3953, "CURATED", score=c(0,1), vocabulary = "ENTREZ" )
#' @export gene2disease


gene2disease <- function( gene, vocabulary= "HGNC", database = "CURATED", score=c(0,1), api_key=NULL,  verbose = FALSE, warnings = TRUE ) {
  if(is.null(api_key)){
    api_key = Sys.getenv('DISGENET_API_KEY')
    if(api_key == ""){
      stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
    }
  }
  check_disgenet_sources( database )

  if( length( gene ) != length( unique( gene ) ) ) {
    gene <- unique( gene )
    warning(
      "Removing duplicates from input genes list."
    )
  }

  type <- "symbol"
  if( vocabulary == "HGNC" ){
    #do nothing
  } else if( vocabulary == "ENTREZ" ){
    type <- "entrez"
  } else if( class( gene[1] ) == "factor"){
    message("Your input genes are in factor format.
    Please, revise your input genes and save them as numeric or as character.")
    stop()
  } else {
    message(paste0("Your input genes are a wrong vocabulary ", vocabulary,
                   "Please, revise your input vocabulary. Remember that genes should be identified
                   using HGNC gene symbols or NCBI Entrez identifiers"))
    stop()
  }

  if(length(score) != 2) {
    stop("Invalid argument 'score'. It must have two elements: initial value of the score, and final value of the score")
  }

  list_of_genes <- paste(gene,collapse=",")
  result <- NULL

  url <- paste0( get_url_disgenet(), "gda/gene/", list_of_genes , "?source=",database, "&min_score=",score[1],"&max_score=", score[2],  "&format=tsv")
  r <- get_api_connection(url = url, api_key=api_key)

  if (r$status_code == 200) {
    myTextConnection <- textConnection(rawToChar(r$content ))
    result <- read.csv( myTextConnection, header = TRUE, sep = "\t" )
    close(myTextConnection)
  }else{
    print(httr::http_status(r))
    print(httr::content(r, "text"))
  }


  if(length( gene )==1){
    cls <- "single"
  }else{
    cls <- "list"
  }

  scR <- paste0( score[1],"-", score[2])

  if (! is.null(result) > 0){
    if(type == "symbol"){
      wGenes <- setdiff(gene, result$gene_symbol)
      eGenes <- intersect(gene, result$gene_symbol)
    }else if (type == "entrez"){
      wGenes <- setdiff(gene,result$geneid)
      eGenes <- intersect(gene, result$geneid)
    }

    if( length( wGenes ) != 0 ) {
      genes <- paste( paste( "   -", wGenes ), collapse = "\n" )
      if( warnings ) {
        warning( "\n One or more of the genes in the list is not in DisGeNET ( '", database, "' ):\n", genes )
      }
    }

    result <- new( "DataGeNET.DGN",
                   type = "gene-disease",
                   search = cls,
                   term = as.character( eGenes ),
                   scoreRange = scR,
                   database = database,
                   qresult = result )

    return( result )
  } else {
    print("no results for the query")
  }
}

#' Retrieves genes associated to a disease, or list of diseases and generates an \code{DataGeNET.DGN}
#'
#' Given the name of one or multiple diseases retrieves their asssociated genes
#' from DisGeNET and creates an object of type \code{DataGeNET.DGN}.
#'
#' @param disease  A disease or a list of disease identifiers (CUIs, MeSH, OMIMs...)
#' @param vocabulary   The vocabulary of the disease identifier(s)
#' Select one of the available:  \code{UMLS} (UMLS), \code{OMIM} (OMIM),
#' \code{MESH} (MeSH), \code{DO} (Disease Ontology),
#' \code{NCI} (NCI thesaurus), \code{ORDO} (Orphanet),
#' \code{ICD9CM} (ICD9-CM) or \code{EFO} (EFO). Default \code{'UMLS'}.
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to don't see
#' the warnings.
#' @return An object of class \code{DataGeNET.DGN}
#' @examples
#' dis_res <- disease2attribute( "C0028754", database = "CURATED", vocabulary="UMLS")
#' @export disease2attribute



disease2attribute <- function( disease, vocabulary= "UMLS", database = "CURATED",  verbose = FALSE, warnings = TRUE ) {

  vocabularies <- c("UMLS", "OMIM", "NCI", "MESH", "ICD9CM", "EFO", "DO", "HPO", "ORDO")
  vv <- intersect(vocabulary, vocabularies)
  if (length(vv) == 0) {
    stop(paste0(vocabulary,  " is a wrong vocabulary! Allowed vocabularies are: \n", paste(vocabularies, collapse = "\n")))
  }
  if (vv != "UMLS") {
    vv <- paste0(tolower(vv), "_id")
  }
  check_disgenet_sources( database )
  if( length( disease ) != length( unique( disease ) ) ) {
    disease <- unique( disease )
    if( warnings ) {
      warning(
        "Removing duplicates from input diseases list."
      )
    }
  }

  list_of_diseases <- paste(disease,collapse=",")
  result <- NULL


  if (vocabulary== "UMLS") {
    #http://localhost:5555/disgenetv6/api/disease/C0004153,C0002395
    url <- paste0( get_url_disgenet(), "disease/", list_of_diseases , "?format=tsv")
    #url <- paste0( getUrlDGN(), "disease/", list_of_diseases , "?source=",database, "&format=tsv")

  } else {
    url <- paste0( get_url_disgenet(), "disease/",tolower(vocabulary),"/", list_of_diseases ,"?source=",database,"&format=tsv")
  }

  #print(url)
  r <- httr::GET(url)
  if (r$status_code == 200) {
    myTextConnection <- textConnection(rawToChar(r$content ))
    result <- read.csv( myTextConnection, header = TRUE, sep = "\t" )
    close(myTextConnection)
  }else{
    print(httr::http_status(r))
    print(httr::content(r, "text"))
  }
  # x =RCurl::getURL(url)
  # if (grepl("status_code",x) == F) {
  #   dataTsv <- RCurl::getURLContent( url     )
  #   myTextConnection <- textConnection( dataTsv )
  #   result <- read.csv( myTextConnection, header = TRUE, sep = "\t", colClasses=c("character"))
  #   close(myTextConnection)
  # }
  # else{
  #   x <- jsonlite::fromJSON(x)
  #   print(x$detail)
  # }

  if(length( disease )==1){
    cls <- "single"
  }else {
    cls <- "list"
  }

  if (!is.null(result)){
    if(vocabulary == "UMLS"){
      wDiseases <- setdiff(disease, result$diseaseid)
      eDiseases <- intersect(disease, result$diseaseid)
    }else {
      wDiseases <- setdiff(disease,result[, vv])
      eDiseases <- intersect(disease, result[, vv])
    }

    if( length( wDiseases ) != 0 ) {
      diseases <- paste( paste( "   -", wDiseases ), collapse = "\n" )
      if( warnings ) {
        warning( "One or more of the diseases in the list is not in DisGeNET ( '", database, "' ):\n", diseases  )
      }
    }
    result <- new( "DataGeNET.DGN",
                   type       = "disease",
                   search     = cls,
                   term       = as.character( eDiseases ),
                   database   = database,
                   scoreRange = "",
                   qresult    = result
    )
    return( result )
  } else {
    print("no results for the query")
  }
}

#' Retrieves diseases similar to an input disease and generates an \code{DataGeNET.DGN}
#'
#' Given the disease identifier for one or multiple diseases retrieves their asssociated genes
#' from DisGeNET and creates an object of type \code{DataGeNET.DGN}.
#'
#' @param disease  A disease or a list of disease identifiers (CUIs, MeSH, OMIMs...)
#' specific genes from DisGeNET. The genes non contained in DisGeNET will
#' be removed from the output.
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to not see
#' the warnings.
#' @return An object of class \code{DataGeNET.Dis}
#' @examples
#' dis_res <- get_similar_diseases( "C0028754" )
#' @export get_similar_diseases

get_similar_diseases <- function(disease, api_key=NULL, limit = 5   ) {

  if(is.null(api_key)){
    api_key = Sys.getenv('DISGENET_API_KEY')
    if(api_key == ""){
      stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
    }
  }
  list_of_diseases <- paste(unique(disease),collapse=",")
  url <-   paste0(get_url_disgenet(), "disease/similarity/", list_of_diseases , "?source=ALL&format=json&limit=", limit   )
  #print(url)
  # r <- httr::GET(url) http://miranda/disgenetv6/api/disease/similarity/C0002395?format=json
  r <- get_api_connection(url = url, api_key=api_key)
  if (r$status_code == 200) {
    res<-jsonlite::fromJSON(httr::content(r, as = "text", encoding = "UTF-8"), flatten = F)

    result <-res$similar_diseases[[1]]
    result$ref_disease <- res$ref_disease[1]
    result$name <- res$disease_name[1]
    if (length(res$similar_diseases)> 1) {
      for (i in 2:length(res$similar_diseases)) {
        rr <-res$similar_diseases[[i]]
        rr$ref_disease <- res$ref_disease[i]
        rr$name <- res$disease_name[i]
        result <- rbind(result, rr)
      }

    }

    colnames(result)[1]<- "similar_disease"
    colnames(result)[2]<- "similar_disease_name"
    return(result)
  } else{
    print(httr::http_status(r))
    print(httr::content(r, "text"))
  }

}

#' Obtain the raw query from DisGeNET from a \code{DataGeNET.DGN} object.
#'
#' @name extract
#' @rdname extract-methods
#' @aliases DataGeNET.DGN-methods
#' @param object Object of class \code{DataGeNET.DGN}
#' @return A \code{data.frame} containing the raw result from DisGeNET
#' @examples
#' \dontrun{
#' #Being x an DataGeNET.DGN
#' qr <- extract(x) # Get number of unique diseases
#' }
#' @export
setMethod( "extract",
   signature = "DataGeNET.DGN",
   definition = function( object ) {
     return( object@qresult )
   }
)

#' Query for given disease(s) and generates an \code{DataGeNET.RDF}
#'
#' Given the UMLS CUI for a disease, it retrieves the information
#' related to the pharmacology in ChEMBL and creates an object of type \code{DataGeNET.RDF}.
#'
#' @param disease UMLS ID (CUI) for a disease
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param score A vector with two elements: 1) initial value of score 2) final value of score
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to don't see
#' the warnings.
#' @return An object of class \code{DataGeNET.RDF}
#' @examples
#' dis2com <- disease2compound( disease = "C3542021", database = "ALL" )
#' @export disease2compound


disease2compound <- function( disease = "C3542021", database = "CURATED", score = c(0,1), verbose = FALSE, warnings = TRUE ) {

  cat(paste0("Started at ", Sys.time(),"\n"));
  message("Please, be aware of ChEMBL restrictions for their SPARQL endpoint \"https://www.ebi.ac.uk/rdf/what-are-limitations-sparql-endpoints\". \nIf 1000 compounds are retrieved for a single protein it probably means that there are more than 1000.");

  # this function, gives you the pharmacological profile from ChEMBL for an specific disease

  check_disgenet_sources(database);

  if(length(score) != 2) {
    stop("Invalid argument 'score'. It must have two elements: initial value of the score, and final value of the score")
  }
  gdas <- disease2gene(disease, vocabulary= "UMLS", database =  database , score = score)
  unis <- unique(gdas@qresult$uniprotid)
  message(paste0("There are ",length(unis) ," proteins to be queried on the
                 ChEMBL SPARQL endopoint which may take some time, please wait..."));

    # endpoint
    endpoint <- "https://www.ebi.ac.uk/rdf/services/sparql";
    results <- data.frame(uniprot=character(),molecule = character(),moleculeLabel=character())


    for( uniprot in  unis){

            query <-    "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
            PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
            PREFIX owl: <http://www.w3.org/2002/07/owl#>
            PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
            PREFIX dc: <http://purl.org/dc/elements/1.1/>
            PREFIX dcterms: <http://purl.org/dc/terms/>
            PREFIX foaf: <http://xmlns.com/foaf/0.1/>
            PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
            PREFIX cco: <http://rdf.ebi.ac.uk/terms/chembl#>

            SELECT DISTINCT ?uniprot
            ?molecule
            ?moleculeLabel
            WHERE {
            ?targetcmpt cco:targetCmptXref ?uniprot .
            ?target cco:hasTargetComponent ?targetcmpt .
            ?molecule rdfs:label ?moleculeLabel .
            ?assay cco:hasTarget ?target .
            ?activity a cco:Activity ;
            cco:hasMolecule ?molecule ;
            cco:hasAssay ?assay .
            FILTER ( ?uniprot = <http://purl.uniprot.org/uniprot/%s> ) }";


          query <- sprintf(query,  uniprot)

            # prefix <- c("rdfs","http://www.w3.org/2000/01/rdf-schema#","cco","http://rdf.ebi.ac.uk/terms/chembl#");
            cat(paste0("Querying ChEMBL for protein ", uniprot, " ... "));

            res <- tryCatch({
              SPARQL(url=endpoint,query=query )
            },
            error = function(err){
              print(err)
            })
            if (length(res$results) == 0){
              cat(paste0("no compounds found for uniprot ", uniprot, " \n"));

            } else {
              cat(paste0(nrow(res$results)," compounds retrieved for uniprot ", uniprot, " \n"));
              results <- rbind(results, res$results)
            }
          }
      cat(paste0("Ended at ", Sys.time(),"\n"));

      results$uniprot <- gsub("<http://purl.uniprot.org/uniprot/", "", results$uniprot)
      results$uniprot <- gsub(">", "", results$uniprot)
      results <- merge(results, gdas@qresult, by.x = "uniprot", by.y = "uniprotid", all = T)
      scR <- paste0( score[1],"-", score[2])
      result <- new( "DataGeNET.RDF",
                     input     = disease,
                     search    = "compound",
                     database = database,
                     scoreRange = scR,
                     selection = "ChEMBL",
                     mapping   = nrow(results),
                     qresult   = results
      );
    return( result )

}





federated_disease2compound <- function( disease = "C0751955", database = "ALL", score = c(">", 0), verbose = FALSE, warnings = TRUE ) {

  # this function, gives you the pharmacological profile from ChEMBL for an specific disease
  if( verbose ) {
    message( "Starting querying DisGeNET for the disease code ", disease, " and cross its disease genes with ChEMBL data." )
  }
  checkDisGeNET_dbs(database)
  diseaseValidation <-  diseaseMapping(disease, inVocabulary = "umls")
  diseaseValidation <- diseaseValidation@qresult
  disease <- diseaseValidation [diseaseValidation$isFormatOK == T & diseaseValidation$existsInDGN == T, "inputID"]

  if (length(disease)> 0){
    DB_ID <- "\"\""
    if (database == "CURATED") {
      DB_ID <- " \"uniprot|ctd_human|clinvar|orphanet|gwascat\" "
    }
    else if (database == "PREDICTED") {
      DB_ID <- "\"ctd_mouse|mgd|ctd_rat|rgd\""
    }
    else if (database == "ALL") {
      DB_ID <- "\"\""
    }
    else{
      DB_ID <- paste0("\"", tolower(database), "\"")
    }

    if (length(score) != 2) {
      stop("Invalid argument 'score'. It must have two elements.")
    } else if (!score[1] %in% c('>', '<')) {
      stop("Invalid argument 'score'. First element must be '>' or '<'.")
    }

    SCORE <- 0
    if (score[2] > 0) {
      SCORE <- score[2]
    }
    SIGN <- ">"
    if (score[1] ==  "<") {
      SIGN <- "<"
    }
    # endpoint
    endpoint <- "http://rdf.disgenet.org/sparql/"

    # oql is the query that let us look for compounds in ChEMBL
    oql <- "PREFIX cco: <http://rdf.ebi.ac.uk/terms/chembl#>
    SELECT DISTINCT ?disease str(?diseaseName) as ?diseaseName ?gene str(?geneName) as ?geneName  ?uniprot ?source ?score  ?molecule ?moleculeLabel WHERE {
    ?gda sio:SIO_000628 ?gene,?disease .
    ?gda sio:SIO_000253 ?source . FILTER regex(?source, DB_ID )
    ?gda sio:SIO_000216 ?scoreIRI .
    ?scoreIRI sio:SIO_000300 ?score . FILTER (?score SIGN \"SCORE\"^^xsd:decimal)

    ?gene rdf:type ncit:C16612 .
    ?gene dcterms:title ?geneName .
    ?gene sio:SIO_010078 ?protein .
    ?disease rdf:type ncit:C7057 ;
    dcterms:title ?diseaseName ;
    dcterms:identifier ?inputID .
    FILTER regex(?inputID,concat('umls:',?cui))
    values ?cui {'UMLS_CUI'} .
    ?protein skos:exactMatch ?uniprot .
    FILTER regex(?uniprot, 'http://purl.uniprot.org/uniprot/')
    # Query ChEMBL for active molecules
{SELECT ?uniprot ?molecule ?moleculeLabel WHERE {
    SERVICE <http://www.ebi.ac.uk/rdf/services/chembl/sparql> {
    ?molecule rdfs:label ?moleculeLabel .
    ?activity a cco:Activity ;
    cco:hasMolecule ?molecule ;
    cco:hasAssay ?assay .
    ?assay cco:hasTarget ?target .
    ?target cco:hasTargetComponent ?targetcmpt .
    ?targetcmpt cco:targetCmptXref ?uniprot .
    ?uniprot a cco:UniprotRef
    } # end of service
} # end of select
} # end of subquery
    }"

    oql <- stringr::str_replace(string = oql,
                                pattern = "DB_ID",
                                replacement = DB_ID)
    oql <- stringr::str_replace(string = oql,
                                pattern = "SCORE",
                                replacement = SCORE)
    oql <- stringr::str_replace(string = oql,
                                pattern = "SIGN",
                                replacement = SIGN)
    # disease
    # input: query=single, namespace=UMLS. Parse input to substract 'namespace:'.
    if (substr(disease,1,4) == 'umls' & nchar(disease) == 13 & substr(disease,6,6) == 'C' & !is.na(as.numeric(substring(disease,7)))) {
      disease = substr(disease,6,13)
      oql <- stringr::str_replace(
        string = oql,
        pattern = "UMLS_CUI",
        replacement = disease
      )
    } else if (substr(disease,1,1) == 'C' & nchar(substring(disease,2)) == 7 & !is.na(as.numeric(substring(disease,2)))) {
      oql <- stringr::str_replace(
        string = oql,
        pattern = "UMLS_CUI",
        replacement = disease
      )
    }else{
      stop( "\nThe disease introduced: '", disease, "' is not a valid input.
            Remember that only one type of ontology is valid for this query: UMLS CUI (inputted as \"umls:C0028754\" or \"C0028754\").
            Please, check that the disease introduced is a valid UMLS CUI and it is inputted in the correct format, and try again.\n\n" )
    }

    # SPARQL query
    # perform the SPARQL query to DisGeNET
    prefix <- c("sio","http://semanticscience.org/resource/","skos","http://www.w3.org/2004/02/skos/core#")
    message("Performing the query. This is a federated query with ChEMBL and may take some time, please wait...")
    res <- tryCatch({
      SPARQL(url=endpoint,query=oql,ns=prefix)
    },
    error = function(err){
      print(paste0("The query did not work. The error: "),err)
    })
    if (length(res$results) == 0){
      warning("There are no genes for disease ", disease, " and the input parameters that have annotations in ChEMBL.")
    } else {

      result <- new( "DataGeNET.RDF",
                     input     = disease,
                     search    = "compound",
                     selection = "umls",
                     mapping   = nrow(res$result),
                     qresult   = res$result
      )
      return( result )
    }

  }else{
    warning("The  disease ", disease, " is not in DisGeNET (", database, ", ", score, ")")
  }
}

#' Query for given gene(s) and generates an \code{DataGeNET.RDF}
#'
#' Given a NCBI gene identifier, retrieves the GO (Gene Ontology) information
#' related to the cellular location of the gene product and creates an object
#' of type \code{DataGeNET.RDF}.
#'
#' @param gene NCBI gene ID
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to don't see
#' the warnings.
#' @return An object of class \code{DataGeNET.RDF}
#' @examples
#' gene2cc <- gene2cellcomponent( gene = 1588 )
#' @export gene2cellcomponent


gene2cellcomponent <- function( gene, verbose = FALSE, warnings = TRUE ) {

  endpoint <- "http://rdf.disgenet.org/sparql/"
  message("Performing the query. This is a federated query with Wikidata and may take some time, please wait...")

     # oql is the query that let us look for drug indications in Wikidata
    query <- "PREFIX wd: <http://www.wikidata.org/entity/>
      PREFIX wdt: <http://www.wikidata.org/prop/direct/>

      SELECT DISTINCT str(?ncbigene_id) as ?ncbi_geneid ?gene_iri
     str(?gene_product_label) as ?gene_product_label str(?go_id) as ?go_id
     str(?go_label) as ?go_label ?cell_component_iri WHERE {

      # Wikidata query
      SERVICE <https://query.wikidata.org/sparql> {
        ?gene wdt:P351 ?ncbigene_id . FILTER (?ncbigene_id = \"%s\")
        ?gene wdt:P688 ?gene_product .  # gene_product (usually a protein) is a product of a gene (a region of DNA)
        ?gene_product rdfs:label ?gene_product_label .
        filter (lang(?gene_product_label) = 'en')
        ?drug wdt:P129 ?gene_product .   # drug interacts with a gene_product
        ?gene_product wdt:P681 ?cell_component_iri . #add information about the GO cell component
        ?cell_component_iri rdfs:label ?go_label ;
                        wdt:P686 ?go_id .
        filter (lang(?go_label) = 'en')
      }

      # DisGeNET query
      BIND(IRI(CONCAT(\"http://identifiers.org/ncbigene/\",?ncbigene_id)) as ?gene_iri)
      ?gene_iri rdf:type ncit:C16612 .
      }"

    query <- sprintf(query,  as.character(gene))
    # print(query)
    # SPARQL query
    # perform the SPARQL query to DisGeNET
    prefix <- c("sio","http://semanticscience.org/resource/","skos","http://www.w3.org/2004/02/skos/core#")
    #message("Performing the query. This is a federated query with Wikidata and may take some time, please wait...")
    res <- tryCatch({
      SPARQL(url=endpoint,query=query,ns=prefix)
    },
    error = function(err){
      print(paste0("The query did not work. The error: "),err)
    })
    if (length(res$results) > 0){
      results <-res$results
          result <- new( "DataGeNET.RDF",
                     input     = as.character(gene),
                     search    = "GOCC",
                     selection = "gene",
                     mapping   = nrow(results),
                     qresult   = results  )
      return( result )
    } else {
    if( verbose ) {
      message("The gene ",gene, " has no annotations in Wikidata.")
    }

 }
}

#' Estimates the p value of the Jaccard Coefficient for pairs of diseases
#'
#' This function estimates the statistic significance of the Jaccard Coefficient with a bootstrap
#' @param object receives dataframe produced by function disgenetDisDis
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param nboot Number of iterations sued to compute the pvalue associted
#' to the calculated Jaccard Index. Default: 1000.
#' @param ncores Number of cores used to calculate the pvalue associated to
#' the computed Jaccard Index. Default: 1.
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @examples
#' ji <- pvalue_estimation( object = dis, "CURATED" )
#' @export pvalue_estimation



pvalue_estimation <- function(input, database="CURATED", api_key=NULL,  nboot = 100, ncores = 1, verbose = FALSE) {
  if(is.null(api_key)){
    api_key = Sys.getenv('DISGENET_API_KEY')
    if(api_key == ""){
      stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
    }
  }
  check_disgenet_sources(database)

  colnames(input)<- tolower(colnames(input))
  if ( length(intersect("jaccard_genes", colnames(input))) > 0 ){
    type <- "gene"
    url <- paste0( get_url_disgenet(), "gene/source/",database, "?format=tsv")
    r <- get_api_connection(url = url, api_key=api_key)

    if (r$status_code == 200) {
      myTextConnection <- textConnection(rawToChar(r$content ))
      result <- read.csv( myTextConnection, header = TRUE, sep = "\t" )
      close(myTextConnection)
    }else{
      #print(httr::http_status(r))
      print(httr::content(r, "text"))
    }
    input$jaccard_index <- input$jaccard_genes
  }   else if ( length(intersect("jaccard_variants", colnames(input))) > 0 ){
    type <- "variant"
    load(system.file("extdata", "universe.rda", package="disgenet2r"))

    result <-unique(universe_vdas[,c("variantid", "source")])
    result <- result[ result$source==database,  ]

    input$jaccard_index <- input$jaccard_variants
  }


  if (type =="gene"){
    universe <- as.character(unique(result$geneid))
  } else {
    universe <- as.character(unique(result$variantid))
  }

  message(paste0("A total of ", length(universe), " ", type,
            "s obtained from DisGeNET database ", database, " are
                 being used for the bootstrap process\n")
  )

    input$pvalue <- NA
    message("Pvalue estimation")

    for(i in 1:nrow( input )){
      if( verbose ) {
        message(paste0("\n\t->Disease pair ", i, " of ", nrow(input), " total diseases' pairs."))
      }
      if (type == "gene"){
        bb <- ji.internal(input$ngenes1[i], input$ngenes2[i], universe, nboot, ncores)
      } else {
        bb <- ji.internal(input$nvariants1[i], input$nvariants2[i], universe, nboot, ncores)
      }
      pvalue <- (sum(bb > input$jaccard_index[i]) * 1.0) / (nboot)
      input$pvalue[i] <- round(pvalue, 5)
    }
    return(input)

  }

  ji.internal <- function(len1, len2, universe, nboot, ncores) {
    if (!requireNamespace("parallel", quietly = TRUE)) {
      pfun <- lapply
    } else {
      pfun <- parallel::mclapply
    }

    unlist(pfun(1:nboot, function(ii) {
      g1 <- sample( universe, len1 )
      g2 <- sample( universe, len2 )
      ja.coefr <- length(intersect(g1, g2)) / length(union(g1, g2))
    }, mc.cores = ncores))
  }

#' Retrieves evidences supporting the associations, for a disease, or a list of diseases,
#' and generates an \code{DataGeNET.DGN}
#'
#' @param disease  A disease or a list of diseases identified by the Concept Unique Identifiers
#' @param variant a variant or a list of variants
#' @param gene a gene, or a list of genes identified by NCBI identifiers, or HGNC symbols.
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param score A vector with two elements: 1) initial value of score 2) final value of score
#' @param type one of two possible values: "GDA" or "VDA" depending if the user wants to retrieve gene-disease associations or
#' variant-disease associations.
#' @param year A vector with two elements: 1) initial value of year 2) final value of year
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to not see
#' the warnings.
#' @return An object of class \code{DataGeNET.Dis}
#' @examples
#' g <- disease2evidence( disease="C0002395", "CURATED", score=c(0,1)  )
#' @export disease2evidence


disease2evidence <- function( disease=disease, type = 'GDA',
                           gene = NULL, variant=NULL, year=c(0, 2050), limit = 10,
                           database = "CURATED", score=c(0,1), api_key=NULL,  verbose = FALSE, warnings = TRUE ) {
  if(is.null(api_key)){
    api_key = Sys.getenv('DISGENET_API_KEY')
    if(api_key == ""){
      stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
    }
  }
  check_disgenet_sources( database )

  if( length( disease ) != length( unique( disease ) ) ) {
    disease <- unique( disease )
    warning(
      "Removing duplicates from input disease list."
    )
  }

  # type <- "symbol"
  # if( vocabulary == "HGNC" ){
  #   #do nothing
  # } else if( vocabulary == "ENTREZ" ){
  #   type <- "entrez"
  # } else if( class( gene[1] ) == "factor"){
  #   message("Your input genes are in factor format.
  #   Please, revise your input genes and save them as numeric or as character.")
  #   stop()
  # } else {
  #   message(paste0("Your input genes are a wrong vocabulary ", vocabulary,
  #                  "Please, revise your input vocabulary. Remember that genes should be identified
  #                  using HGNC gene symbols or NCBI Entrez identifiers"))
  #   stop()
  # }
  if( type =="GDA" & !is.null(variant)) {
    stop("You must select 'type=VDA' if you are going to query disease2evidence with a variant or a list of variants")
  }
  if( type =="VDA" & !is.null(gene)) {
    message("You are using the argument 'type=VDA' and querying with genes. This will retrieve the variants in the gene(s) associated to diseases.
            To obtain gene-disease associations, change the argument 'type' to 'GDA'")
  }


  if(length(score) != 2) {
    stop("Invalid argument 'score'. It must have two elements: initial value of the score, and final value of the score")
  }

  if(length(year) != 2) {
    stop("Invalid argument 'year'. It must have two elements: initial year and final year")
  }
  list_of_genes <- paste(gene,collapse=",")
  list_of_diseases <- paste(disease,collapse=",")
  list_of_variants <- paste(variant,collapse=",")

  result <- NULL

  if(type == "GDA"){
    if(!is.null(gene)){
      url <- paste0( get_url_disgenet(), "gda/evidences/disease/", list_of_diseases , "?gene=", list_of_genes, "&source=",database, "&min_score=",score[1],"&max_score=", score[2], "&min_year=",year[1],"&max_year=", year[2])
    }
    else{
      url <- paste0( get_url_disgenet(), "gda/evidences/disease/", list_of_diseases , "?source=",database, "&min_score=",score[1],"&max_score=", score[2], "&min_year=",year[1],"&max_year=", year[2])

    }
  } else if(type == "VDA"){
    if (!is.null(variant) & !is.null(gene)){
      url <- paste0( get_url_disgenet(), "vda/evidences/disease/", list_of_diseases , "?variant=",list_of_variants , "&gene=",list_of_genes, "&source=",database, "&min_score=",score[1],"&max_score=", score[2], "&min_year=",year[1],"&max_year=", year[2])
    }
    else  if(!is.null(variant)){
      url <- paste0( get_url_disgenet(), "vda/evidences/disease/", list_of_diseases , "?variant=",list_of_variants , "&source=",database, "&min_score=",score[1],"&max_score=", score[2], "&min_year=",year[1],"&max_year=", year[2])
    } else   if(!is.null(gene)){
      url <- paste0( get_url_disgenet(), "vda/evidences/disease/", list_of_diseases , "?gene=",list_of_genes , "&source=",database, "&min_score=",score[1],"&max_score=", score[2], "&min_year=",year[1],"&max_year=", year[2])
    }
    else{
      url <- paste0( get_url_disgenet(), "vda/evidences/disease/", list_of_diseases , "?source=",database, "&min_score=",score[1],"&max_score=", score[2], "&min_year=",year[1],"&max_year=", year[2])
    }
  }
  else {
    message(paste0("The argument 'type' is invalid: ", type,
                   "Please, revise your input type Remember that it should be VDA or GDA"))
    stop()
  }


  r <- get_api_connection(url = url, api_key=api_key)
  if (r$status_code == 200) {

    res<-jsonlite::fromJSON(httr::content(r, as = "text", encoding = "UTF-8"), flatten = F)
    result <- res$results

    while (is.null(res$`next` )==F) {
      r <- get_api_connection(url = res$`next`, api_key=api_key)
      if (r$status_code == 200) {

        res <- jsonlite::fromJSON(httr::content(r, as = "text", encoding = "UTF-8"), flatten = F)
        result <- rbind(result, res$results)
      }
    }

  } else{
    print(httr::http_status(r))
    print(httr::content(r, "text"))
  }



  if(length( disease )==1){
    cls <- "single"
  }else{
    cls <- "list"
  }

  scR <- paste0( score[1],"-", score[2])

  if (! is.null(result) > 0){
   missing_diseases <- setdiff(disease, result$disease_id)
   found_diseases <- intersect(disease, result$disease_id)

    if( length( missing_diseases ) > 0 ) {
      diseases <- paste( paste( "   -", missing_diseases ), collapse = "\n" )
      if( warnings ) {
        warning( "\n One or more of the genes in the list is not in DisGeNET ( '", database, "' ):\n", diseases )
      }
    }

    result <- new( "DataGeNET.DGN",
                   type = "evidence",
                   search = cls,
                   term = as.character( found_diseases ),
                   scoreRange = scR,
                   database = database,
                   qresult = result )

    return( result )
  } else {
    print("no results for the query")
  }
}

# Private function. Given an RDF data frame, returns the formatted data frame
# input: inID = input ID, InVocabulary = input vocabulary
# output: uri = the resulting URI. If the format is incorrect it returns NA
getFormattedDataFrame <- function( df, verbose = FALSE, warnings = FALSE  ) {

  #df <- as.data.frame(apply(df, 1:2, function(x) strsplit(gsub(">", "", x), "\\/")[[1]][length(strsplit(x, "\\/")[[1]])] ))

  # df$disease <- gsub("<http://linkedlifedata.com/resource/umls/id/", "", df$disease)
  # df$disease <- gsub(">", "", df$disease)
  # df["gene"] <- apply(df["gene"], 1:2, function(x) strsplit(gsub(">", "", x), "\\/")[[1]][length(strsplit(x, "\\/")[[1]])] )
  colnames(df)[which(colnames(df) == "disease")] <- "diseaseid"
  colnames(df)[which(colnames(df) == "gene")] <- "geneid"
  colnames(df)[which(colnames(df) == "geneSymbol")] <- "geneSymbol"
  colnames(df)[which(colnames(df) == "geneName")] <- "description"
  df$source <- gsub("<http://rdf.disgenet.org/v6.0.0/void/","", df$source)
  df$source <- gsub(">","", df$source)
  df$diseaseid <- gsub("umls:","", df$diseaseid)
  df$geneid <- gsub("ncbigene:","", df$geneid)
  if (length(df[, colnames(df)=="molecule"]) == 0){
    #df <- as.data.frame(apply(df, 1:2, function(x) strsplit(gsub(">", "", x), "\\/")[[1]][length(strsplit(x, "\\/")[[1]])] ))
    df["source"] <- apply(df["source"], 1:2, function(x) strsplit(gsub(">", "", x), "\\/")[[1]][length(strsplit(x, "\\/")[[1]])] )

    #colnames(df)[which(colnames(df) == "source")] <- "sourceId"
    #df$sourceId <- gsub("-2016", "", df$sourceId)
    df$source <- toupper(df$source )
    df$source <- gsub("CTD_HUMAN", "CTD_human", df$source)
    df$source <- gsub("CTD_RAT", "CTD_rat", df$source)
    df$source <- gsub("CTD_MOUSE", "CTD_mouse", df$source)
  }
  else{
    df["uniprot"] <- apply(df["uniprot"], 1:2, function(x) strsplit(gsub(">", "", x), "\\/")[[1]][length(strsplit(x, "\\/")[[1]])] )

  }
  if (length(df[, colnames(df)=="snp"]) >  0){
    df["snp"] <- apply(df["snp"], 1:2, function(x) strsplit(gsub(">", "", x), "\\/")[[1]][length(strsplit(x, "\\/")[[1]])] )
  }
  return(df);
}

#' Retrieves disease-disease associations via shared genes and generates an \code{DataGeNET.DGN}
#'
#' Given the CUI of one or multiple diseases, retrieves the associated diseases
#' from DisGeNET and creates an object of type \code{DataGeNET.Dis}.
#'
#' @param disease a CUI or a vector of CUIs
#' The diseases non existing in DisGeNET will
#' be removed from the output.
#' @param vocabulary   The vocabulary of the disease identifier(s)
#' Select one of the available:  \code{UMLS} (UMLS), \code{OMIM} (OMIM), \code{MSH} (MeSH), \code{DO} (Disease Ontology),
#' \code{NCI} (NCI thesaurus), \code{ORDO} (Orphanet),
#' \code{ICD9CM} (ICD9-CM) or \code{EFO} (EFO). Default \code{'UMLS'}.
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param ndiseases The number of associated diseases to retrieve. By default 10. Set to XX to retrieve all diseases
#' @param pvalue p value of the bootstrap. See more info at www.disgenet.org. By default 1
#' @param verbose By default \code{FALSE}. Set to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Set to \code{FALSE} to hide the warnings.
#' @return An object of class \code{DataGeNET.Dis}
#' @examples
#' dd1 <- disease2disease_by_gene( "C0028754", database = "CURATED" , pvalue = 0.05)
#' @export disease2disease_by_gene


disease2disease_by_gene <- function( disease, vocabulary= "UMLS",  ndiseases =10, database = "CURATED", api_key=NULL,  verbose = FALSE, warnings = TRUE ) {
  if(is.null(api_key)){
    api_key = Sys.getenv('DISGENET_API_KEY')
    if(api_key == ""){
      stop("This is not a valid API KEY! Please, use the function `get_disgenet_api_key` to get your API key from DisGeNET")
    }
  }
  check_disgenet_sources( database )
  vocabularies <- c("UMLS", "OMIM", "NCI", "MESH", "ICD9CM", "EFO", "DO", "HPO", "ORDO")
  vv <- intersect(vocabulary, vocabularies)
  if (length(vv) == 0) {
    stop(paste0(vocabulary,  " is a wrong vocabulary! Allowed vocabularies are: \n", paste(vocabularies, collapse = "\n")))
  }
  if (vv != "UMLS") {
    vv <- paste0(tolower(vv), "_id")
  }

  if( length( disease ) != length( unique( disease ) ) ) {
    disease <- unique( disease )
    if( warnings ) {
      warning(
        "Removing duplicates from input diseases list."
      )
    }
  }

  result    <- data.frame()
  for (ii in 1:length(disease) ){

    if( verbose ) {
      message(
        "Retrieving data for ", disease[ii], " from DisGeNET"
      )
    }
    if (vocabulary== "UMLS") {
      #url <- paste0( get_url_disgenet(), "dda/genes/disease/", disease[ii] ,"?limit=", ndiseases, "&source=", database, "&pvalue=", pvalue, "&format=tsv")
      url <- paste0( get_url_disgenet(), "dda/genes/disease/", disease[ii] ,"?limit=", ndiseases, "&source=", database, "&format=tsv")

    } else {
      #url <- paste0( get_url_disgenet(), "dda/genes/disease/",tolower(vocabulary),"/", disease[ii], "?limit=", ndiseases, "&source=", database, "&pvalue=", pvalue,  "&format=tsv")
      url <- paste0( get_url_disgenet(), "dda/genes/disease/",tolower(vocabulary),"/", disease[ii], "?limit=", ndiseases, "&source=", database, "&format=tsv")
    }
    #print(url)
    # x = RCurl::getURL(url)
    # if (grepl("status_code",x) == F) {
    #   dataTsv <- RCurl::getURLContent( url     )
    #   myTextConnection <- textConnection( dataTsv )
    #   dataNew <- read.csv( myTextConnection, header = TRUE, sep = "\t", colClasses=c("character"))
    #   result <- rbind(result, dataNew)
    #   close(myTextConnection)
    # } else {
    #   x <- jsonlite::fromJSON(x)
    #   print(x$detail)
    # }
    #r <- httr::GET(url)
    r <- get_api_connection(url = url, api_key=api_key)

    if (r$status_code == 200) {
      myTextConnection <- textConnection(rawToChar(r$content ))
      dataNew <- read.csv( myTextConnection, header = TRUE, sep = "\t" )
      result <- rbind(result, dataNew)
      close(myTextConnection)
    } else if (r$status_code == 404){
      message(
        "The disease ", disease[ii], " is not present in DisGeNET, data source ", database
      )
    }   else{
      #print(httr::http_status(r))
      print(httr::content(r, "text"))
    }
  }

  if(length( disease )==1){
    cls <- "single"
  }else {
    cls <- "list"
  }

  if (!is.null(result)){
    if(vocabulary == "UMLS"){
      wDiseases <- setdiff(disease, result$diseaseid1)
      eDiseases <- intersect(disease, result$diseaseid1)
    }else {
      wDiseases <- setdiff(disease,result[, vv])
      eDiseases <- intersect(disease, result[, vv])
    }

    if( length( wDiseases ) != 0 ) {
      diseases <- paste( paste( "   -", wDiseases ), collapse = "\n" )
      if( warnings ) {
        warning( "One or more of the diseases in the list is not in DisGeNET ( '", database, "' ):\n", diseases  )
      }
    }
    #result$pv <- as.numeric(as.character(result$score))
    result <- pvalue_estimation(result, database = database, api_key=api_key, nboot = 1000)
    result$pvalue <- as.numeric(as.character(result$pvalue))
    result$pvalue <- round(result$pvalue, 3)
    result$jaccard_genes <- as.numeric(as.character(result$jaccard_genes))
    result$jaccard_genes <- round(result$jaccard_genes, 3)
    result <- result[c( "diseaseid1", "disease1_name", "diseaseid2", "disease2_name",
                        "disease1_disease_class", "disease1_disease_class_name",
                        "disease2_disease_class", "disease2_disease_class_name",
                        "jaccard_genes", "pvalue", "ngenes",
                       "ngenes1" ,"ngenes2" ,  "source"  )]
    result <- result[ result$pvalue < 0.05  , ]
    result <- new( "DataGeNET.DGN",
                   type     = "disease-disease-gene",
                   search   = cls,
                   term       = as.character( eDiseases ),
                   database = database,
                   scoreRange =  "",
                   qresult  = result
    )

    return( result )
  }
}

#' Query for given disease(s) and generates an \code{DataGeNET.RDF}
#'
#' Given the UMLS ID (CUI) for a disease, retrieves the associated genes,
#' and the pathway(s) in WikiPathways to which the genes are annotated.
#' It creates an object of type \code{DataGeNET.RDF}.
#' @param disease UMLS ID (CUI) for a disease
#' @param database Name of the database that will be queried. It can take the values:
#' \code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
#' \code{'UNIPROT'} to use Universal Protein Resource;
#' \code{'CLINGEN'} to use Clinical Genome Resource;
#' \code{'CGI'} to use Cancer Genome Interpreter;
#' \code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
#' \code{'PSYGENET'} to use PSYGENET;
#' \code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
#' \code{'CURATED'} to use expert curated, human databases;
#' \code{'HPO'} to use HPO;
#' \code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
#' \code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
#' \code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
#' \code{'RGD'}, to use Rat Genome Database;
#' \code{'MGD'}, to use the Mouse Genome Database;
#' \code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
#' \code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
#' \code{'GWASDB'} to use the GWAS Database GWASdb;
#' \code{'CLINVAR'} to use ClinVar, a public archive of relationships
#' among sequence variation and human phenotype;
#' \code{'BEFREE'} to use text mining data, generated using BeFree System;
#' \code{'ALL'} to use all these databases. Default \code{'CURATED'}.
#' @param score A vector with two elements: 1) initial value of score 2) final value of score
#' @param verbose By default \code{FALSE}. Change it to \code{TRUE} to get a
#' on-time log from the function.
#' @param warnings By default \code{TRUE}. Change it to \code{FALSE} to don't see
#' the warnings.
#' @return An object of class \code{DataGeNET.RDF}
#' @examples
#' dis2path <- disease2pathway( disease = "C0751955" )
#' @export disease2pathway


disease2pathway <- function( disease , database = "CURATED", score = c(0,1), verbose = FALSE, warnings = TRUE ) {

  # this function, gives you a list of pathway(s) from WikiPathways for an specific disease

  check_disgenet_sources( database )

  DB_ID <- "\"\""
  if (database == "CURATED") {
    DB_ID <- toupper(" \"uniprot|ctd_human|clinvar|orphanet|CLINGEN|GENOMICS_ENGLAND|CGI|psygenet\" ")
  }
  else if (database == "ANIMAL_MODELS") {
    DB_ID <- toupper("\"ctd_mouse|mgd|ctd_rat|rgd\"")
  }
  else if (database == "ALL") {
    DB_ID <- "\"\""
  }
  else{
    DB_ID <- paste0("\"", toupper(database), "\"")
  }


  if(length(score) != 2) {
    stop("Invalid argument 'score'. It must have two elements: initial value of the score, and final value of the score")
  }
  # endpoint
  endpoint <- "http://rdf.disgenet.org/sparql/"



  message("Performing the query. This is a federated query with WikiPathways and may take some time, please wait...")
  query <- "PREFIX wp:      <http://vocabularies.wikipathways.org/wp#>

      SELECT DISTINCT ?diseaseid str(?diseaseName) as ?diseaseName
      ?geneid str(?geneSymbol) as ?geneSymbol str(?geneName) as ?geneName
       ?score ?source ?pathway str(?pathwayName) as ?pathwayName WHERE {
      # Query DisGeNET for disease-genes
      ?disease skos:exactMatch <http://bio2rdf.org/umls:%s> .
      ?gda sio:SIO_000628 ?gene,?disease .
      ?gda sio:SIO_000253 ?source .
     ?gene rdf:type ncit:C16612 ;
      dcterms:identifier ?geneid;
      sio:SIO_000205 ?gSymbol;
      dcterms:title ?geneName .
      ?gSymbol dcterms:title ?geneSymbol .
      ?disease rdf:type ncit:C7057;
      dcterms:identifier ?diseaseid;
      dcterms:title ?diseaseName .
      ?gda sio:SIO_000253 ?source .

      ?gda sio:SIO_000216 ?scoreIRI .
      ?scoreIRI sio:SIO_000300 ?score .
      FILTER (?score >= %f && ?score<= %f)
      FILTER regex( ?source, %s )

      # Query WikiPathways for gene-pathways
      SERVICE <http://sparql.wikipathways.org/sparql> {
      ?geneProduct a wp:GeneProduct .
      ?geneProduct wp:bdbEntrezGene ?gene .
      ?geneProduct rdfs:label ?GeneLabel .
      ?geneProduct dcterms:isPartOf ?pathwayid .
      ?pathwayid dc:identifier ?pathway .
      ?pathwayid dc:title ?pathwayName .
      }
      }
      ORDER BY DESC(?pathwayName)"

      query <- sprintf(query, disease, score[1],score[2],DB_ID)
      #print(    query)
      # SPARQL query
      # perform the SPARQL query to DisGeNET
      #print(oql)
      prefix <- c("sio","http://semanticscience.org/resource/","skos","http://www.w3.org/2004/02/skos/core#")
      res <- tryCatch({
        SPARQL(url=endpoint,query=query,ns=prefix)
      },
      error = function(err){
        print(err)
      })



   if (length(res$results) > 0) {
    scR <- paste0( score[1],"-", score[2])

    results <- res$result
    results<- getFormattedDataFrame(results)
    result <- new( "DataGeNET.RDF",
                   input     = disease,
                   search    = "pathway",
                   database = database,
                   scoreRange = scR,
                   selection = "wikipathways",
                   mapping   = nrow(results),
                   qresult   = results
    )
    return( result )
  }
  else{
    print(paste0("There were no results for this query"))
  }

}

---
title: 'disgenet2r: An R package to explore the molecular underpinnings of human diseases'
author: IBI group
date: "`r Sys.Date()`"
output:
  prettydoc::html_pretty:
    highlight: github
    toc: yes
  pdf_document:
    toc: yes
  html_document:
    df_print: paged
    toc: yes
bibliography: disgenet2r.bib
biblio-style: apalike
vignette: |
  
  %\usepackage[utf8]{inputenc} %\VignetteEncoding{UTF-8} %\VignetteIndexEntry{disgenet2r: An R package to explore the molecular underpinnings of human diseases} %\VignetteEngine{knitr::rmarkdown}
---

```{r style, echo=FALSE, results="asis", message=FALSE}
knitr::opts_chunk$set(tidy = FALSE,
                      warning = FALSE,
                      message = FALSE,
                      cache = F)
```


# Introduction

\noindent The **disgenet2r** package contains a set of functions to retrieve, visualize and expand [DisGeNET](www.disgenet.org) data. DisGeNET is a discovery platform that contains information about the genetic basis of human diseases [@Pinero2015; @Pinero2017; @Pinero2019]. DisGeNET integrates data from several expert curated databases and from text-mining the biomedical literature.   

\noindent The current version of DisGeNET (v7.0) contains 1134942 gene-disease associations (GDAs), between 21671 genes and 30170 diseases, disorders, traits, and clinical or abnormal human phenotypes, and 369554 variant-disease associations (VDAs), between 194515 variants and 14155 diseases, traits, and phenotypes.



\noindent The information in DisGeNET is organized according to the original data source (Table 1). 
Diseases are identified using the UMLS concept unique identifier (CUI), but mappings to commonly employed biomedical vocabularies such as MeSH, OMIM, DO, HPO, and ICD-9 are also provided. The genes are identified using the NCBI Entrez Identifier, but annotations to the official gene symbol, the UniProt identifier, and the Panther Protein Class are also supplied. Finally, the GDAs and VDAs can be ranked using the DisGeNET score. The DisGeNET score ranges from 0 to 1, and takes into account the evidence supporting the association (See more information at [http://disgenet.org/dbinfo/](http://disgenet.org/dbinfo/ "DisGeNET's information"))

\noindent DisGeNET data is also represented as a Resource Description Framework (RDF), which provides new opportunities for data integration, making possible to link DisGeNET data to other external RDF datasets [@Queralt-Rosinach2016]. 

Table: Sources of DisGeNET data

```{r echo=FALSE,  message=FALSE}
library(kableExtra)
table1 <- data.frame(
  Source_Name = 
    c("CTD_human", "CGI", "CLINGEN", "GENOMICS_ENGLAND", "ORPHANET", "PSYGENET",  "HPO",
           "UNIPROT", "CLINVAR", "GWASCAT", "GWASDB" ,
        "CTD_mouse",   "MGD", "CTD_rat", "RGD", 
        "BEFREE",  "LHGDN",
        "CURATED", "INFERRED", "ANIMAL_MODELS", "ALL"), 
  Type_of_data= c("GDAs","GDAs","GDAs", "GDAs", "GDAs", "GDAs", "GDAs",
                  "GDAs/VDAs", "GDAs/VDAs", "GDAs/VDAs", "GDAs/VDAs", 
                  "GDAs",  "GDAs", "GDAs","GDAs",
                  "GDAs/VDAs", "GDAs", 
                  "GDAs/VDAs", "GDAs", "GDAs", "GDAs/VDAs"), 
  Description =c("The Comparative Toxicogenomics Database, human data", 
               "The Cancer Genome Interpreter",
               "The Clinical Genome Resource", 
               "The Genomics England PanelApp", "The portal for rare diseases and orphan drugs", 
               "Psychiatric disorders Gene association NETwork",
               "Human Phenotype Ontology",
               "The Universal Protein Resource", 
               "ClinVar, public archive of relationships among sequence variation and human phenotype",
               "The NHGRI-EBI GWAS Catalog", "The GWas Database",
               "The Comparative Toxicogenomics Database, Mus musculus data",
               "The Mouse Genome Database", 
               "The Comparative Toxicogenomics Database, Rattus norvergicus data",
               "The Rat Genome Database", 
               "Data from text mining medline abstracts using the BeFree System [@Bravo2015]" ,
               "Literature-derived human gene-disease network generated by text mining NCBI GeneRIFs [@Bundschus2008]" ,
            "Human curated sources: CTD, ClinGen, CGI, UniProt, Orphanet, PsyGeNET,  Genomics England PanelApp", "Inferred data from: HPO,ClinVar, GWASCat, GwasDB", 
               "Data from animal models: CTD_rat, RGD, CTD_mouse, MGD", 
               "All data sources"
               )) 
 
kable(table1) %>%   kable_styling(bootstrap_options = "striped", full_width = F)
                               

```


# Contact
For questions regarding **disgenet2r**, contact our support account at <support@disgenet.org>.


# Installation and first run 

\noindent The package **disgenet2r** is available through Bitbucket.
The package requires an R version > 3.5. Additionally, the following packages are needed:
VennDiagram, stringr, tidyr, SPARQL, RCurl, igraph, ggplot2, and reshape2.

\noindent Install **disgenet2r** by typing in R:

```{r   message=FALSE, eval=F, warning=F}
library(devtools)
install_bitbucket("ibi_group/disgenet2r")
``` 

 To load the package:

```{r warning = FALSE, message = FALSE}
library(disgenet2r)
``` 

To be able to use the **disgenet2r** package, you need to register for a free account [here](http://disgenet.org/signup). Once you have completed the registration process, use the **get_disgenet_api_key** to retrieve your API key.


```{r warning = FALSE, eval =F, message = FALSE}

disgenet_api_key <- get_disgenet_api_key(
                  email = "user@email.com", 
                  password = "myspwd" )

``` 

After retrieving the API key, run the line below so the key is available for all the **disgenet2r** functions. 


```{r, warning = FALSE, message = FALSE, eval=F}
Sys.setenv(DISGENET_API_KEY= disgenet_api_key)
```


 In the following document, we illustrate how to use the **disgenet2r** package through a series of examples. 

# Retrieving Gene-Disease Associations from DisGeNET

## Searching by gene

\noindent The **gene2disease** function retrieves the GDAs in DisGeNET for a given gene, or a for a list of genes. The gene(s) can be identified by either the NCBI gene identifier, or the official Gene Symbol, and the type of identifier used must be specified using the parameter `vocabulary`. By default, `vocabulary = "HGNC"`, to switch to Entrez NCBI Gene identifiers, set vocabulary to *ENTREZ*. 

\noindent The function also requires the user to specify the source database using the argument `database`. By default, all the functions in the **disgenet2r** package use as source database *CURATED*, which includes GDAs from CTD (human data), PsyGeNET, the HPO, Genomics England PanelApp, ClinGen, CGI, UniProt, and Orphanet.

\noindent The information can be filtered using the DisGeNET score. The argument `score` is filled with a range of score to perform the search. The score is entered as a vector which first position is the initial value of score, and the second argument is the final value of score. Both values will always be included. By default, `score=c(0,1)`.


\noindent In the example, the query for the Leptin Receptor (Gene Symbol `LEPR`, and Entrez NCBI Identifier `3953`) is performed in all databases in DisGeNET (`database = "ALL"`). 

```{r, warning = FALSE, message = FALSE}
data1 <- gene2disease( gene = 3953, vocabulary = "ENTREZ",
                       database = "CURATED")
```

\noindent The function **gene2disease** produces an object `DataGeNET.DGN` that contains the results of the query.

```{r, warning = FALSE, message = FALSE}
class(data1)
```

\noindent Type the name of the object to display its attributes: the input parameters such as whether a single entity, or a list were searched (`single` or `list`), the type of entity (`gene-disease`), the selected database (`ALL`), the score range used in the search (`0-1`), and the gene NCBI identifier (`3953`).

```{r, warning = FALSE, message = FALSE}
data1


```

\noindent To obtain the data frame with the results of the query, apply the **extract** function:

```{r, warning = FALSE, message = FALSE}
results <- extract(data1)
head( results, 3 )
```

\noindent The same query can be performed using the Gene Symbol (`LEPR`). Additionally, a minimum threshold for the score can be defined. In the example, a cutoff of `score=c(0.2,1)` is used. Notice how the number of diseases associated to the Leptin Receptor drops from 264 to 68 when the score is restricted. 


```{r, warning = T, echo=F, message = FALSE}
data1 <- gene2disease( gene = "LEPR",
                        vocabulary = "HGNC",
                       database = "ALL",
                       score =c(0.3,1))
data1
results <- extract(data1)

```

### Visualizing the diseases associated to a single gene

\noindent The **disgenet2r** package offers two options to visualize the results of querying DisGeNET for a single gene: a  network showing the diseases associated to the gene of interest (`Gene-Disease Network`), and a network showing the MeSH Disease Classes of the diseases associated to the gene (`Gene-Disease Class Network`). These graphics can be obtained by changing the `class` argument in the plot function.

\noindent By default, the **plot** function produces a `Gene-Disease Network` on a `DataGeNET.DGN` object (Figure 1). In the `Gene-Disease Network` the blue nodes are diseases, the pink nodes are genes, and the width of the edges is proportional to the score of the association. The `prop` parameter allows to adjust the width of the edges while keeping the proportionality to the score. 

 
```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 1: The **Gene-Disease Network** for the Leptin Receptor gene"}

plot( data1,
      class = "Network",
      prop = 20)


```


\noindent The results can also be visualized in a network in which diseases are grouped by the MeSH Disease Class if the `class` argument is set to "DiseaseClass" (`Gene-Disease Class Network`, Figure 2). In the `Gene-Disease Class Network`, the node size of is proportional to the fraction of diseases in the disease class, with respect to the total number of diseases with disease classes associated to the gene. In the example, the Lepin Receptor is associated mainly to Nutritional and Metabolic Diseases. There is 1 disease in the example that does not have annotations to MeSH disease class (Shown as a warning).

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 2: The **Disease Class Network** for the Leptin Receptor Gene"}
plot( data1,
      class = "DiseaseClass",
      prop = 3)

```

### Exploring the evidences associated to a gene

You can extract the evidences associated to a particular gene using the function  **gene2evidence**. Additionally, you can explore the evidences for a specific gene-disease pair by specifying the disease identifier using the argument  `disease`.

```{r, warning = T, echo=T, message = FALSE}
data1 <- gene2evidence( gene = "LEPR",
                        vocabulary = "HGNC",
               disease ="C3554225",
                       database = "ALL",
                       score =c(0.3,1))
data1
results <- extract(data1)

```

The results are shown in the table below. 
```{r, warning = T, echo=F, message = FALSE}

kable(results[, c("pmid", "year", "sentence")], caption = "Evidences supporting the association between LEPR & C3554225") %>%   kable_styling(bootstrap_options = "striped", full_width = F)

```

 
## Searching multiple genes

\noindent The **gene2disease** function can also receive a list of genes as input, either as NCBI Gene Identifiers or Gene Symbols. In the example, we show how to create a vector with the Gene Symbols of several genes belonging to the family of voltage-gated potassium channels (Table 2) and then, we apply the function **gene2disease**.

Table 2: Example of voltage-gated potassium channel family members

```{r echo=FALSE,  message=FALSE,}
table1 <- data.frame(
  Name = c("KCNE1", "KCNE2", "KCNH1",  "KCNH2", "KCNG1"), 
  Description =c(
    "potassium channel, voltage gated subfamily E regulatory beta subunit 1", 
    "potassium channel, voltage gated subfamily E regulatory beta subunit 2",
    "potassium channel, voltage gated eag related subfamily H, member 1", 
    "potassium channel, voltage gated eag related subfamily H, member 2", 
    "potassium voltage-gated channel modifier subfamily G member 1"     )) 
kable(table1) %>%   kable_styling(bootstrap_options = "striped", full_width = F)
                               

```

\noindent Creating the vector with the list of genes belonging to the voltage-gated potassium channel family. 

```{r, warning = T, echo=T, message = FALSE}
myListOfGenes <- c( "KCNE1", "KCNE2", "KCNH1", "KCNH2", "KCNG1")
```


\noindent The **gene2disease** function also requires the user to specify the source database using the argument `database`, and optionally, the DisGeNET `score` can also be applied to filter the results.

```{r, warning = T, echo=T, message = FALSE}
data2 <- gene2disease(
  gene     = myListOfGenes,
  score =c(0.2, 1),
  verbose  = TRUE
)

data2
```

### Visualizing  the diseases associated to multiple genes

\noindent By default, plotting a `DataGeNET.DGN` resulting of the query with a list of genes produces a `Gene-Disease Network` where the blue nodes are diseases, the pink nodes are genes, and the width of the edges is proportional to the score of the association (Figure 3).


```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 3: The **Gene-Disease Network** for a list of genes belonging to the voltage-gated potassium channel family"}
plot( data2,
      class = "Network",
      prop = 10)
```


\noindent Setting the argument `class` to "Heatmap" produces a `Gene-Disease Heatmap` (Figure 4), where the scale of colors is proportional to the score of the GDA. The argument `limit` can be used to limit the number of rows to the top scoring GDAs. The argument `nchars` can be used to limit the length of the name of the disease. By default, the plot shows the 50 highest scoring GDAs.

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 4: The **Gene-Disease Heatmap** for a list of genes belonging to the voltage-gated potassium channel family"}
plot( data2,
      class  ="Heatmap",
      limit  = 100, nchars = 50 )
```


\noindent These results can also be visualized as a `Gene-Disease Class Heatmap` by setting the argument `class` to "DiseaseClass" (Figure 5). In this case, diseases are grouped by the their MeSH disease classes, and the color scale is proportional to the percentage of diseases in each MeSH disease class. In the example, genes are associated mainly to *Cardiovascular Diseases*, and to *Congenital, Hereditary, and Neonatal Diseases and Abnormalities*.

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 5: The **Gene-Disease Class Heatmap** for a list of genes belonging to the voltage-gated potassium channel family"}
plot( data2,
      class="DiseaseClass", nchars=60)
```

## Retrieving the identifier for a disease of interest
To retrieve the concept unique identifier for the disease of interest, you can use  the **get_umls_from_vocabulary** function with the parameter vocabulary set to "NAME". This will retrieve all diseases in DisGeNET that contain the keyword used as an input. 

```{r, warning = T, echo=T, message = FALSE, eval=T}
diseases <- get_umls_from_vocabulary( "Schizophrenia", vocabulary = "NAME" )
kable(diseases, caption = "CUIs associated to Schizophrenia") %>%   kable_styling(bootstrap_options = "striped", full_width = F)


```


## Searching by disease

\noindent The **disease2gene** function allows to retrieve the genes associated to a disease, or a list of diseases. The function uses as input the disease, or list of diseases of interest (as UMLS CUI, MeSH, OMIM, Disease Ontology, ICD9CM, NCIt, EFO, or Orphanet Identifiers), the disease vocabulary employed (`OMIM` (OMIM), `MESH` (MeSH),`ICD9CM` (ICD9-CM), `DO` (Disease Ontology), `NCI` (NCI thesaurus), `ORDO` (Orphanet), or `EFO` (EFO)  and the database (by default, `CURATED`). A threshold value for the score can be set, like in the **gene2disease** function.

\noindent In the example, we will use the **disease2gene** function to retrieve the genes associated to the UMLS CUI *C0036341*. This function also receives as input the database, in the example, *CURATED*, and a score range, in the example, from 0.4 to 1. 

```{r, warning = T, echo=T, message = FALSE, eval=T}
data3 <- disease2gene( disease  = "C0036341",
                          database = "CURATED",
                          score    = c( 0.4,1 ) )
data3
```

\noindent  The same results are obtained when querying DisGeNET with the MeSH identifier for Schizophrenia (*D012559*). 

```{r, warning = T, echo=F, message = FALSE, eval=T}
data4 <- disease2gene( disease  = "D012559", vocabulary = "MESH",
                          database = "CURATED",
                          score    = c(0.4,1 ) )
data4
```

\noindent  The same results are obtained when querying DisGeNET with the OMIM identifier for Schizophrenia (*181500*). 

```{r, warning = T, echo=T, message = FALSE, eval=T}
data4 <- disease2gene( disease  = "181500", vocabulary = "OMIM",
                          database = "CURATED",
                          score    = c(0.4,1 ) )
data4
	
```

\noindent  The same results are obtained when querying DisGeNET with the ICD9-CM identifier for Schizophrenia (*295*). 

```{r, warning = T, echo=T, message = FALSE, eval=T}
data4 <- disease2gene( disease  = "295", vocabulary = "ICD9CM",
                          database = "CURATED",
                          score    = c(0.4,1 ) )
data4
	
```

\noindent  The same results are obtained when querying DisGeNET with the NCI identifier for Schizophrenia (*C3362*). 

```{r, warning = T, echo=T, message = FALSE, eval=T}
data4 <- disease2gene( disease  = "C3362", vocabulary = "NCI",
                          database = "CURATED",
                          score    = c(0.4,1 ) )
data4
	
```

\noindent  The same results are obtained when querying DisGeNET with the DO identifier for Schizophrenia (*5419*). 

```{r, warning = T, echo=T, message = FALSE, eval=T}
data4 <- disease2gene( disease  = "HP:0100753", vocabulary = "HPO",
                          database = "CURATED",
                          score    = c(0.4,1 ) )
data4

```

### Visualizing the genes associated to a single disease

\noindent There are two options to visualize the results from searching a single disease: a `Gene-Disease Network` showing the genes related to the disease of interest (Figure 6), and a `Disease-Protein Class Network` with the genes grouped by Panther Protein Class (Figure 7). 

\noindent Figure 6 shows the default `Gene-Disease Network` for Schizophrenia. As in the case of the **gene2disease** function, the blue nodes is the disease, the pink nodes are genes, and the width of the edges is proportional to the score of the association.

```{r, fig.align="center",echo=T, fig.width=6, fig.height=6, fig.cap="Figure 6: The **Gene-Disease Network** for genes associated to Schizophrenia"}

plot ( data3,
       prop = 10)
``` 


\noindent Alternatively, in the `Disease-Protein Class Network`, genes are grouped by the Panther Protein Class (Figure 7). This is a better choice when there is a large number of genes associated to the disease. This plot uses as `class` argument "ProteinClass". The resulting network  will show in blue the disease, and in green the Protein Classes of the genes associated to the disease. The node size is proportional to the number of genes in the Panther Protein Class. In the example, the largest proportion of the genes associated to Schizophrenia are receptors. Notice again that not all genes have annotations to Panther Protein classes (69 genes in Figure 7)

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 7: The **Protein Class-Disease Network** for genes associated to Schizophrenia", eval=T}
plot( data3,
      class="ProteinClass"
)
```

### Exploring the evidences associated to a disease

To explore the evidences supporting the associations for Schizophrenia using the function  **disease2evidence**.


```{r, warning = T, echo=T, message = FALSE, eval=T}
data3 <- disease2evidence( disease  = "C0036341",
                           type = "GDA",
                          database = "CURATED",
                          score    = c( 0.4,1 ) )
data3

```

 Additionally, you can explore the evidences for a specific gene-disease pair by specifying the gene identifier using the argument  `gene`.

```{r, warning = T, echo=T, message = FALSE, eval=T}
data3 <- disease2evidence( disease  = "C0036341",
                           gene = c("DRD2", "DRD3"),
                           type = "GDA",
                          database = "CURATED",
                          score    = c( 0.4,1 ) )
data3
results <- extract(data3)

```

The results are shown in the table below.  

```{r, warning = T, echo=F, message = FALSE}

kable(results[, c("pmid", "year", "sentence")], caption = "Evidences supporting the association between C0036341 & DRD2,DRD3") %>%   kable_styling(bootstrap_options = "striped", full_width = F)

```


## Searching multiple diseases

\noindent The **disease2gene** function also accepts as input a list of diseases  (as UMLS CUI, MeSH, OMIM, Disease Ontology, Orphanet, Dechipher, or ICD9CM Identifiers), the database (by default, *CURATED*), and optionally, a value range for the score. In the example, we have selected a list of 10 diseases. Table 3 shows the UMLS CUIs and the corresponding disease names. 

Table 3: Disease list selected for illustrating the **disease2gene** multiple search 

```{r echo=FALSE,  message=FALSE,}
table1 <- data.frame(
  UMLS_CUI = c("C0036341", "C0036341", "C0030567", "C0005586"), 
  Disease_Name =c("Schizophrenia", 
               "Alzheimer's Disease",
               "Parkinson Disease", 
               "Bipolar Disorder")) 
 
kable(table1) %>%   kable_styling(bootstrap_options = "striped", full_width = F)
                               

```


\noindent Creating the vector with the list of diseases.   

```{r, warning = T, echo=T, message = FALSE, eval=T}
diseasesOfInterest <- c("C0036341", "C0002395", "C0030567","C0005586")
```

\noindent In the example, we will search in *CURATED* data, using a score range of 0.4-1.

```{r, warning = T, echo=T, message = FALSE, eval=T}
data5 <- disease2gene(
  disease = diseasesOfInterest,
  database = "CURATED",
  score =c(0.4,1),
  verbose  = TRUE )
```


### Visualizing the genes associated to multiple diseases

\noindent The default plot of the results of querying DisGeNET with a list of diseases produces a `Gene-Disease Network` where the blue nodes are diseases, the pink nodes are genes, and the width of the edges is proportional to the score of the association (Figure 8).

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 8: **The Gene-Disease Network** for genes associated to a list of diseases", eval=T}
plot( data5,
      class = "Network",
      prop = 10)
```

 

\noindent To visualize the results as a `Gene-Disease Heatmap` (Figure 9) change the argument `class` to "Heatmap". In this plot, the scale of colors is proportional to the score of the GDA. The argument `limit` can be used to limit the number of rows to the top scoring GDAs when the results are large. By default, the plot shows the 50 highest scoring GDAs.


```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 9: The **Gene-Disease Heatmap** for genes associated to a list of diseases", eval=T}
plot( data5,
      class="Heatmap",
      limit =30,
      cutoff=0.2)
```


\noindent A third visualization option is a `Protein Class-Disease Heatmap` (Figure 10), in which genes are grouped by protein class. This plot is obtained by setting the `class` argument to "ProteinClass". In this case, the color of the heatmap is proportional to the percentage of genes for each disease in each protein class. This heatmap displays the protein classes associated to each disease. 

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 10: The **Protein Class-Disease** Heatmap for genes associated to a list of diseases", eval=T}
plot( data5,
      class="ProteinClass" )
```


# Retrieving Variant-Disease Associations from DisGeNET

## Searching by variant

\noindent The **variant2disease** function receives a variant, or a list of variants as input, identified by the dbSNP identifier. It produces an object `DataGeNET.DGN`, with `Type = "variant-disease"`.

```{r, warning = T, echo=T, message = FALSE, eval=T}
data6 <- variant2disease( variant= "rs121913279",
                         database = "CURATED")
data6
```

### Visualizing the diseases associated to a single variant

\noindent The **disgenet2r** package offers several options to visualize the results of querying DisGeNET for a single variant: a `Variant-Disease Network` showing the diseases associated to the variant of interest, a `Variant-Gene-Disease Network` showing the genes, diseases, and variant of interest, and a network showing the MeSH Disease Classes of the diseases associated to the variant (`Variant-Disease Class Network`). These graphics can be obtained by changing the `class` argument in the **plot** function.

\noindent By default, the **plot** function produces a `Variant-Disease Network` on a `DataGeNET.DGN` object (Figure 11). In the `Variant-Disease Network` the blue nodes are diseases, the yellow nodes are variants, the blue nodes are diseases, and the width of the edges is proportional to the score of the association. 

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 11: The **Variant-Disease Network** for the variant rs121913279", eval=T}
plot( data6, 
      class = "Network",
      prop  = 10)

```


\noindent The results can also be visualized in a network in which diseases are grouped by the MeSH Disease Class if the `class` argument is set to "DiseaseClass" (Figure 12). In the `Variant-Disease Class Network`, the node size of is proportional to the fraction of diseases in the disease class, with respect to the total number of diseases with disease class associated to the gene. In the example, the variant is associated mainly to Neoplasms.

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 12: The **Variant- Disease Class Network** for the variant rs121913279", eval=T}
plot( data6,
      class = "DiseaseClass",
      prop = 3)
```


### Exploring the evidences associated to a variant

You can extract the evidences associated to a particular variant using the function  **variant2evidence**. Additionally, you can explore the evidences for a specific variant-disease pair by specifying the argument  `disease`.

```{r, warning = T, echo=F, message = FALSE}
data6 <- variant2evidence( variant = "rs121913279",
                disease ="C0009402",
                       database = "ALL",
                       score =c(0,1))
data6
results <- extract(data6)

```


The results are shown in the table below.  

```{r, warning = T, echo=F, message = FALSE}

kable(results[, c("pmid", "year", "sentence")], caption = "Evidences supporting the association between C0009402 & rs121913279") %>%   kable_styling(bootstrap_options = "striped", full_width = F)

```



## Searching multiple variants

\noindent The **variant2disease** function retrieves the information in DisGeNET for a list of variants identified by the dbSNP identifier. The function also requires the user to specify the source database using the argument `database`. By default, **variant2disease** function uses as source database *CURATED*.


```{r, warning = T, echo=T, message = FALSE, eval=T}
data7 <- variant2disease(
         variant = c("rs121913013", "rs1060500621",
              "rs199472709", "rs72552293",
              "rs74315445", "rs199472795"),
         database = "ALL")
```


### Visualizing the diseases associated to multiple variants

\noindent The results of querying DisGeNET with a list of variants can be visualized as a `Variant-Disease Network` (Figure 13), as a `Variant-Gene-Disease Network` (Figure 15) and as heatmap (`Variant-Disease Class Heatmap`, Figure 16). 
Below, the `Variant-Disease Network`. 

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 13: The **Variant-Disease Network** for a list of variants", eval=T}
plot( data7,
      class = "Network",
      prop = 10)
``` 


\noindent To obtain the `Variant-Gene-Disease Network`, Figure 14), change the `showGenes` argument to "TRUE".

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 14: The **Variant-Gene-Disease Network** for a list of variants", eval=T}
plot( data7,
      class = "Network",
      showGenes = T)
```

\noindent The results of querying DisGeNET variant information with a list of diseases can be visualized as a `Variant-Disease Heatmap` by changing the `class` argument to `Heatmap` (Figure 15).


```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 15: The **Variant-Disease Heatmap** for a list of variants", eval=T}
plot( data7,
      class = "Heatmap",
      prop = 10)
``` 

\noindent The results of querying DisGeNET variant information with a list of diseases can also be visualized as a `Variant-Disease Class Network`.

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 16: The **Variant-Disease Class Heatmap** for a list of variants", eval=T}
plot( data7,
      class = "DiseaseClass")

```


## Searching by disease


\noindent The **disease2variant** function allows to retrieve the variants associated to a disease, or a list of diseases. The function uses as input the disease, or list of diseases of interest (as UMLS CUI, MeSH, OMIM, Disease Ontology, ICD9CM, NCIt, EFO, or Orphanet Identifiers), the disease vocabulary employed (`OMIM` (OMIM), `MESH` (MeSH),`ICD9CM` (ICD9-CM), `DO` (Disease Ontology), `NCI` (NCI thesaurus), `ORDO` (Orphanet), or `EFO` (EFO)  and the database (by default, `CURATED`). A threshold value for the score can be set, like in the **gene2disease** function.


```{r, warning = T, echo=T, message = FALSE, eval=T}
data8 <- disease2variant(disease = c("C0752166"),
                       database = "CLINVAR", 
                       score = c(0, 1) )
data8
```


### Visualizing the variants associated to a single disease

\noindent The results of querying DisGeNET variant information with a list of diseases can be visualized as a `Variant-Disease Network` (Figure 17).

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 17: The **Variant-Disease Network** for a single disease", eval=T}
plot( data8,     
      class = "Network")
```

### Explore the evidences associated to a single disease

To explore the evidences supporting the VDAs for Schizophrenia, run the **disease2evidence** function. You can use the argument variant to inspect the evidences for a particular variant and Schizophrenia. You can also specify a year range for the publications

```{r, warning = T, echo=T, message = FALSE, eval=T}
data8 <- disease2evidence( disease  = "C0036341",
                               variant = "rs1344706",
                           type = "VDA",
                           year = c(2019, 2020),
                          database = "ALL",
                          score    = c( 0.1,1 ) )
data8
```


```{r, warning = T, echo=F, message = FALSE, eval=T}
results <- extract(data8)
results <- results[ order(-results$year),]
kable(results[, c("pmid", "year", "sentence")], caption = "Evidences supporting associations between C0036341 & rs1344706") %>%   kable_styling(bootstrap_options = "striped", full_width = F)
```

If you want to inspect the evidences for Schizophrenia, and all the variants in a particular gene, use the argument `gene`. 

```{r, warning = T, echo=T, message = FALSE, eval=T}
data8 <- disease2evidence( disease  = "C0036341",
                               gene = "CACNA1C",
                           type = "VDA",
                          database = "BEFREE",
                          score    = c( 0.1,1 ) )
data8
results <- extract(data8)
```


```{r, warning = T, echo=F, message = FALSE, eval=T}

results <- results[ order(-results$year),][1:5,]
kable(results[, c("pmid", "year", "sentence")], caption = "Selection of evidences supporting associations between C0036341 & CACNA1C") %>%   kable_styling(bootstrap_options = "striped", full_width = F)

```


## Searching multiple diseases 

```{r, warning = T, echo=T, message = FALSE, eval=T}
data8 <- disease2variant(
              disease = c("C3150943",  "C1859062", "C2678485", "C4015695"),
              database = "CURATED", 
              score = c(0.75, 1) )
data8
```

### Visualizing the variants associated to multiple diseases

\noindent The results of querying DisGeNET variant information with a list of diseases can be visualized as a `Variant-Disease Network`, or as a `Variant-Disease Heatmap`, Figure 18), by changing the `class` argument from "Network" to "Heatmap".

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 18: The **Variant-Disease Network** for a list of diseases", eval=T}
plot( data8,     
      class = "Network")
```

\noindent The `Variant-Disease Network` can be displayed as a `Variant-Disease-Gene Network`, by setting the `showGenes` parameter to `TRUE`. 


```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 19: The **Variant-Gene-Disease Network** for a list of diseases", eval=T}
plot( data8, 
      class = "Network",
      showGenes = T)
```

The results can be visualized as a Heatmap. 

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 20: The **Variant-Disease Heatmap** for a list of diseases", eval=T}
plot( data8,
      class = "Heatmap",
      prop = 10)

``` 


# Retrieving Disease-Disease Associations from DisGeNET

\noindent The **disgenet2r** package also allows to obtain a list of diseases that share genes or variants with a particular disease, or disease list (disease-disease associations, or DDAs). 

## Searching DDAs by genes for a single disease

\noindent To obtain disease-disease associations, use the **disease2disease_by_gene** function. This function uses as input a disease, in the same format that in **disease2gene**, the database to perform the search (by default, *CURATED*), and the argument `ndiseases`, the number of diseases that share genes with the disease(s) of interest. By default `ndiseases = 10`. The output is a `DataGeNET.DGN` object that contains the top 10 diseases that share genes with the disease that has been searched. 

```{r, warning = T, echo=T, message = FALSE, eval=T}
data9 <- disease2disease_by_gene(
  disease  = "C0010674",
  database = "CURATED", ndiseases = 5 )
data9

qr <- extract(data9)
head(qr[c("disease1_name", "disease2_name","jaccard_genes","ngenes", "pvalue")])
```

\noindent The `DataGeNET.DGN` object produced by the **disease2disease_by_gene** function also contains the Jaccard Index, also known as the Jaccard similarity coefficient for each disease pair. The Jaccard Coefficient is a similarity metric, computed as as the size of the intersection divided by the size of the union of two sample sets, in this case, the genes associates to each disease: 

\begin{equation*}
J(A, B) = \frac{\mid A \cap B \mid}{\mid A \cup B \mid}
\end{equation*}

\noindent The `pvalue` column estimates the significance of the Jaccard coefficient for a list of disease pairs. The estimation of the pvalue is estimated by randomizing 1000 times. 


### Visualizing the diseases associated to a single disease

\noindent The **plot** function applied to the `DataGeNET.DGN` object generated by the **disease2disease_by_gene** function results in a `Disease-Disease Network`, where the node in dark blue is the disease of interest and nodes in ligth blue are the diseases that share genes with it (Figure 21). The node size is proportional to the number of genes associated to each disease.

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 21: The **Disease-Disease Network** by shared genes for MELAS Syndrome", eval=T}
plot( data9, 
      class = "Network",
      layout="layout.lgl" ,
      prop = 0.4 )
```



\noindent To obtain the fully connected network, set the `class` argument of the **plot** function to `Diseasome`(Figure 22). In this network, the nodes are the diseases of interest, and the node size is proportional to the number of genes associated with them, and the edges size is proportional to the number of genes that are shared between the diseases they are connecting. The nodes in dark blue are the query diseases, and in light blue, the diseases that share genes with them. 

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 22: The **Diseasome plot** for MELAS Syndrome", eval=T}
plot( data9, 
      class = "Diseasome",
      layout="layout.lgl" ,
      prop = 5 )

```

\noindent A second option to visualize the results of **disease2disease_by_gene** is as a `Disease-Disease Barplot` (Figure 23), obtained by setting the `class` argument to `Barplot`. The `Disease-Disease Barplot` shows the top **n** diseases that share genes with the disease of interest. This barplot also provides the jaccard index for each disease pair.

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 23: **Disease-Disease Barplot** visualizing the top 5 diseases associated to MELAS Syndrome", eval=T}
plot( data9,
      class="Barplot")
```


## Searching DDAs via genes for multiple diseases

### Visualizing the diseases associated to multiple diseases 

\noindent The function **disease2disease_by_gene** can receive a list of diseases as input, in any of the previously described vocabularies. It will retrieve the top 10 diseases that share genes with each of the diseases in the input list. This results can be visualized as a `Disease-Disease Network`, a `Diseasome plot`, or as a `Barplot`. 

Table 4: Disease list selected for illustrating the **disease2disease_by_gene** function 

```{r echo=FALSE,  message=FALSE, eval=T}
table1 <- data.frame(
  UMLS_CUI = c("C0162671", "C0023264", "C0917796"), 
  Disease_Name =c("MELAS Syndrome", "Leigh Disease" , "Optic Atrophy, Hereditary, Leber")) 
 
kableExtra::kable(table1) %>%  kableExtra::kable_styling(bootstrap_options = "striped", full_width = F)
                               

```



```{r,  echo=T,  message=FALSE, eval=T}
diseasesOfInterest <-  c("C0013182", "C0013221", "C3658290", "C0860207", "C1274933")
data10 <- disease2disease_by_gene(
  disease = diseasesOfInterest,
  database = "CURATED", ndiseases =  5)

```

\noindent To obtain the network, set the `class` argument of the **plot** function to `Network`(Figure 24). In this network, the nodes are the diseases of interest, and the node size is proportional to the number of genes associated with them. On the other hand, the edges size is proportional to the number of genes that are shared between the diseases they are connecting.

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 24: The **Disease-Disease Network** by shared genes for a list of diseases", eval=T}
plot( data10,
      class = "Network",
      prop  = 0.1)
```



\noindent To obtain the fully connected network, set the `class` argument of the **plot** function to `Diseasome`(Figure 25). In this network, the nodes are the diseases of interest, and the node size is proportional to the number of genes associated with them. On the other hand, the edges size is proportional to the number of genes that are shared between the diseases they are connecting.

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 25: The **Diseasome plot** for a list of diseases", eval=T}
plot( data10,
      class = "Diseasome",
      prop  = 0.1)
```


\noindent To further inspect the relationship between a pair of diseases, create a Venn Diagram by setting the `class` argument of the **plot** function to `Venn` (Figure 26).

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 26: The **Venn Diagram** for 3 diseases", eval=T}
plot( data10,
      class="Venn")

```

The Venn diagram for 4 diseases


```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 27: The **Venn Diagram** for a list of 4 diseases", eval=T}
data11 <- disease2disease_by_gene(
  disease =  c("C0018801", "C0028754", "C0004153", "C0011849"),
  database = "CURATED",
  ndiseases = 5)
plot( data11,
      class="Venn"
)
```



The Venn diagram for 5 diseases


```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 28: The **Venn Diagram** for a list of 5 diseases", eval=T}
data11 <- disease2disease_by_gene(
  disease =  c("C0018801", "C0028754", "C0004153", "C0011849", "C0021368"),
  database = "CURATED",
  ndiseases = 5)
plot( data11,
      class="Venn"
)

```

## Searching DDAs via shared variants for a single disease

\noindent To obtain disease-disease associations, use the **disease2disease_by_variant** function. This function uses as input a disease, in the same format that in **disease2disease_by_gene**, the database to perform the search (by default, *CURATED*), and the argument `ndiseases`, the number of diseases that share genes with the disease(s) of interest. By default `ndiseases = 10`. The output is a `DataGeNET.DGN` object that contains the top 10 diseases that share genes with the disease that has been searched. 

```{r, warning = T, echo=T, message = T, eval=T}
data12 <- disease2disease_by_variant(
  disease  = "C0011860",
  database = "CURATED", ndiseases = 3 )
data12

```


```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 29: An example of **Disease-Disease Network**", eval=T}
plot( data12, layout="layout.lgl" ,
      prop = 0.2 )
```


```{r, warning = T, echo=T, message = FALSE, eval=T}
data13 <- disease2disease_by_variant(
  disease  = c("C0018801", "C0020538"),
  database = "CURATED", ndiseases = 5 )

data13


```


```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure 30: The **Diseasome plot** by shared variants for Muscular Dystrophy, Duchenne", eval=T}
plot( data13, layout="layout.lgl" ,
      class = "Diseasome",
      prop = 0.02)
```

# Performing a disease enrichment


\noindent The **disease_enrichment** function receives a list of genes and performs an enrichment analysis over the diseases in DisGeNET. The input list of genes should be identified with HGNC symbols, or Entrez Gene Identifiers. The vocabulary should be specified using the parameter `vocabulary`. By default, `vocabulary = "HGNC"`. The function has other optional argument: the source database (by default, `database = “CURATED”`). The background for the Fisher test are all the genes in DisGeNET. The p-values resulting from the multiple Fisher tests are corrected for false discovery rate using the Benjamini-Hochberg method.

To perform the enrichment, run:


```{r,  eval=T}
list_of_genes <- disease2gene(disease = "C0004352", database = "GENOMICS_ENGLAND")

list_of_genes <- list_of_genes@qresult$gene_symbol

res_enrich <-disease_enrichment( entities =list_of_genes, vocabulary = "HGNC",
                             database = "CURATED" )

table1 <- res_enrich@qresult[1:10, c("Description", "FDR", "Ratio",  "BgRatio")]
```
The column Ratio represents the number of genes from the input list that are associated to the disease. The BgRatio are the number of genes associated to the disease from the length of the universe, in the example, all genes in DisGeNET curated (9703). 


```{r, results='asis', warning= F, echo=FALSE, message=FALSE ,fig.width= 10, fig.height= 10, eval=T}
kableExtra::kable(table1, row.names = F) %>%  kableExtra::kable_styling(bootstrap_options = "striped", full_width = F)
```


To visualize the results of the enrichment, use the function **plot**. Use the argument `cutoff` to set a minimum p value threshold, and the argument `limit` to reduce the number of records shown. By default, `limit=50`.  Use the argument `nchars` to control the lenght of the disease name. 

```{r, fig.align="center", fig.width=6, fig.height=6, fig.cap="Figure : The **Enrichment plot** for a list of genes", eval=T}
plot( res_enrich, class = "Enrichment", count =3,  cutoff= 0.05, nchars=70)

```




```{r,  eval=T}

res_enrich <-disease_enrichment( entities =list_of_genes, vocabulary = "HGNC",
                             database = "ALL" )

table1 <- res_enrich@qresult[1:10, c("Description", "FDR", "Ratio",  "BgRatio")]
```


```{r, results='asis', warning= F, echo=FALSE, message=FALSE ,fig.width= 10, fig.height= 10, eval=T}
kableExtra::kable(table1, row.names = F) %>%  kableExtra::kable_styling(bootstrap_options = "striped", full_width = F)
```


\noindent A **disease_enrichment** for a list of variants can also be performed. The input list of variants should be identified with dbSNP identifiers and the vocabulary should be specified using the parameter vocabulary = `"DBSNP"`. The function has other optional argument: the source database (by default, `database = “CURATED”`). The background for the Fisher test are all the genes in DisGeNET. The p-values resulting from the multiple Fisher tests are corrected for false discovery rate using the Benjamini-Hochberg method.

To perform the enrichment, run:


```{r,  eval=T}
list_of_variants <- disease2variant(disease = "C0004352", database = "CLINVAR")

list_of_variants <- as.character(list_of_variants@qresult$variantid)

res_enrich <-disease_enrichment( entities =list_of_variants, vocabulary = "DBSNP",
                             database = "CURATED" )

table1 <- res_enrich@qresult[1:10, c("Description", "FDR", "Ratio",  "BgRatio")]

```

```{r, results='asis', warning= F, echo=FALSE, message=FALSE ,fig.width= 10, fig.height= 10, eval=T}
kableExtra::kable(table1, row.names = F) %>%  kableExtra::kable_styling(bootstrap_options = "striped", full_width = F)
```


To visualize the results of the enrichment, use the function **plot**. Use the argument `cutoff` to set a minimum p value threshold, and the argument `limit` to reduce the number of records shown. By default, `limit=50`.   

```{r, fig.align="center", fig.width=8, fig.height=8, fig.cap="Figure : The **Enrichment plot** for a list of genes", eval=T}
plot( res_enrich, class = "Enrichment", count =6,  cutoff= 0.05)

```


# Expanding DisGeNET data with other resources available in the LOD cloud 

Currently, Wikipathways-RDF has issues and these federated queries do not work! 

## Retrieving the pathways associated to a disease 

To obtain the pathways from WikiPathways associated to a disease, use the **disease2pathway** function.  

```{r,  eval=F}
library("SPARQL")
dis2path <- disease2pathway( disease = "C0018801" ,
                             database = "ALL", score = c(0.5, 1))
dis2path
# head(dis2path@qresult)
# qr <- extract(dis2path)
# head(qr, 3)

``` 

## Retrieving the diseases associated to a given pathway

To obtain the pathways from WikiPathways associated to a disease, use the **disease2pathway** function.  

```{r,  eval=F}
path2dis <- pathway2disease( pathway = "WP1591" ,
                             database = "CURATED",
                             score = c(0.9, 1))
path2dis
head(path2dis@qresult)
qr <- extract(path2dis)
head(qr, 3)

``` 



## Retrieve the drug targets for a disease 

The function **disease2compound** allows retrieved the chemicals in ChEMBL that target the genes associated to the given disease, or list of diseases. The function produces a DataGeNET.RDF object with the input disease(s), the associated genes, the DisGeNET score, and the chemicals associated to the disease proteins. If there were no chemicals found, the genes are still included in the output. It is important to higlight that because of ChEMBL restrictions for their SPARQL endpoint if 1000 compounds are retrieved for a single protein it probably means that there are more than 1000. (See more information about ChEMBL SPARQL endpoint at  https://www.ebi.ac.uk/rdf/what-are-limitations-sparql-endpoints).  


```{r,  eval=F}

dis2com <- disease2compound(
  disease = c("C0020538"),
  database = "CURATED" )
dis2com
qr <- extract(dis2com)
head(qr, 3)


```

## Retrieving Gene Ontology data for a gene 

```{r,  eval=F}
 
gene2bp <- gene2biologicalprocess(gene = "351")
head(gene2bp@qresult)
gene2cc <- gene2cellcomponent(gene = "351")
head(gene2cc@qresult)
gene2mf <- gene2molecularfunction(gene = "351")
head(gene2mf@qresult)
gene2indi <- gene2indication( gene = "1588" )
head(gene2indi@qresult)
```


## Retrieving Gene Ontology data for a disease 

The functions **disease2biologicalprocess**, **disease2molecularfunction**, and **disease2cellcomponent** can retrieve the Gene Ontology (GO) molecular function, GO biological process and GO cellular component of the genes associated to a disease or a list of diseases.  

### Retrieving the biological processes associated to a disease

For a disease, the biological process information can be retrieved in GO terms using the function **disease2biologicalprocess** that receives as input an NCBI gene identfier. The function produces a DataGeNET.RDF object containing the disease, the genes and their GOBP terms.  


```{r, eval=F}

disease2bp <- disease2biologicalprocess(
  disease = "C0036341",
  database = "CURATED",
  score = c( 0.6,1)
)
disease2bp
disease2bp <- extract(disease2bp)
head(disease2bp[c("gene_product_label","go_label")])

```

### Retrieving the molecular functions of the genes associated to a disease}

For a particular disease, the molecular activities of associated genes can be retrieved as GO terms using the function **disease2molecularfunction**. The function produces a DataGeNET.RDF object containing the disease, the genes and their GOMF terms.  


```{r,  eval=F}
disease2mf <- disease2molecularfunction(
  disease = "C0002395",
  database = "UNIPROT"
)

disease2mf
disease2mf <- extract(disease2mf)
head(disease2mf[c("gene_product_label", "go_label")])

```


### Retrieving the molecular functions of the genes associated to a disease

For a given gene, the cell component information (i.e. where gene products are active) can be retrieved as GO terms using the function **gene2cellcomponent** that receives as input an NCBI gene identfier. The function produces a DataGeNET.RDF object containing the disease, the genes and their GO CC terms. 


```{r,  eval=F}
disease2cc <- disease2cellcomponent(  disease = "C0002395",
                                      database = "MGD")

disease2cc <- extract(disease2cc)
head(disease2cc[c("gene_product_label", "go_label")])


``` 

# Get DisGeNET data version

```{r}

get_disgenet_version()

```

# COPYRIGHT

Copyright (C) 2021, IBI group.

disgenet2r is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

disgenet2r is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.

# How to cite disgenet2r

Piñero, J., Ramírez-Anguita, J. M., Saüch-Pitarch, J., Ronzano, F., Centeno, E., Sanz, F., & Furlong, L. I. (2020). The DisGeNET knowledge platform for disease genomics: 2019 update. Nucleic Acids Research, 48(D1), D845-D855.


```{r, eval=F, echo=F}
# rmarkdown::render('/home/janet/Documents/disgenet2r/vignettes/disgenet2r.Rmd')

```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/disease2compound.R
\name{disease2compound}
\alias{disease2compound}
\title{Query for given disease(s) and generates an \code{DataGeNET.RDF}}
\usage{
disease2compound(
  disease = "C3542021",
  database = "CURATED",
  score = c(0, 1),
  verbose = FALSE,
  warnings = TRUE
)
}
\arguments{
\item{disease}{UMLS ID (CUI) for a disease}

\item{database}{Name of the database that will be queried. It can take the values:
\code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
\code{'UNIPROT'} to use Universal Protein Resource;
\code{'CLINGEN'} to use Clinical Genome Resource;
\code{'CGI'} to use Cancer Genome Interpreter;
\code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
\code{'PSYGENET'} to use PSYGENET;
\code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
\code{'CURATED'} to use expert curated, human databases;
\code{'HPO'} to use HPO;
\code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
\code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
\code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
\code{'RGD'}, to use Rat Genome Database;
\code{'MGD'}, to use the Mouse Genome Database;
\code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
\code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
\code{'GWASDB'} to use the GWAS Database GWASdb;
\code{'CLINVAR'} to use ClinVar, a public archive of relationships
among sequence variation and human phenotype;
\code{'BEFREE'} to use text mining data, generated using BeFree System;
\code{'ALL'} to use all these databases. Default \code{'CURATED'}.}

\item{score}{A vector with two elements: 1) initial value of score 2) final value of score}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to don't see
the warnings.}
}
\value{
An object of class \code{DataGeNET.RDF}
}
\description{
Given the UMLS CUI for a disease, it retrieves the information
related to the pharmacology in ChEMBL and creates an object of type \code{DataGeNET.RDF}.
}
\examples{
dis2com <- disease2compound( disease = "C3542021", database = "ALL" )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_disgenet_version.R
\name{get_disgenet_version}
\alias{get_disgenet_version}
\title{Retrieves DisGeNET data version}
\usage{
get_disgenet_version()
}
\description{
Retrieves DisGeNET data version
}
\examples{
dgn_version <- get_disgenet_version()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/disease2disease_by_variant.R
\name{disease2disease_by_variant}
\alias{disease2disease_by_variant}
\title{Retrieves disease-disease associations via shared genes and generates an \code{DataGeNET.DGN}}
\usage{
disease2disease_by_variant(
  disease,
  vocabulary = "UMLS",
  ndiseases = 10,
  database = "CURATED",
  pvalue = 1,
  api_key = NULL,
  verbose = FALSE,
  warnings = TRUE
)
}
\arguments{
\item{disease}{a CUI or a vector of CUIs
The diseases non existing in DisGeNET will
be removed from the output.}

\item{vocabulary}{The vocabulary of the disease identifier(s)
Select one of the available:  \code{UMLS} (UMLS), \code{OMIM} (OMIM), \code{MSH} (MeSH), \code{DO} (Disease Ontology),
\code{NCI} (NCI thesaurus), \code{ORDO} (Orphanet),
\code{ICD9CM} (ICD9-CM) or \code{EFO} (EFO). Default \code{'UMLS'}.}

\item{ndiseases}{The number of associated diseases to retrieve. By default 10. Set to XX to retrieve all diseases}

\item{database}{Name of the database that will be queried. It can take the values:
\code{'UNIPROT'} to use Universal Protein Resource;
\code{'CURATED'} to use expert curated, human databases;
\code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
\code{'GWASDB'} to use the GWAS Database GWASdb;
\code{'CLINVAR'} to use ClinVar, a public archive of relationships
among sequence variation and human phenotype;
\code{'BEFREE'} to use text mining data, generated using BeFree System;
\code{'ALL'} to use all these databases. Default \code{'CURATED'}.}

\item{pvalue}{p value of the bootstrap. See more info at www.disgenet.org. By default 1}

\item{verbose}{By default \code{FALSE}. Set to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Set to \code{FALSE} to hide the warnings.}
}
\value{
An object of class \code{DataGeNET.Dis}
}
\description{
Given the CUI of one or multiple diseases, retrieves the associated diseases
from DisGeNET and creates an object of type \code{DataGeNET.Dis}.
}
\examples{
dd1 <- disease2disease_by_variant( "C0028754", database = "CURATED" , pvalue = 0.05)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_similar_diseases.R
\name{get_similar_diseases}
\alias{get_similar_diseases}
\title{Retrieves diseases similar to an input disease and generates an \code{DataGeNET.DGN}}
\usage{
get_similar_diseases(disease, api_key = NULL, limit = 5)
}
\arguments{
\item{disease}{A disease or a list of disease identifiers (CUIs, MeSH, OMIMs...)
specific genes from DisGeNET. The genes non contained in DisGeNET will
be removed from the output.}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to not see
the warnings.}
}
\value{
An object of class \code{DataGeNET.Dis}
}
\description{
Given the disease identifier for one or multiple diseases retrieves their asssociated genes
from DisGeNET and creates an object of type \code{DataGeNET.DGN}.
}
\examples{
dis_res <- get_similar_diseases( "C0028754" )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene2cellcomponent.R
\name{gene2cellcomponent}
\alias{gene2cellcomponent}
\title{Query for given gene(s) and generates an \code{DataGeNET.RDF}}
\usage{
gene2cellcomponent(gene, verbose = FALSE, warnings = TRUE)
}
\arguments{
\item{gene}{NCBI gene ID}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to don't see
the warnings.}
}
\value{
An object of class \code{DataGeNET.RDF}
}
\description{
Given a NCBI gene identifier, retrieves the GO (Gene Ontology) information
related to the cellular location of the gene product and creates an object
of type \code{DataGeNET.RDF}.
}
\examples{
gene2cc <- gene2cellcomponent( gene = 1588 )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_disgenet_api_key.R
\name{get_disgenet_api_key}
\alias{get_disgenet_api_key}
\title{Retrieves the DisGeNET API key for a user}
\usage{
get_disgenet_api_key(email, password, verbose = FALSE, warnings = TRUE)
}
\arguments{
\item{email}{the email of the user}

\item{password}{the password of the user to connect to DisGeNET}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to don't see
the warnings.}
}
\value{
A string
}
\description{
Given the email and password, retrieves the users API Key
}
\examples{
disgenet_api_key <- get_disgenet_api_key( email = "user@gmail.com", password = "myspwd" )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DataGeNET_DGN-extract.R,
%   R/DataGeNET_RDF-extract.R
\name{extract}
\alias{extract}
\alias{DataGeNET.DGN-methods}
\alias{DataGeNET.Dis-methods}
\title{Obtain the raw query from DisGeNET from a \code{DataGeNET.DGN} object.}
\usage{
\S4method{extract}{DataGeNET.DGN}(object)

\S4method{extract}{DataGeNET.RDF}(object)
}
\arguments{
\item{object}{Object of class \code{DataGeNET.RDF}}
}
\value{
A \code{data.frame} containing the raw result from DisGeNET

A \code{data.frame} containing the raw result from DisGeNET
}
\description{
Obtain the raw query from DisGeNET from a \code{DataGeNET.DGN} object.

Obtain the raw query from DisGeNET from a \code{DataGeNET.RDF} object.
}
\examples{
\dontrun{
#Being x an DataGeNET.DGN
qr <- extract(x) # Get number of unique diseases
}
\dontrun{
#Being x an DataGeNET.RDF
qr <- extract(x) 
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DataGeNET_DGN-ngene.R
\name{ngene}
\alias{ngene}
\alias{DataGeNET.DGN-methods}
\title{Obtain the number of unique genes in a \code{DataGeNET.DGN}.}
\usage{
\S4method{ngene}{DataGeNET.DGN}(object)
}
\arguments{
\item{object}{Object of class \code{DataGeNET.DGN}}
}
\value{
The number of unique genes
}
\description{
Obtain the number of unique genes in a \code{DataGeNET.DGN}.
}
\examples{
\dontrun{
#Being x an DataGeNET.DGN
nd <- ngene(x) # Get number of unique genes
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_umls.R
\name{get_umls_from_vocabulary}
\alias{get_umls_from_vocabulary}
\title{Retrieves mappings from different vocabularies associated to a disease, or list of diseases and generates an \code{DataGeNET.DGN}}
\usage{
get_umls_from_vocabulary(
  disease,
  vocabulary,
  api_key = NULL,
  allowed_vocabularies = c("UMLS", "OMIM", "NCI", "MESH", "ICD9CM", "ICD10", "EFO", "DO",
    "HPO", "ORDO", "NAME")
)
}
\arguments{
\item{disease}{A disease or a list of disease identifiers (CUIs, MeSH, OMIMs...)}

\item{vocabulary}{The vocabulary of the disease identifier(s)
Select one of the available:  \code{UMLS} (UMLS), \code{OMIM} (OMIM),
\code{MESH} (MeSH), \code{DO} (Disease Ontology),
\code{NCI} (NCI thesaurus), \code{ORDO} (Orphanet),
\code{ICD9CM} (ICD9-CM) or \code{EFO} (EFO). Default \code{'UMLS'}.}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to don't see
the warnings.}
}
\value{
An object of class \code{DataGeNET.DGN}
}
\description{
Given the disease identifier for one or multiple diseases retrieves the mappings to other vocabularies
from DisGeNET and creates an object of type \code{DataGeNET.DGN}.
}
\examples{
dis_res <- get_umls_from_vocabulary( "	D000130", vocabulary = "MESH"  )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/variant2disease.R
\name{variant2disease}
\alias{variant2disease}
\title{Retrieves diseases associated to a variant or list of variants and generates an \code{DataGeNET.DGN}}
\usage{
variant2disease(
  variant,
  database = "CURATED",
  score = c(0, 1),
  api_key = NULL,
  verbose = FALSE,
  warnings = TRUE
)
}
\arguments{
\item{variant}{a variant, or list of variants}

\item{database}{Name of the database that will be queried. It can take the values:
\code{'UNIPROT'} to use Universal Protein Resource;
\code{'CLINVAR'} to use ClinVar, a public archive of relationships
among sequence variation and human phenotype;
\code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
\code{'GWASDB'} to use the GWAS Database GWASdb;
\code{'CURATED'} to use expert curated, human databases;
\code{'ALL'} to use all these databases. Default \code{'CURATED'}.
\code{'BEFREE'} to use text mining data, generated using BeFree System;}

\item{score}{A vector with two elements: 1) initial value of score 2) final value of score}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to not see
the warnings.}
}
\value{
An object of class \code{DataGeNET.DGN}
}
\description{
Given a variant or a list of variants, it retrieves the variant-disease associations
related to diseases in DisGeNET. It creates an object of type \code{DataGeNET.DGN}.
}
\examples{
vd <- variant2disease(variant = "rs121909211", database = "CURATED",  verbose = FALSE, warnings = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DataGeNET-plot.R, R/DisGeNET-plot.R
\name{plot}
\alias{plot}
\alias{DataGeNET.DGN-methods}
\title{Plots the content of a \code{DataGeNET.DGN} object.
This functions allows to create a variety of plots for \code{DataGeNET.DGN} objects.}
\usage{
\S4method{plot}{DataGeNET.DGN}(x, y, ...)

\S4method{plot}{DataGeNET.DGN}(x, y, ...)
}
\arguments{
\item{x}{Object of class \code{DataGeNET.DGN}}

\item{y}{NOT USED}

\item{...}{Passed to inner functions for different plots.}

\item{layout}{Function to design the location of the different nodes. By
default \code{layout.fruchterman.reingold} from \code{igraph} is used.}

\item{class}{Type of the drawn chart. By default it is \code{"network"} but
it also can be \code{"Piechart"}, \code{"DiseaseClass"}, \code{"Venn"}
\code{"Heatmap"}, \code{"ProteinClass"}, \code{"Barplot"}, or \code{"Lollipop"}.}

\item{verbose}{By default \code{FALSE}. If set to \code{TRUE} information
on the drawing process will be shown.}
}
\value{
A plot for \code{DataGeNET.DGN}.

A plot for \code{DataGeNET.DGN}.
}
\description{
Plots the content of a \code{DataGeNET.DGN} object.
This functions allows to create a variety of plots for \code{DataGeNET.DGN} objects.

Plots the content of a \code{DataGeNET.DGN} object.
This functions allows to create a variety of plots for \code{DataGeNET.DGN} objects.
}
\examples{
\dontrun{
#Being x an DataGeNET.DGN
qr <- plot(x) # Get number of unique diseases
}
\dontrun{
Being x an DataGeNET.DGN
qr <- plot(x) # Get number of unique diseases
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{DataGeNET.RDF-class}
\alias{DataGeNET.RDF-class}
\title{Class DataGeNET.RDF}
\description{
Class \code{DataGeNET.RDF} is the basic object generated when RDF is needed.
It can be passed to other disgenet2r package functions.
}
\section{Slots}{

\describe{
\item{\code{input}}{Character containing \code{'ontology'}, \code{'phenotype'} or
\code{'disease'}. used as input to the query.}

\item{\code{search}}{Character containing \code{'ontology'},  \code{'phenotype'} or
\code{'disease'} it is looking for.It is used to perform the correct query}

\item{\code{database}}{Character containing the name of the database that will be
queried. It can take the values
\code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
\code{'UNIPROT'} to use Universal Protein Resource;
\code{'CLINGEN'} to use Clinical Genome Resource;
\code{'CGI'} to use Cancer Genome Interpreter;
\code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
\code{'PSYGENET'} to use PSYGENET;
\code{'GENOMICS_ENGLAND'} to use GENOMICS England;
\code{'CURATED'} to use expert curated, human databases;
\code{'HPO'} to use HPO;
\code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
\code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
\code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
\code{'RGD'}, to use Rat Genome Database;
\code{'MGD'}, to use the Mouse Genome Database;
\code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
\code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
\code{'GWASDB'} to use the GWAS Database GWASdb;
\code{'CLINVAR'} to use ClinVar, a public archive of relationships
among sequence variation and human phenotype;
\code{'BEFREE'} to use text mining data, generated using BeFree System;
\code{'ALL'} to use all these databases. Default \code{'CURATED'}.}

\item{\code{scoreRange}}{the disGeNET score range to retrieved the GDAs/VDAs}

\item{\code{selection}}{Character containing the name of the ontoloyg selected}

\item{\code{mapping}}{Number with the mappings obtained.}

\item{\code{qresult}}{\code{data.frame} with the obtained result}
}}

\seealso{
ontology2disease, disease2ontology, phenotype2disease, disease2phenotype
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{DataGeNET.DGN-class}
\alias{DataGeNET.DGN-class}
\title{Class DataGeNET.DGN}
\description{
Class \code{DataGeNET.DGN} is one of the two objects used in \code{disgenet2r}
package. It is the main data container to using the different functions to
query DisGeNET database and generate their output.
}
\section{Slots}{

\describe{
\item{\code{type}}{type of query: \code{'gene-disease'} or  \code{'variant-disease'}
or \code{'disease-gene'},  or \code{'disease-variant'} or \code{'disease-disease'} or \code{'disease-enrichment'}.}

\item{\code{search}}{Character containing \code{'single'} of \code{'list'}.It is
used to perform the correct query to DisGeNET}

\item{\code{database}}{Character containing the name of the database that will be
queried. It can take the values
\code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
\code{'UNIPROT'} to use Universal Protein Resource;
\code{'CLINGEN'} to use Clinical Genome Resource;
\code{'CGI'} to use Cancer Genome Interpreter;
\code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
\code{'PSYGENET'} to use PSYGENET;
\code{'GENOMICS_ENGLAND'} to use GENOMICS England;
\code{'CURATED'} to use expert curated, human databases;
\code{'HPO'} to use HPO;
\code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
\code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
\code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
\code{'RGD'}, to use Rat Genome Database;
\code{'MGD'}, to use the Mouse Genome Database;
\code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
\code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
\code{'GWASDB'} to use the GWAS Database GWASdb;
\code{'CLINVAR'} to use ClinVar, a public archive of relationships
among sequence variation and human phenotype;
\code{'BEFREE'} to use text mining data, generated using BeFree System;
\code{'ALL'} to use all these databases. Default \code{'CURATED'}.}

\item{\code{scoreRange}}{the disGeNET score range to retrieved the GDAs or VDAs}

\item{\code{term}}{Character with the term(s) to search into the database(s).}

\item{\code{qresult}}{\code{data.frame} with the obtained result}
}}

\seealso{
disease2gene, gene2disease, DataGeNET.DGN-methods
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/disease2molecularfunction.R
\name{disease2molecularfunction}
\alias{disease2molecularfunction}
\title{Query for a disease or a list of diseases and generates an \code{DataGeNET.RDF}}
\usage{
disease2molecularfunction(
  disease,
  vocabulary = "umls",
  database = "CURATED",
  score = c(0, 1),
  verbose = FALSE,
  warnings = TRUE
)
}
\arguments{
\item{disease}{a CUI or a vector of CUIs}

\item{database}{Name of the database that will be queried.
It can take the values \code{'CTD_human'} to use Comparative
Toxicogenomics Database, human data; \code{'UNIPROT'} to use Universal
Protein Resource;\code{'CLINVAR'} to use ClinVar, a public archive of relationships
among sequence variation and human phenotype; \code{'GWASCAT'} to use
the NHGRI-EBI GWAS Catalog; \code{'ORPHANET'}, to use
Orphanet, the portal for rare diseases and orphan drugs;
\code{'CURATED'} to use expert curated, human databases;
\code{'RGD'}, to use Rat Genome Database; \code{'MGD'}, to use the Mouse Genome Database;
\code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
\code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
\code{'PREDICTED'} to use the expert curated, animal models data;
\code{'ALL'} to use all these databases. Default \code{'CURATED'}.}

\item{score}{A vector with two elements: 1) character with greather
\code{'>'} or with lower \code{'<'} meaing greather or equal and lower or
equal; 2) the score to be compared. By default: \code{c('>', 0)}.}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to don't see
the warnings.}
}
\value{
An object of class \code{DataGeNET.RDF}
}
\description{
Given a disease or a list of diseases, retrieves the GO BP of the gene products
associated to the disease(s) and creates an object of type \code{DataGeNET.RDF}.
}
\examples{
disease2bp <- disease2molecularfunction( disease = "C1859062" )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gene2indication.R
\name{gene2indication}
\alias{gene2indication}
\title{Query for given gene(s) and generates an \code{DataGeNET.RDF}
Given the NCBI gene identifier, retrieves the information
related to drugs which interacts with the gene product and
their indications and creates an object of type \code{DataGeNET.RDF}.}
\usage{
gene2indication(gene, verbose = FALSE, warnings = TRUE)
}
\arguments{
\item{gene}{NCBI gene ID}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to don't see
the warnings.}
}
\value{
An object of class \code{DataGeNET.RDF}
}
\description{
Query for given gene(s) and generates an \code{DataGeNET.RDF}
Given the NCBI gene identifier, retrieves the information
related to drugs which interacts with the gene product and
their indications and creates an object of type \code{DataGeNET.RDF}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/disease2variant.R
\name{disease2variant}
\alias{disease2variant}
\title{Retrieves variants associated to a disease, or list of diseases and generates an \code{DataGeNET.DGN}}
\usage{
disease2variant(
  disease = "C0751955",
  vocabulary = "UMLS",
  database = "CURATED",
  score = c(0, 1),
  api_key = NULL,
  verbose = FALSE,
  warnings = TRUE
)
}
\arguments{
\item{disease}{A disease or a list of disease identifiers (CUIs, MeSH, OMIMs...)}

\item{vocabulary}{The vocabulary of the disease identifier(s)
Select one of the available: \code{OMIM} (OMIM), \code{MSH} (MeSH), \code{DO} (Disease Ontology),
\code{NCI} (NCI thesaurus), \code{ORDO} (Orphanet),
\code{ICD9CM} (ICD9-CM) or \code{EFO} (EFO). Default \code{'UMLS'}.}

\item{database}{Name of the database that will be queried. It can take the values:
\code{'UNIPROT'} to use Universal Protein Resource;
\code{'CLINVAR'} to use ClinVar, a public archive of relationships
among sequence variation and human phenotype;
\code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
\code{'GWASDB'} to use the GWAS Database GWASdb;
\code{'CURATED'} to use expert curated, human databases;
\code{'BEFREE'} to use text mining data, generated using BeFree System;
\code{'ALL'} to use all these databases. Default \code{'CURATED'}.}

\item{score}{A vector with two elements: 1) initial value of score 2) final value of score}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to hide the warnings.}
}
\value{
An object of class \code{DataGeNET.DGN}
}
\description{
Given the name of one or multiple diseases and retrieves the associated variant(s)
 and creates an object of type \code{DataGeNET.RDF}.
}
\examples{
dis2var <- disease2variant( disease = "C0751955",vocabulary = "UMLS", database = "ALL", score=c(0,1) )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/disgenet_enrichment.R
\name{disease_enrichment}
\alias{disease_enrichment}
\title{Performs an enrichment analysis on a list of genes/variants and generates an object \code{DataGeNET.DGN}}
\usage{
disease_enrichment(
  entities = entities,
  universe = "DISGENET",
  custom_universe = "",
  vocabulary = "HGNC",
  verbose = TRUE,
  database = "CURATED",
  warnings = TRUE
)
}
\arguments{
\item{entities}{Name or vector of genes (Entrez identifiers or HGNC symbols) or variants (DBSNP identifiers) to
for the enrichment}

\item{universe}{The universe to be used for the Fisher test.
The possible values are:
\code{DISGENET} - All genes in DisGeNET
\code{HUMAN} - All genes according to the NCBI
\code{HUMAN_CODING} - All protein coding genes to the NCBI
\code{CUSTOM} - A list of genes or variants submitted by the user
\code{custom_universe} a list of genes/variants as Entrez or symbols/dbSNP identifiers to be used
as universe when setting the universe="CUSTOM"}

\item{vocabulary}{The vocabulary for the genes (ENTREZ or HGNC) and for the variants (DBSNP)}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{database}{Name of the database that will be queried to retrieve the gene/variant disease annotations.
The possible values are:
\code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
\code{'UNIPROT'} to use Universal Protein Resource;
\code{'CLINGEN'} to use Clinical Genome Resource;
\code{'CGI'} to use Cancer Genome Interpreter;
\code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
\code{'PSYGENET'} to use PSYGENET;
\code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
\code{'CURATED'} to use expert curated, human databases;
\code{'HPO'} to use HPO;
\code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
\code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
\code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
\code{'RGD'}, to use Rat Genome Database;
\code{'MGD'}, to use the Mouse Genome Database;
\code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
\code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
\code{'GWASDB'} to use the GWAS Database GWASdb;
\code{'CLINVAR'} to use ClinVar, a public archive of relationships
among sequence variation and human phenotype;
\code{'BEFREE'} to use text mining data, generated using BeFree System;
\code{'ALL'} to use all these databases. Default \code{'CURATED'}.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to not see
the warnings.}
}
\value{
An object of class \code{DataGeNET.Dis}
}
\description{
Performs an enrichment analysis on a list of genes/variants and generates an object \code{DataGeNET.DGN}
}
\examples{
res <- disease_enrichment( entities =c("APP", "PSEN","APOE"), vocabulary = "HGNC", database = "CURATED", universe = "HUMAN_CODING")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pvalue_estimation.R
\name{pvalue_estimation}
\alias{pvalue_estimation}
\title{Estimates the p value of the Jaccard Coefficient for pairs of diseases}
\usage{
pvalue_estimation(
  input,
  database = "CURATED",
  api_key = NULL,
  nboot = 100,
  ncores = 1,
  verbose = FALSE
)
}
\arguments{
\item{database}{Name of the database that will be queried. It can take the values:
\code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
\code{'UNIPROT'} to use Universal Protein Resource;
\code{'CLINGEN'} to use Clinical Genome Resource;
\code{'CGI'} to use Cancer Genome Interpreter;
\code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
\code{'PSYGENET'} to use PSYGENET;
\code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
\code{'CURATED'} to use expert curated, human databases;
\code{'HPO'} to use HPO;
\code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
\code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
\code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
\code{'RGD'}, to use Rat Genome Database;
\code{'MGD'}, to use the Mouse Genome Database;
\code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
\code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
\code{'GWASDB'} to use the GWAS Database GWASdb;
\code{'CLINVAR'} to use ClinVar, a public archive of relationships
among sequence variation and human phenotype;
\code{'BEFREE'} to use text mining data, generated using BeFree System;
\code{'ALL'} to use all these databases. Default \code{'CURATED'}.}

\item{nboot}{Number of iterations sued to compute the pvalue associted
to the calculated Jaccard Index. Default: 1000.}

\item{ncores}{Number of cores used to calculate the pvalue associated to
the computed Jaccard Index. Default: 1.}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{object}{receives dataframe produced by function disgenetDisDis}
}
\description{
This function estimates the statistic significance of the Jaccard Coefficient with a bootstrap
}
\examples{
ji <- pvalue_estimation( object = dis, "CURATED" )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/disease2evidence.R
\name{disease2evidence}
\alias{disease2evidence}
\title{Retrieves evidences supporting the associations, for a disease, or a list of diseases,
and generates an \code{DataGeNET.DGN}}
\usage{
disease2evidence(
  disease = disease,
  type = "GDA",
  gene = NULL,
  variant = NULL,
  year = c(0, 2050),
  limit = 10,
  database = "CURATED",
  score = c(0, 1),
  api_key = NULL,
  verbose = FALSE,
  warnings = TRUE
)
}
\arguments{
\item{disease}{A disease or a list of diseases identified by the Concept Unique Identifiers}

\item{type}{one of two possible values: "GDA" or "VDA" depending if the user wants to retrieve gene-disease associations or
variant-disease associations.}

\item{gene}{a gene, or a list of genes identified by NCBI identifiers, or HGNC symbols.}

\item{variant}{a variant or a list of variants}

\item{year}{A vector with two elements: 1) initial value of year 2) final value of year}

\item{database}{Name of the database that will be queried. It can take the values:
\code{'CTD_human'} to use Comparative Toxicogenomics Database, human data;
\code{'UNIPROT'} to use Universal Protein Resource;
\code{'CLINGEN'} to use Clinical Genome Resource;
\code{'CGI'} to use Cancer Genome Interpreter;
\code{'ORPHANET'}, to use Orphanet, the portal for rare diseases and orphan drugs;
\code{'PSYGENET'} to use PSYGENET;
\code{'GENOMICS_ENGLAND'} to use Genomics England PanelApp;
\code{'CURATED'} to use expert curated, human databases;
\code{'HPO'} to use HPO;
\code{'INFERRED'} to use inferred data from HPO, GWASDB, GWASCAT, and CLINVAR;
\code{'CTD_rat'} to use Comparative Toxicogenomics Database, rat data;
\code{'CTD_mouse'} to use Comparative Toxicogenomics Database, mouse data;
\code{'RGD'}, to use Rat Genome Database;
\code{'MGD'}, to use the Mouse Genome Database;
\code{'ANIMAL_MODELS'} to use the expert curated, animal models data;
\code{'GWASCAT'} to use the NHGRI-EBI GWAS Catalog;
\code{'GWASDB'} to use the GWAS Database GWASdb;
\code{'CLINVAR'} to use ClinVar, a public archive of relationships
among sequence variation and human phenotype;
\code{'BEFREE'} to use text mining data, generated using BeFree System;
\code{'ALL'} to use all these databases. Default \code{'CURATED'}.}

\item{score}{A vector with two elements: 1) initial value of score 2) final value of score}

\item{verbose}{By default \code{FALSE}. Change it to \code{TRUE} to get a
on-time log from the function.}

\item{warnings}{By default \code{TRUE}. Change it to \code{FALSE} to not see
the warnings.}
}
\value{
An object of class \code{DataGeNET.Dis}
}
\description{
Retrieves evidences supporting the associations, for a disease, or a list of diseases,
and generates an \code{DataGeNET.DGN}
}
\examples{
g <- disease2evidence( disease="C0002395", "CURATED", score=c(0,1)  )
}
